export default {
  hil: 3,
  render: {
    view_template: '@eab-aip/ai-template-nav/ai-template-nav-menu'
  },
  runtime: {
    startup: ['[reference]{ /resource_permission_api }', '[reference]{ /index }'],
    tasks: {
      view: {
        $is: 'task',
        model: {
          title: 'Resources Menu'
        }
      },
      resource_permission_api: {
        $is: 'api',
        settings: {
          uri: '[constant]{ @sgd_api_base_uri }/api/v1/core/appconfig/'
        },
        after_modifiers: [
          {
            $is: 'task',
            model: '[value]{ /member_features }'
          },
          {
            $is: 'task',
            model: {
              inst_resource: '[value]{ /inst-resource_places }',
              ssccampus_campus_success_network: '[value]{ /ssccampus-campus_success_network }'
            }
          },
          {
            $is: 'task',
            model: {
              inst_resource: {
                $is: 'condition',
                settings: {
                  if: {
                    comparator: '==',
                    left: '[value]{/inst_resource}',
                    right: true
                  },
                  is_true: {
                    icon: 'place',
                    title: 'Places',
                    uri: '#/my/resources/places/'
                  },
                  is_false: null
                }
              },
              ssccampus_campus_success_network: {
                $is: 'condition',
                settings: {
                  if: {
                    comparator: '==',
                    left: '[value]{/ssccampus_campus_success_network}',
                    right: true
                  },
                  is_true: {
                    icon: 'people',
                    title: 'People',
                    uri: '#/my/resources/people/'
                  },
                  is_false: null
                }
              }
            }
          },
          '[f1]{/to/array}',
          '[f1]{/compact}'
        ],
        success: ['[assignment]{/index}']
      },
      index: {
        $is: 'task'
      }
    }
  }
};
