
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import ifn from '../../../pip/library/pi-ifn/pi-ifn.js';
export function BaseBehaviorBuilder(Base) {
  class BehaviorBuilder2 extends BehaviorBehavior(Base) {
    constructor() {
      super(...arguments);
      this.__forceBuilder = 0;
    }
    static get properties() {
      return {
        input: {
          type: Object
        },
        disallowHidden: {
          type: Boolean
        },
        __forceBuilder: {
          type: Number
        },
        mergeOver: {
          type: Object
        },
        mergeOnto: {
          type: Object
        }
      };
    }
    static get autoBinding() {
      return {
        signal: "output-changed",
        field: "input"
      };
    }
    static get observers() {
      return ["__inputWatcher(input, __forceBuilder)"];
    }
    connectedCallback() {
      super.connectedCallback();
      this.setAttribute("exclude", "exclude");
      this.setAttribute("hidden", "hidden");
      this._registerBehavior("BehaviorBuilder");
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      this.cleanup();
    }
    flush() {
    }
    refresh() {
      this.__forceBuilder += 1;
    }
    get builtEls() {
      return this.__builtEls || [];
    }
    __inputWatcher(input) {
      this.cleanup();
      input = input || {};
      if (f1.is.in("properties", input) && input.properties) {
        this.__applyTypePointCut(input.properties);
      }
      this._inputWatcher(input);
    }
    _disabledChanged(disabled) {
      super._disabledChanged(disabled);
      this.builtEls.forEach((el) => {
        el.disabled = disabled;
      });
    }
    _inputWatcher(input) {
    }
    __applyTypePointCut(input) {
      const mergeOnto = this.mergeOnto || {};
      const mergeOver = this.mergeOver || {};
      this.__iterateType(input, function(node) {
        return ifn.merge({}, mergeOnto, node, mergeOver);
      });
      return input;
    }
    __iterateType(parent, fn) {
      if (!parent) {
        return;
      }
      let node;
      for (const key in parent) {
        node = parent[key];
        if (f1.is.object(node)) {
          parent[key] = fn.call(this, node);
        }
        if (node.properties != null) {
          this.__iterateType(node.properties, fn);
        }
      }
    }
    cleanup() {
      this.builtEls.forEach((el) => {
        if (el.remove) {
          el.remove();
        } else if (this.parentElement) {
          this.parentElement.removeChild(el);
        }
      });
      this.__builtEls = [];
    }
    _insertElement(el, builderEl) {
      if (el) {
        if (builderEl) {
          builderEl.appendChild(el);
        } else if (this.insertAdjacentElement) {
          this.insertAdjacentElement("beforebegin", el);
        } else if (this.parentElement) {
          this.parentElement.appendChild(el);
        } else {
          return;
        }
        this.builtEls.push(el);
        el.ns = this.ns;
        if (this.disabled != null) {
          el.disabled = this.disabled;
        }
      }
    }
  }
  return HIP.factory.mixin(BehaviorBuilder2);
}
export const BehaviorBuilder = dedupingMixin(BaseBehaviorBuilder);
HIP["BehaviorBuilder"] = BehaviorBuilder;
