
import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import { animationFrame } from '../../../hip/library/polymer/polymer.js';
import { Debouncer } from '../../../hip/library/polymer/polymer.js';
import { AsHIC, BehaviorElement, HIP, BehaviorCustomizable } from '../../../eip/element/hi-hip/hi-hif.js';
export class BlockElement extends BehaviorCustomizable(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "ai-block";
  }
  static get template() {
    return html`
      <style>
        :host {
          display: flex;
        }
      </style>
      <slot></slot>
    `;
  }
  static get properties() {
    return {
      excluded: {
        type: Boolean,
        reflectToAttribute: true
      }
    };
  }
  static get autoBinding() {
    return {
      signal: "excluded-changed",
      field: "excluded"
    };
  }
  static get observers() {
    return ["__tripleWatcher(disabled, hidden, excluded)"];
  }
  __tripleWatcher(disabled, hidden, excluded) {
    this.__tripleDebouncer = Debouncer.debounce(this.__tripleDebouncer, animationFrame, () => {
      Array.from(this.children).forEach((el) => {
        if (disabled != null) {
          el.disabled = disabled;
        }
        if (hidden != null) {
          el.hidden = hidden;
        }
        if (excluded != null) {
          el.excluded = excluded;
        }
      });
    });
  }
}
HIP.factory.element(BlockElement);
