
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import { buildHeader } from './ai-visitor-container-fallback.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
const entity = "container";
HIP.visitor.add({
  entity,
  render_type: "accordion-group",
  buildField: (fieldEl, containerEl) => {
    containerEl.appendChild(fieldEl);
    return containerEl;
  },
  buildTag: (parentContainerEl, tagType) => {
    const containerEl = document.createElement("hi-accordion");
    dom.setAttrs(containerEl, {
      aesthetic: "invisible",
      name: tagType.name,
      class: "mtm"
    });
    buildHeader(parentContainerEl, tagType);
    parentContainerEl.appendChild(containerEl);
    return containerEl;
  }
});
HIP.visitor.add({
  entity,
  render_type: "accordion",
  buildField: (fieldEl, containerEl) => {
    containerEl.appendChild(fieldEl);
    return containerEl;
  },
  buildTag: (parentContainerEl, tagType) => {
    const noteEl = document.createElement("hi-note");
    const barEl = document.createElement("hi-bar");
    const titleEl = document.createElement("strong");
    titleEl.textContent = tagType.title || tagType.name;
    barEl.appendChild(titleEl);
    noteEl.setAttribute("allow-overflow", "true");
    parentContainerEl.appendChild(barEl);
    parentContainerEl.appendChild(noteEl);
    return noteEl;
  }
});
