
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
const entity = "container";
export const buildHeader = (parentContainerEl, tagType) => {
  if (!tagType.title) {
    return parentContainerEl;
  }
  const headerEl = document.createElement("header");
  headerEl.setAttribute("class", "mtex mbsx");
  const h3El = document.createElement("h3");
  h3El.innerHTML = tagType.title || tagType.name;
  headerEl.appendChild(h3El);
  if (tagType.description) {
    const pEl = document.createElement("p");
    pEl.innerHTML = tagType.description;
    pEl.setAttribute("class", "mtsx");
    headerEl.appendChild(pEl);
  }
  parentContainerEl.appendChild(headerEl);
  return parentContainerEl;
};
export const buildFieldAppendChild = (fieldEl, containerEl, fieldType, tagType) => {
  containerEl.appendChild(fieldEl);
  dom.setAttrs(fieldEl, {
    ...f1.read("/$configure/render_type/child", {}, tagType)
  });
  return containerEl;
};
const buildTagLayout = (direction) => (parentContainerEl, tagType) => {
  const containerEl = document.createElement("section");
  dom.setAttrs(containerEl, {
    name: tagType.name,
    "l-kind": direction,
    ...f1.read("/$configure/render_type/parent", {}, tagType)
  });
  parentContainerEl = buildHeader(parentContainerEl, tagType);
  parentContainerEl.appendChild(containerEl);
  return containerEl;
};
const buildTagLayoutVertical = buildTagLayout("vert");
HIP.visitor.add({
  entity,
  render_type: "vertical",
  buildField: buildFieldAppendChild,
  buildTag: buildTagLayoutVertical
});
const buildTagLayoutHorizontal = buildTagLayout("hort");
HIP.visitor.add({
  entity,
  render_type: "horizontal",
  buildField: buildFieldAppendChild,
  buildTag: (parentContainerEl, tagType) => {
    const containerEl = buildTagLayoutHorizontal(parentContainerEl, tagType);
    dom.setAttrs(containerEl, {
      "l-gutter": true
    });
    return containerEl;
  }
});
HIP.visitor.add({
  entity,
  render_type: "fallback",
  buildField: buildFieldAppendChild,
  buildTag: (parentContainerEl) => {
    return parentContainerEl;
  }
});
