
import { buildFormControls } from './ai-support-form-control.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
const entity = "form";
HIP.visitor.add({
  entity,
  render_type: "form-control",
  attributes: {
    is_form_container: true
  },
  build: (fieldType, builderEl) => {
    const { section, selectEl } = buildFormControls(fieldType, builderEl);
    selectEl.addEventListener("selected-ended", () => {
      if (selectEl.__mutex__formControl__) {
        selectEl.__mutex__formControl__ = false;
        return;
      }
      const formEl = builderEl.parentElement;
      if (formEl) {
        selectEl.__mutex__formControl__ = true;
        formEl.refresh();
      }
    });
    return section;
  }
});
