
import { __attachOptionsList } from './ai-support-input.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
const entity = "form";
HIP.visitor.add({
  entity,
  render_type: "ranklist",
  build: (fieldType, builderEl) => {
    const rankListEl = document.createElement("hi-rank-list");
    dom.setAttrs(rankListEl, {
      gid: `${builderEl.gid}__${fieldType.name}`,
      id: `${builderEl.gid}__${fieldType.name}`,
      name: fieldType.path,
      form: builderEl.form,
      ns: builderEl.ns,
      aesthetic: "list"
    });
    __attachOptionsList(rankListEl, fieldType, builderEl);
    return rankListEl;
  }
});
HIP.visitor.add({
  entity,
  render_type: "dual-picklist",
  build: (fieldType, builderEl) => {
    const pickListEl = document.createElement("hi-dual-picklist");
    dom.setAttrs(pickListEl, {
      gid: `${builderEl.gid}__${fieldType.name}`,
      id: `${builderEl.gid}__${fieldType.name}`,
      name: fieldType.path,
      form: builderEl.form,
      ns: builderEl.ns
    });
    if (fieldType.initial_value) {
      pickListEl.value = fieldType.initial_value;
    }
    __attachOptionsList(pickListEl, fieldType, builderEl);
    return pickListEl;
  }
});
