
import {
  __attachOptionsList,
  __createInputDescription,
  __createInputTitle,
  __createInputClear,
  __createInputHint
} from './ai-support-input.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
const entity = "form";
HIP.visitor.add({
  entity,
  render_type: "grid",
  attributes: {
    is_form_container: true
  },
  build: (fieldType, builderEl) => {
    const ns = builderEl.ns;
    const gridEl = document.createElement("hi-grid");
    const gridBuilderEl = document.createElement("ai-builder-grid");
    const hiddenInputEl = document.createElement("hi-textarea");
    dom.setAttrs(gridBuilderEl, {
      ns
    });
    dom.setAttrs(hiddenInputEl, {
      name: fieldType.name,
      form: builderEl.form,
      hidden: "hidden",
      parser: "json",
      ns
    });
    dom.setAttrs(gridEl, {
      ns
    });
    dom.ensureAttr(hiddenInputEl, "gid");
    dom.ensureAttr(gridEl, "gid");
    dom.setAttrs(gridEl, f1.merge("over", {}, fieldType.attributes || {}));
    gridEl.appendChild(gridBuilderEl);
    gridBuilderEl.input = fieldType;
    fieldType.ns = ns;
    const sourceIO = __attachOptionsList("request-source-bucket", fieldType, builderEl);
    gridEl.addEventListener("output-changed", (event) => {
      hiddenInputEl.value = Array.from(event.detail.value);
    });
    const sectionEl = document.createElement("section");
    const hintTemplate = __createInputHint(fieldType);
    const bucketToGridBindingEl = document.createElement("hi-binding");
    const descriptionEl = __createInputDescription(fieldType, sectionEl);
    const clearTemplate = __createInputClear(fieldType, builderEl);
    const labelEl = __createInputTitle(fieldType, hintTemplate, clearTemplate, builderEl);
    dom.setAttrs(bucketToGridBindingEl, {
      source: sourceIO.getAttribute("id"),
      sink: gridEl.getAttribute("gid"),
      ns
    });
    if (labelEl) {
      sectionEl.appendChild(labelEl);
    }
    if (descriptionEl) {
      sectionEl.appendChild(descriptionEl);
    }
    if (bucketToGridBindingEl) {
      sectionEl.appendChild(bucketToGridBindingEl);
    }
    sectionEl.appendChild(hiddenInputEl);
    sectionEl.appendChild(gridEl);
    hiddenInputEl.addEventListener("reset-ended", () => sourceIO.invoke([{}]));
    return sectionEl;
  }
});
