
import { __applyAttributes } from './ai-support-input.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
const entity = "form";
const BuildFormEditorElement = (fieldType) => {
  const el = document.createElement("hi-editor");
  if (fieldType.minimum_length != null) {
    el.setAttribute("minlength", fieldType.minimum_length);
  }
  if (fieldType.maximum_length != null) {
    el.setAttribute("maxlength", fieldType.maximum_length);
  }
  el.configuration = f1.read("/$configuration/render_type", el.configuration, fieldType);
  return el;
};
const BuildFormTextAreaElement = (fieldType) => {
  const el = document.createElement("hi-textarea");
  dom.setAttrs(el, {
    name: fieldType.name
  });
  if (fieldType.minimum_length != null) {
    el.setAttribute("minlength", fieldType.minimum_length);
  }
  if (fieldType.maximum_length != null) {
    el.setAttribute("maxlength", fieldType.maximum_length);
  }
  __applyAttributes(fieldType, el);
  return el;
};
HIP.visitor.add({
  entity,
  render_type: "editor",
  build: BuildFormEditorElement
});
HIP.visitor.add({
  entity,
  render_type: "html",
  build: BuildFormEditorElement
});
HIP.visitor.add({
  entity,
  render_type: "textarea",
  build: (fieldType) => {
    fieldType.format_type = fieldType.format_type || "json";
    return BuildFormTextAreaElement(fieldType);
  }
});
HIP.visitor.add({
  entity,
  render_type: "json",
  build: (fieldType) => {
    fieldType.format_type = "json";
    return BuildFormTextAreaElement(fieldType);
  }
});
