
import '../../../eip/element/hi-input/hi-input.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
const entity = "form";
HIP.visitor.add({
  entity,
  render_type: "range",
  build: (fieldType, builderEl) => {
    const inputRange = document.createElement("hi-input-group");
    const betweenText = document.createElement("hi-label");
    const prefixText = document.createElement("hi-label");
    const numberBuilder = HIP.visitor.queryField(
      {
        render_type: "number"
      },
      entity
    );
    const minInput = numberBuilder.build({
      name: fieldType.name + "__gte"
    });
    const maxInput = numberBuilder.build({
      name: fieldType.name + "__lte"
    });
    inputRange.setAttribute("name", fieldType.name);
    prefixText.textContent = "from";
    betweenText.textContent = "to";
    const minId = `${builderEl.gid}__${minInput.name}`;
    const maxId = `${builderEl.gid}__${maxInput.name}`;
    dom.setAttrs(minInput, {
      required: fieldType.required,
      gid: minId,
      ns: builderEl.ns,
      form: builderEl.form,
      class: "mlsxx mrsxx"
    });
    dom.setAttrs(maxInput, {
      required: fieldType.required,
      gid: maxId,
      ns: builderEl.ns,
      form: builderEl.form,
      class: "mlsxx"
    });
    inputRange.appendChild(prefixText);
    inputRange.appendChild(minInput);
    inputRange.appendChild(betweenText);
    inputRange.appendChild(maxInput);
    dom.ensureAttr(prefixText, "id");
    dom.ensureAttr(betweenText, "id");
    minInput.setAttribute("aria-labelledby", prefixText.getAttribute("id"));
    maxInput.setAttribute("aria-labelledby", betweenText.getAttribute("id"));
    inputRange.style.display = "flex";
    inputRange.style.alignItems = "center";
    return inputRange;
  }
});
