
import { createColumnEl } from './ai-visitor-grid-fallback.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
const entity = "grid";
HIP.visitor.add({
  entity,
  render_type: "tasks",
  build: (fieldType, id) => {
    const columnEl = createColumnEl(entity, fieldType, id);
    columnEl.innerHTML = `<template>
      <div id="_tasks_regions__singular_task__widget_group__${id}_[[ row_index ]]">
        <ai-builder-widget gid="_tasks_regions__singular_task__widget_group__${id}_[[ row_index ]]__builder"
          value="[[ object ]]"
          ns="${fieldType.ns}">
        </ai-builder-widget>
      </div>
      <hi-binding source="source"
        sink="_tasks_regions__singular_task__widget_group__${id}_[[ row_index ]]__builder"
        ns="${fieldType.ns}">
        <di-fn-get path="region.${fieldType.$region || "record_row"}.tasks.singular"></di-fn-get>
      </hi-binding>
    </template>`;
    return columnEl;
  }
});
HIP.visitor.add({
  entity,
  render_type: "tasks_menu",
  build: (fieldType, id) => {
    const columnEl = createColumnEl(entity, fieldType, id);
    columnEl.innerHTML = `<template>
      <hi-flyout>
        <hi-icon slot="anchor" kind="gear"></hi-icon>
        <div id="_tasks_flyout_regions__singular_task__widget_group__${id}_[[ row_index ]]"
          l-kind="vert">
          <ai-builder-widget gid="_tasks_flyout_regions__singular_task__widget_group__${id}_[[ row_index ]]__builder"
            value="[[ object ]]"
            ns="${fieldType.ns}">
          </ai-builder-widget>
        </div>
      </hi-flyout>
      <hi-binding source="source"
        sink="_tasks_flyout_regions__singular_task__widget_group__${id}_[[ row_index ]]__builder"
        ns="${fieldType.ns}">
        <di-fn-get path="region.${fieldType.$region || "record_row_menu"}.tasks.singular"></di-fn-get>
      </hi-binding>
    </template>`;
    return columnEl;
  }
});
