
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
const entity = "message";
HIP.visitor.add({
  entity,
  render_type: "alert",
  message_endpoint: "alert",
  messageSink: (messageEl) => messageEl.id,
  build(messageDeclaration) {
    const alertEl = document.createElement("hi-alert");
    dom.setAttrs(alertEl, {
      aesthetic: messageDeclaration.aesthetic,
      theme: messageDeclaration.theme,
      mode: messageDeclaration.mode,
      hidden: "hidden",
      class: "mbsxx",
      kind: "hide"
    });
    return alertEl;
  }
});
HIP.visitor.add({
  entity,
  render_type: "fallback",
  message_endpoint: "noop",
  messageSink: (messageEl) => messageEl.id,
  build() {
    const textEl = document.createElement("hi-text");
    dom.setAttrs(textEl, {
      class: "mbsxx"
    });
    return textEl;
  }
});
