
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import { BehaviorBuilder } from '../../../aip/element/ai-behavior-builder/ai-behavior-builder.js';
import ifn from '../../../pip/library/pi-ifn/pi-ifn.js';
import './ai-visitor-select-fallback.js';
export class BuilderSelectElement extends BehaviorBuilder(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "ai-builder-select";
  }
  static get properties() {
    return {
      fieldType: {
        type: Object,
        value: {}
      }
    };
  }
  _inputWatcher(sourceFieldType) {
    const parentFieldType = this.fieldType;
    const fields = sourceFieldType.properties == null ? sourceFieldType : ifn.getWithDefault({}, "properties", sourceFieldType);
    const visitorDefault = parentFieldType.render_type === "radio" ? "radio" : "select";
    const inputVisitor = HIP.visitor.queryField({ render_type: visitorDefault }, "select");
    if (!inputVisitor) {
      return;
    }
    for (const id in fields) {
      const field = HIP.visitor.setFieldTypeDefaults(fields[id]);
      const isAllowedToHideAndIsHidden = this.disallowHidden === false && field.hidden === true;
      if (isAllowedToHideAndIsHidden) {
        continue;
      }
      const optionsEl = inputVisitor.build(field, parentFieldType, id);
      optionsEl.forEach((optionEl) => {
        this._insertElement(optionEl);
      });
    }
  }
}
HIP.factory.element(BuilderSelectElement);
