
import { repeat } from '../../../hip/library/lit-html/directives/repeat.js';
import { html, nothing } from '../../../hip/library/lit-html/lit-html.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import { setAttributes } from '../../../eip/library/hi-lit/hi-lit.js';
import ifn from '../../../pip/library/pi-ifn/pi-ifn.js';
const render_type = "card-list-default";
const entity = "repeater";
HIP.visitor.add({
  entity,
  render_type,
  build: (properties) => (builderFn) => (list) => {
    const hasNoItemTemplate = !builderFn;
    const repeaterConfig = ifn.get("render_hints.$configure.repeater", properties);
    const attributes = repeaterConfig && repeaterConfig.attributes || {};
    if (hasNoItemTemplate) {
      return html`${nothing}`;
    }
    list = !ifn.is(Array, list) ? Object.values(list) : list;
    if (!ifn.is(Array, list)) {
      return html`${nothing}`;
    }
    return html`
      <ul kind="no-dot" x-yip="list" _noop=${setAttributes(attributes)}>
        ${repeat(list, (o, index) => html` <li>${builderFn(o, index)}</li> `)}
      </ul>
    `;
  }
});
