
import { repeat } from '../../../hip/library/lit-html/directives/repeat.js';
import { html, nothing } from '../../../hip/library/lit-html/lit-html.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import ifn from '../../../pip/library/pi-ifn/pi-ifn.js';
const render_type = "fallback";
const entity = "repeater";
HIP.visitor.add({
  entity,
  render_type,
  build: () => (itemFn) => (list) => {
    const hasNoItemTemplate = !itemFn;
    if (hasNoItemTemplate) {
      return html`${nothing}`;
    }
    list = ifn.is(Object, list) ? Object.values(list) : list;
    if (!ifn.is(Array, list)) {
      return html`${nothing}`;
    }
    return html`
      <ul kind="no-dot">
        ${repeat(list, (o, index) => html` <li>${itemFn(o, index)}</li> `)}
      </ul>
    `;
  }
});
