
import { html, nothing } from '../../../hip/library/lit-html/lit-html.js';
import { __definitionListTemplate, __widgetTemplate, __orderedTypeFields } from './ai-support-template.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
const entity = "template";
HIP.visitor.add({
  entity,
  render_type: "fallback",
  build: (hilFields) => {
    const typeFieldsKeys = __orderedTypeFields(hilFields);
    return (widgetBuilderFn) => (o, index) => {
      if (o == null) {
        return html`${nothing}`;
      }
      return html`<hi-tile class="mbm">
        <dl kind="data">${__definitionListTemplate(typeFieldsKeys, o)}</dl>
        ${__widgetTemplate(widgetBuilderFn, typeFieldsKeys, o)}
      </hi-tile>`;
    };
  }
});
HIP.visitor.add({
  entity,
  render_type: "definition-stacked",
  build: (hilFields) => {
    const typeFieldsKeys = __orderedTypeFields(hilFields);
    return (widgetBuilderFn) => (o, index) => {
      if (o == null) {
        return html`${nothing}`;
      }
      return html`<section class="mbl max-w-960">
        <dl kind="stacked">${__definitionListTemplate(typeFieldsKeys, o)}</dl>
        ${__widgetTemplate(widgetBuilderFn, typeFieldsKeys, o)}
      </section>`;
    };
  }
});
HIP.visitor.add({
  entity,
  render_type: "definition-inline",
  build: (hilFields) => {
    const typeFieldsKeys = __orderedTypeFields(hilFields);
    return (widgetBuilderFn) => (o, index) => {
      if (o == null) {
        return html`${nothing}`;
      }
      return html`<section class="mbl max-w-960">
        <dl kind="inline">${__definitionListTemplate(typeFieldsKeys, o)}</dl>
        ${__widgetTemplate(widgetBuilderFn, typeFieldsKeys, o)}
      </section>`;
    };
  }
});
