
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
const entity = "widget";
const includeIcon = (widgetDeclaration, widgetEl) => {
  const iconEl = document.createElement("hi-icon");
  dom.setAttrs(iconEl, {
    kind: widgetDeclaration.icon,
    class: "mrs"
  });
  widgetEl.appendChild(iconEl);
  return widgetEl;
};
const includeLabel = (widgetEl) => {
  const labelEl = widgetEl["aesthetic"] == "icon" ? document.createElement("hi-hint") : document.createElement("span");
  widgetEl.appendChild(labelEl);
  widgetEl["__labelEl__"] = labelEl;
  return widgetEl;
};
HIP.visitor.add({
  entity,
  render_type: "link",
  build: (widgetDeclaration) => {
    const linkEl = document.createElement("hi-link");
    linkEl.style.lineHeight = "1";
    linkEl.href = "#";
    if (widgetDeclaration.icon) {
      includeIcon(widgetDeclaration, linkEl);
    }
    return includeLabel(linkEl);
  }
});
HIP.visitor.add({
  entity,
  render_type: "download",
  build: (widgetDeclaration) => {
    const downloadLinkEl = document.createElement("hi-link");
    dom.setAttrs(downloadLinkEl, {
      style: "line-height: 1",
      external: "external",
      target: "_blank",
      download: true,
      href: "#"
    });
    if (widgetDeclaration.icon) {
      includeIcon(widgetDeclaration, downloadLinkEl);
    }
    return includeLabel(downloadLinkEl);
  }
});
HIP.visitor.add({
  entity,
  render_type: "button",
  build: (widgetDeclaration) => {
    const buttonEl = document.createElement("hi-button");
    buttonEl.aesthetic = widgetDeclaration.aesthetic || widgetDeclaration.kind || "secondary";
    if (widgetDeclaration.icon) {
      includeIcon(widgetDeclaration, buttonEl);
    }
    return includeLabel(buttonEl);
  }
});
HIP.visitor.add({
  entity,
  render_type: "fallback",
  build: () => {
    const buttonEl = document.createElement("hi-button");
    buttonEl.aesthetic = "ghost";
    return includeLabel(buttonEl);
  }
});
