
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import HIL from '../../../aip/library/ai-transpiler/ai-transpiler.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class CompilerElement extends BehaviorElement(AsHIC(PolymerElement)) {
  static get is() {
    return "ai-compiler";
  }
  static get api() {
    return ["postCompile", "preCompile", "compile", "downgrade", "upgrade"];
  }
  static get autoBinding() {
    return {
      signal: "compile-ended",
      field: "compile"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.__transpiler = void 0;
  }
  set namespace(ns) {
    this.transpiler.namespace = ns;
  }
  get namespace() {
    return this.transpiler.namespace;
  }
  get transpiler() {
    return this.__transpiler = this.__transpiler || HIL.dsl.transpiler();
  }
  setFlag(flag) {
    this.transpiler.setFlag(flag);
  }
  unsetFlag(flag) {
    this.transpiler.unsetFlag(flag);
  }
  get builder() {
    return this.transpiler.builder;
  }
  compile(script) {
    return this.transpiler.compile(script);
  }
  preCompile(script) {
    return this.transpiler.preCompile(script);
  }
  postCompile(script) {
    return this.transpiler.postCompile(script);
  }
  upgrade(plugin) {
    return this.transpiler.upgrade(plugin);
  }
  downgrade(plugin) {
    return this.transpiler.downgrade(plugin);
  }
}
HIP.factory.element(CompilerElement);
