
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorIO } from '../../../eip/element/hi-behavior-io/hi-behavior-io.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class EnvironmentElement extends BehaviorIO(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "ai-environment";
  }
  static get properties() {
    return {
      setting: {
        type: String
      }
    };
  }
  static get observers() {
    return ["__settingWatcher(setting)"];
  }
  static get autoBinding() {
    return {
      signal: "output-changed",
      field: "input"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "directory");
    this.setAttribute("hidden", "hidden");
  }
  __settingWatcher() {
    this.__forceRefresh();
  }
  _outputCompute(_input) {
    const _output = super._outputCompute(_input) || {};
    return _output ? _output[this.setting || ""] : {};
  }
  toString() {
    return `${this.setting}`;
  }
}
HIP.factory.element(EnvironmentElement);
