
import { LitElement } from '../../../hip/library/lit-element/lit-element.js';
import { html, nothing } from '../../../hip/library/lit-html/lit-html.js';
import { AsLitHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import adt from '../../../pip/library/pi-adt/pi-adt.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
import { BehaviorFactory } from '../../../aip/element/ai-behavior-factory/ai-behavior-factory.js';
import '../../../aip/element/ai-behavior-factory/ai-behavior-factory.js';
import './ai-control-artifact-basic.js';
import './ai-control-artifact-types.js';
export class FactoryControlElement extends BehaviorFactory(BehaviorElement(AsLitHIC(LitElement))) {
  static get is() {
    return "ai-factory-control";
  }
  _render(fields, type) {
    return html`${fields.map((field) => this.renderField(field))}`;
  }
  renderField(field) {
    const renderWidget = $ip.di.inject("control", field.render_type);
    if (!renderWidget) {
      return nothing;
    }
    const _field = adt.expression.evaluateAll(field, this.value);
    const renderFn = renderWidget.render(_field, this);
    if (!renderFn) {
      return nothing;
    }
    return this._renderValue(renderFn, _field);
  }
}
export default HIP.factory.element(FactoryControlElement);
