
import { setAttributes, writeAlways } from '../../../eip/element/hi-lit/hi-lit.js';
import { styleMap } from '../../../hip/library/lit-html/directives/style-map.js';
import { html, nothing } from '../../../hip/library/lit-html/lit-html.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export const renderAttributes = (field, defaultFieldAttributes = {}) => {
  const descriptionId = field.description ? `form_input__desc__${field.id}` : void 0;
  return f1.merge(
    "over",
    {
      type: f1.read("/filter_type", f1.read("/render_type", "unknown", field), field),
      maxlength: f1.read("/maximum_length", f1.read(`/significant_digits`, void 0, field.settings), field),
      minlength: f1.read("/minimum_length", void 0, field),
      max: f1.read("/maximum", void 0, field),
      min: f1.read("/minimum", void 0, field),
      step: f1.read("/step", void 0, field),
      "aria-labelledby": descriptionId
    },
    f1.merge("over", defaultFieldAttributes, f1.read("/attributes", {}, field))
  );
};
export const renderInput = (value, field, factory, attributes = {}, mask = nothing) => {
  return html`<hi-input
    form=${factory.form}
    name=${factory.namePrefix + field.name}
    model-path=${factory.namePrefix + field.model_path}
    data-attrs=${setAttributes(renderAttributes(field, attributes))}
    style=${styleMap(f1.read("/style", {}, field))}
    .value=${writeAlways(value)}
    .ns=${factory.ns}
    ?required=${field.required}
    ?nullable=${field.nullable}
    ?blankable=${field.blankable}
    ?readonly=${field.read_only}
    @commit-ended=${(e) => factory.retargetFieldEvent(e, field)}
    >${mask}</hi-input
  >`;
};
