
import { LitElement } from '../../../hip/library/lit-element/lit-element.js';
import { nothing } from '../../../hip/library/lit-html/lit-html.js';
import { AsLitHIC, BehaviorElement, HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorFactory } from '../../../aip/element/ai-behavior-factory/ai-behavior-factory.js';
import '../../../aip/element/ai-behavior-factory/ai-behavior-factory.js';
import './ai-edit-artifact-choice.js';
import './ai-edit-artifact-input.js';
import './ai-edit-artifact-types.js';
import './ai-edit-artifact-clock.js';
import './ai-edit-artifact-html.js';
import adt from '../../../pip/library/pi-adt/pi-adt.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
export class FactoryEditElement extends BehaviorFactory(BehaviorElement(AsLitHIC(LitElement))) {
  constructor() {
    super(...arguments);
    this.groupingMutation = adt.mutation("grouping");
    this._willRender = false;
  }
  static get is() {
    return "ai-factory-edit";
  }
  static get properties() {
    return {
      form: {
        type: String
      }
    };
  }
  renderField(field) {
    const renderInput = $ip.di.inject("edit", field.render_type);
    if (!renderInput) {
      return nothing;
    }
    const _field = adt.expression.evaluateAll(field, this.value);
    const renderFn = renderInput.is_render_control ? renderInput.renderControlled(_field, this) : renderInput.render(_field, this);
    if (!renderFn) {
      return nothing;
    }
    return this._renderValue(renderFn, _field);
  }
}
export default HIP.factory.element(FactoryEditElement);
