
import { html } from '../../../hip/library/lit-html/lit-html.js';
import { setAttributes } from '../../../eip/element/hi-lit/hi-lit.js';
import { styleMap } from '../../../hip/library/lit-html/directives/style-map.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
$ip.di.register("info", "text", {
  id: "factory-info-text",
  render(field, factory) {
    const ns = factory.ns;
    return (value, model) => {
      return html`<hi-text .value=${value} .ns=${ns}></hi-text>`;
    };
  }
});
$ip.di.register("info", "badges", {
  id: "factory-info-badges",
  render(field, factory) {
    const ns = factory.ns;
    const style = f1.read("/style", {}, field);
    return (value, model) => {
      return value.map(
        (item) => html`
          <hi-badge .ns=${ns} data-attrs=${setAttributes(field.attributes)} style=${styleMap(style)}>${item}</hi-badge>
        `
      );
    };
  }
});
$ip.di.register("info", "tags", {
  id: "factory-info-tags",
  render(field, factory) {
    const ns = factory.ns;
    const style = f1.read("/style", {}, field);
    return (value, model) => {
      return html`<hi-tag-group>
        ${value.map(
        (item) => html`
              <hi-tag
                data-attrs=${setAttributes(field.attributes)}
                style=${styleMap(style)}
                @close-ended=${(e) => factory.retargetFieldEvent(e, field)}
                >${item}</hi-tag
              >
            `
      )}
      </hi-tag-group>`;
    };
  }
});
