
import { LitElement } from '../../../hip/library/lit-element/lit-element.js';
import { nothing } from '../../../hip/library/lit-html/lit-html.js';
import { AsLitHIC, BehaviorElement, HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorFactory } from '../../../aip/element/ai-behavior-factory/ai-behavior-factory.js';
import '../../../aip/element/ai-behavior-factory/ai-behavior-factory.js';
import './ai-view-artifact-choice.js';
import './ai-view-artifact-clock.js';
import './ai-view-artifact-types.js';
import './ai-view-artifact-input.js';
import './ai-view-artifact-html.js';
import adt from '../../../pip/library/pi-adt/pi-adt.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
export class FactoryViewElement extends BehaviorFactory(BehaviorElement(AsLitHIC(LitElement))) {
  constructor() {
    super(...arguments);
    this._willRender = false;
  }
  static get is() {
    return "ai-factory-view";
  }
  renderField(field) {
    const renderField = $ip.di.inject("view", field.render_type);
    if (!renderField) {
      return nothing;
    }
    const _field = adt.expression.evaluateAll(field, this.value);
    const renderFn = renderField.render(_field, this);
    if (!renderFn) {
      return nothing;
    }
    return this._renderValue(renderFn, _field);
  }
}
export default HIP.factory.element(FactoryViewElement);
