
import { setAttributes, writeAlways } from '../../../eip/element/hi-lit/hi-lit.js';
import { ifDefined as ifDef } from '../../../hip/library/lit-html/directives/if-defined.js';
import { styleMap } from '../../../hip/library/lit-html/directives/style-map.js';
import { html } from '../../../hip/library/lit-html/lit-html.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
["time", "date", "date_time", "iso_date", "iso_time", "iso_date_time"].forEach((render_type) => {
  $ip.di.register("view", render_type, {
    id: `factory-view-${render_type}`,
    render(field, factory) {
      return (value) => {
        return html`<hi-text
          name=${factory.namePrefix + field.name}
          model-path=${factory.namePrefix + field.model_path}
          data-attrs=${setAttributes(field.attributes)}
          style=${styleMap(f1.read("/style", {}, field))}
          formatter=${render_type}
          .ns=${factory.ns}
          .value=${writeAlways(value)}
          .formatterRule=${ifDef(field.settings)}
          ?disallow-hint=${f1.is.boolean(field.hintable) ? !field.hintable : false}
        ></hi-text>`;
      };
    }
  });
});
