
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class InitializeElement extends BehaviorElement(AsHIC(PolymerElement)) {
  static get is() {
    return "ai-initialize";
  }
  static get properties() {
    return {
      output: {
        type: Object,
        notify: true
      },
      started: {
        type: Boolean,
        reflectToAttribute: true,
        notify: true
      }
    };
  }
  static get api() {
    return ["initializeEntities", "restart", "invoke", "start", "stop"];
  }
  static get autoBinding() {
    return {
      signal: "start-ended",
      field: "start"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
  }
  invoke(...args) {
    this.started = false;
    this.__start();
  }
  restart() {
    this.started = false;
    this.__start();
  }
  start() {
    this.__start();
  }
  __start() {
    if (!this.started) {
      this.started = true;
      this.output = {};
    }
  }
  stop() {
    this.started = false;
  }
}
HIP.factory.element(InitializeElement);
