
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorIO } from '../../../eip/element/hi-behavior-io/hi-behavior-io.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import navigation from '../../../pip/library/pi-navigation/pi-navigation.js';
export class LocationElement extends BehaviorIO(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "ai-location";
  }
  static get api() {
    return ["forward", "reload", "back", "goto"];
  }
  static get valueEvent() {
    return "output-changed";
  }
  static get autoBinding() {
    return {
      signal: "output-changed",
      field: "input"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
    this.invoke();
  }
  refresh() {
    return this.invoke();
  }
  _process(argument) {
    const state = navigation.location.active;
    this.parameters = state.parameters;
    return state;
  }
  reload() {
    return navigation.location.reload();
  }
  goto(path) {
    return navigation.location.goto(path);
  }
  back() {
    return navigation.location.back();
  }
  forward() {
    return navigation.location.forward();
  }
}
HIP.factory.element(LocationElement);
