
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class NoopElement extends BehaviorElement(AsHIC(PolymerElement)) {
  static get is() {
    return "ai-noop";
  }
  static get properties() {
    return {
      argument: {
        type: Object
      },
      input: {
        type: Object
      },
      output: {
        type: Object,
        readOnly: true,
        value: () => {
          return {};
        }
      }
    };
  }
  static get autoBinding() {
    return {
      signal: "invoke-ended",
      field: "invoke"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
  }
  invoke(argument) {
    this.argument = argument;
    HIP.data.applyExpressions(this);
    return this.output;
  }
  toString() {
    return JSON.stringify(this.output);
  }
}
HIP.factory.element(NoopElement);
