import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';

/* eslint-disable lit-a11y/heading-has-content */
/**
 * @pending this is incompleted, but functional
 *
 * @customElement
 * @polymer
 * @appliesMixin BehaviorPrefab
 * @appliesMixin BehaviorElement
 */
class PrefabContentEditorElement extends HIP.BehaviorPrefab(HIP.BehaviorElement(PolymerElement)) {
  static get is() {
    return 'ai-prefab-content-editor';
  }

  static get template() {
    return html`
      <ai-screen gid="_screen">
        <ai-state
          gid="_state_main"
          states="main"
          l-size="12"
          l-sml-size="10"
          l-hug="left"
          class="display-block plm prm"
        >
          <h2 id="_doc_title"></h2>

          <section class="mtm mbm">
            <div class="pas bts bls brs bdr-solid clr-gray_50-bdr clr-gray_10-bkg">
              <ai-block gid="_header_doc" region="doc_header" l-kind="hort">
                <div id="_header_doc_none_task__widget_group">
                  <ai-builder-widget gid="_header_doc_none_task__widget_group__builder"> </ai-builder-widget>
                </div>
              </ai-block>

              <hi-binding source="source" sink="noop">
                <hi-pipe sink="_header_doc_none_task__widget_group__builder">
                  <di-fn-get path="region.doc_header.tasks.none"></di-fn-get>
                </hi-pipe>
              </hi-binding>
            </div>

            <hi-editor gid="_editor" id="_editor" configuration="[[ editor_config ]]"> </hi-editor>
          </section>
        </ai-state>
        <ai-state kind="logic" gid="_external_interface">
          <hi-binding source="editor_config" sink="_editor" field="configuration"> </hi-binding>

          <!-- bind doc.title to _doc_title and doc.content to _editor.value -->
          <hi-binding source="doc" sink="noop">
            <hi-pipe sink="_doc_title" field="text">
              <di-fn-get path="title"></di-fn-get>
            </hi-pipe>
            <hi-pipe sink="_editor">
              <di-fn-get path="content"></di-fn-get>
            </hi-pipe>
          </hi-binding>

          <!-- TODO how to get the other values? -->
          <hi-binding source="doc_header__save_widget__task_widget" sink="noop">
            <hi-pipe sink="save_doc">
              <di-fn-composite composite='{ "content": "_editor.value" }'></di-fn-composite>
            </hi-pipe>
          </hi-binding>

          <hi-binding source="doc_header__reload_widget__task_widget" sink="noop">
            // TODO add heading, text from context object HIP.fn.prompt({ text: 'Are you sure you want to reload ?',
            controls: [{ order: 1, aesthetic: 'primary', type: 'yes', name: 'Confirm', value: 1, result: 'resolve' }, {
            order: 0, aesthetic: 'ghost', type: 'cancel', name: 'Cancel', value: -1, result: 'reject' }] }).then(() => {
            HIP.db.gid.queryOne('load_doc', 'ns-0').invoke(); }).catch(() => { });
          </hi-binding>
        </ai-state>
      </ai-screen>
    `;
  }

  get defaultScript() {
    return {
      system: {
        state: 'main'
      },
      configuration: {},
      action: {
        save_doc: {},
        load_doc: {}
      },
      bucket: {
        context: {
          $reactive_values: {
            confirm_dialog_heading: 'Confirm',
            confirm_dialog_sub_heading: '',
            confirm_dialog_body: 'Are you sure you want to reload? All changes will be lost.',
            confirm_dialog_reload_button_label: 'Reload',
            confirm_dialog_cancel_button_label: 'Cancel',
            title: 'Content Editor',
            description:
              'Content editor allows a developer to see what the end result will look like while the interface or document is being created.'
          }
        },
        doc: {
          // a doc object
          // e.g. id, title, content
        },
        editor_config: {
          // configuration object for hi-editor
        }
      }
    };
  }

  _connectedViewCallback() {
    // when the view invokes the prefab
  }
}

HIP.factory.element(PrefabContentEditorElement);
