import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import '../../../aip/element/ai-behavior-prefab/ai-behavior-prefab.js';
import '../../../eip/element/hi-component/hi-component.js';

/**
 * @customElement
 * @polymer
 * @appliesMixin BehaviorPrefab
 * @appliesMixin BehaviorElement
 */
class PrefabContentViewerElement extends HIP.BehaviorPrefab(HIP.BehaviorElement(PolymerElement)) {
  static get is() {
    return 'ai-prefab-content-viewer';
  }

  static get template() {
    return html`
      <ai-screen gid="_screen">
        <ai-state gid="_state_main" states="main" l-size="12" l-hug="left" class="display-block">
          <header>
            <ai-block gid="_header_content" l-kind="vert" region="content_header">
              <div id="_header_content_none_task__widget_group">
                <ai-builder-widget gid="_header_content_none_task__widget_group__builder"> </ai-builder-widget>
              </div>
              <div id="_header_content_singular_task__widget_group">
                <ai-builder-widget gid="_header_content_singular_task__widget_group__builder"> </ai-builder-widget>
              </div>
            </ai-block>
            <hi-binding source="source" sink="noop">
              <hi-pipe sink="_header_content_none_task__widget_group__builder">
                <di-fn-get path="region.content_header.tasks.none"></di-fn-get>
              </hi-pipe>
              <hi-pipe sink="_header_content_singular_task__widget_group__builder">
                <di-fn-get path="region.content_header.tasks.singular"></di-fn-get>
              </hi-pipe>
            </hi-binding>
            <hi-binding source="content" sink="_header_content_singular_task__widget_group__builder" field="value">
            </hi-binding>
          </header>

          <section class="mtm">
            <hi-panel l-size="12" id="_template_target" gid="_template_target"> </hi-panel>
          </section>

          <hi-render id="_template__render" gid="_template__render" for="_template_target"></hi-render>
          <ai-builder-template
            id="_content__template_builder"
            gid="_content__template_builder"
            for="_template__render"
            mode="template"
          ></ai-builder-template>

          <hi-binding source="context" field="template" sink="_content__template_builder">
            <di-fn-get path="template"></di-fn-get>
          </hi-binding>

          <hi-binding source="content_type" sink="_content__template_builder"> </hi-binding>

          <hi-binding source="content" sink="_template__render"> </hi-binding>
        </ai-state>
      </ai-screen>
    `;
  }

  get defaultScript() {
    return {
      system: {
        state: 'main'
      },
      bucket: {
        context: {
          $reactive_values: {
            template: 'fallback'
          }
        },
        content: {}
      }
    };
  }
}

HIP.factory.element(PrefabContentViewerElement);
