import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';

/**
 * @customElement
 * @polymer
 * @appliesMixin BehaviorPrefab
 * @appliesMixin BehaviorElement
 */
class PrefabdashboardElement extends HIP.BehaviorPrefab(HIP.BehaviorElement(PolymerElement)) {
  static get is() {
    return 'ai-prefab-dashboard';
  }

  static get template() {
    return html`
      <ai-screen gid="_screen" l-kind="hort">
        <ai-state gid="_state_main" states="main" l-kind="vert" class="plm prm">
          <header class="mtmxx pbsx bdr-solid clr-gray_50-bdr bbs" l-kind="hort" l-align="center" l-width-fixed>
            <h1 l-hug="start">[[ context.title ]]</h1>
            <div l-size="4">
              <p>[[ context.description ]]</p>
            </div>
          </header>

          <section></section>
        </ai-state>
        <ai-state kind="logic" gid="_external_interface"> </ai-state>
      </ai-screen>
    `;
  }

  get defaultScript() {
    return {
      life_cycle: {
        initialize: {
          $transition: {
            state: 'main'
          }
        }
      },
      configuration: {},
      action: {},
      bucket: {
        context: {
          $reactive_values: {
            title: 'New Prefab'
          }
        }
      }
    };
  }

  _connectedViewCallback() {
    // when the view invokes the prefab
  }
}

HIP.factory.element(PrefabdashboardElement);
