
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorIO } from '../../../eip/element/hi-behavior-io/hi-behavior-io.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class ProxyElement extends BehaviorIO(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "ai-proxy";
  }
  static get properties() {
    return {
      mergeOver: {
        type: Object
      },
      mergeOnto: {
        type: Object
      }
    };
  }
  static get observers() {
    return ["__mergeWatcher(mergeOver, mergeOnto)"];
  }
  static get autoBinding() {
    return {
      signal: "invoke-ended",
      field: "invoke"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
  }
  __mergeWatcher(mergeOver, mergeOnto) {
    this.__mergeOver = f1.clone(f1.safe({}, mergeOver));
    this.__mergeOnto = f1.clone(f1.safe({}, mergeOnto));
  }
  _process(argument) {
    return f1.merge(
      "onto",
      f1.merge("onto", f1.merge("onto", {}, this.__mergeOnto), f1.safe({}, argument)),
      this.__mergeOver
    );
  }
}
HIP.factory.element(ProxyElement);
