
import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import { BehaviorIO } from '../../../eip/element/hi-behavior-io/hi-behavior-io.js';
import { BehaviorContainer } from '../../../eip/element/hi-behavior-container/hi-behavior-container.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class RegionGroupElement extends BehaviorContainer(BehaviorIO(BehaviorElement(AsHIC(PolymerElement)))) {
  static get is() {
    return "ai-region-group";
  }
  static get template() {
    return html`<slot id="items"></slot>`;
  }
  static get autoBinding() {
    return {
      signal: "output-changed",
      field: "input"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
    this.input = {};
  }
  __onSlotChanged() {
    const regions = this.input;
    this.refresh();
    this.slotChildren.filter(this.__filterRegionsFn).map((el) => el.evaluate()).forEach((region) => {
      if (regions) {
        regions[region.name] = region;
      }
    });
  }
  __filterRegionsFn(node) {
    return node.nodeName === "AI-REGION" || node.nodeName === "HI-OBJECT";
  }
}
HIP.factory.element(RegionGroupElement);
