
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import ess from '../../../pip/library/pi-ess/pi-ess.js';
export class RelayElement extends BehaviorElement(AsHIC(PolymerElement)) {
  static get is() {
    return "ai-relay";
  }
  static get api() {
    return ["invoke"];
  }
  static get autoBinding() {
    return {
      signal: "invoke-ended",
      field: "invoke"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
  }
  invoke(value) {
    try {
      const children = this.children;
      const _value = HIP.data.applyModifiers(children, value, this);
      const __value = HIP.data.applyConditions(children, _value, this);
      return HIP.data.runTasks(children, __value, new CustomEvent("relay"));
    } catch (error) {
      ess.ele(this, {
        status: "warning",
        action: "invoke",
        data: error
      });
      return Promise.reject(error);
    }
  }
}
HIP.factory.element(RelayElement);
