
import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import { BehaviorIO } from '../../../eip/element/hi-behavior-io/hi-behavior-io.js';
import { BehaviorContainer } from '../../../eip/element/hi-behavior-container/hi-behavior-container.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class TagGroupElement extends BehaviorContainer(BehaviorIO(BehaviorElement(AsHIC(PolymerElement)))) {
  static get is() {
    return "ai-tag-group";
  }
  static get template() {
    return html`<slot id="items"></slot>`;
  }
  static get autoBinding() {
    return {
      signal: "output-changed",
      field: "input"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
    this.input = {};
  }
  __onSlotChanged() {
    this.refresh();
    this.input = {};
    this.slotChildren.filter(this.__filterTagFn).map((el) => el.evaluate()).forEach((tag) => {
      this.input[tag.name] = tag;
    });
  }
  __filterTagFn(node) {
    return node.nodeName === "AI-TAG" || node.nodeName === "HI-OBJECT";
  }
}
HIP.factory.element(TagGroupElement);
