
import { LitElement, html } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorTemplateAuth } from './ai-behavior-auth.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class TemplateAuthConfirmationElement extends BehaviorTemplateAuth(
  BehaviorTemplate(AsLitTemplateHILC(LitElement))
) {
  constructor() {
    super();
    this.requestNoHeader = true;
    this.requestNoFooter = true;
  }
  static get is() {
    return "ai-template-auth-confirmation";
  }
  _defaultRuntime() {
    return {
      tasks: {
        authorized: {
          $is: "task"
        }
      }
    };
  }
  _injectInstances() {
    return ["view", "authorized"];
  }
  connectedCallback() {
    super.connectedCallback();
    this._styleCentralBox();
    this._styleRegion();
  }
  _render() {
    const authorizedValue = this._instances.authorized.value();
    return html` ${this._renderHeader()}
      <hi-alert mode="presentation">
        <span>${f1.read("/title", "", authorizedValue)}</span>
        <span slot="details"> ${f1.read("/details", "", authorizedValue)} </span>
      </hi-alert>
      ${this._renderFooter()}`;
  }
}
export default HIP.factory.element(TemplateAuthConfirmationElement);
