
import { LitElement, html } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import '../../../aip/element/ai-factory-editor/ai-factory-editor.js';
import '../../../eip/element/hi-button/hi-button.js';
import '../../../eip/element/hi-form/hi-form.js';
import { BehaviorTemplateAuth } from './ai-behavior-auth.js';
export class TemplateAuthResetElement extends BehaviorTemplateAuth(BehaviorTemplate(AsLitTemplateHILC(LitElement))) {
  constructor() {
    super();
    this.requestNoHeader = true;
    this.requestNoFooter = true;
  }
  static get is() {
    return "ai-template-auth-reset";
  }
  connectedCallback() {
    super.connectedCallback();
    this._styleCentralBox();
    this._styleRegion();
  }
  _render() {
    const uniqueId = "auth-reset-form";
    return html`
      ${this._renderHeader()}
      <section>
        ${this._renderForm(uniqueId)} ${this._renderSeparator()} ${this._renderAuthorizationControls(uniqueId)}
        ${this._renderEABLogo()}
      </section>
      ${this._renderFooter()}
    `;
  }
}
export default HIP.factory.element(TemplateAuthResetElement);
