
import { LitElement, html } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class TemplateDebugElement extends BehaviorTemplate(AsLitTemplateHILC(LitElement)) {
  static get is() {
    return "ai-template-debug";
  }
  _render() {
    const workspace = this.runtime.workspace;
    const allJobs = f1.difference(
      ["view_bridge", "document", "window", "navigation", "noop", "hip"],
      f1.map(f1.read("/id", void 0), workspace.list())
    );
    const allInstances = f1.compact(f1.map((id) => workspace.queryInstance(id), allJobs));
    return html`
      <ul kind="no-dot">
        ${allInstances.map((instance) => {
      return html`<li>
            <h3>${instance.id}</h3>
            <hi-textarea id="val-${instance.id}" .value=${instance.value()}></hi-textarea>
            <hi-button .value=${instance} @trigger-ended=${this.__invoke__onTriggerEnded}>Invoke</hi-button>
          </li>`;
    })}
      </ul>
    `;
  }
  __invoke__onTriggerEnded(e) {
    const instance = e.detail.value;
    const textareaEl = this.querySelector(`#val-${instance.id}`);
    if (!textareaEl) {
      return;
    }
    instance.invoke(f1.parse("json", {}, textareaEl.value));
  }
}
export default HIP.factory.element(TemplateDebugElement);
