
import { LitElement, html } from '../../../hip/library/lit-element/lit-element.js';
import { unsafeHTML } from '../../../hip/library/lit-html/directives/unsafe-html.js';
import { nothing } from '../../../hip/library/lit-html/lit-html.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
export class TemplateDocumentElement extends BehaviorTemplate(AsLitTemplateHILC(LitElement)) {
  static get is() {
    return "ai-template-document";
  }
  _defaultRuntime() {
    return {
      tasks: {
        document: {
          $is: "task",
          initial_value: {
            date: new Date().toLocaleDateString(),
            article: ""
          }
        }
      }
    };
  }
  _injectInstances() {
    return ["document"];
  }
  _render() {
    const document = this._instances.document.value();
    return html`
      <header>${document.date ? html`<p>${document.date}</p>` : nothing}</header>
      <section>${unsafeHTML(document.article)}</section>
    `;
  }
}
export default HIP.factory.element(TemplateDocumentElement);
