
import { LitElement, html } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import '../../../aip/element/ai-factory-inline/ai-factory-inline.js';
import '../../../eip/element/hi-panel/hi-panel.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class TemplateEntityDetailsInlineElement extends BehaviorTemplate(AsLitTemplateHILC(LitElement)) {
  static get is() {
    return "ai-template-entity-details-inline";
  }
  _injectInstances() {
    return ["entity", "submit_entity"];
  }
  editorEntity() {
    return this.runtime.id ? `${this.runtime.id}-entity` : `entity-${f1.id()}`;
  }
  _render() {
    const instances = this._instances;
    const entityValue = instances.entity.value();
    const entityType = instances.entity.type();
    const editorEntity = this.editorEntity();
    const entityGid = "entity-editor-form";
    return html`<hi-panel gid=${entityGid} .ns=${this.ns}></hi-panel>
      <ai-factory-inline
        for=${entityGid}
        gid="force-paint"
        .ns=${this.ns}
        form=${editorEntity}
        .value=${entityValue}
        .type=${entityType}
        @field-trigger-ended=${(e) => {
      this.runtime.interlink.proxyFieldValueIn(e.detail);
      this.__field__onTriggerEnded(e);
    }}
      ></ai-factory-inline>`;
  }
  __field__onTriggerEnded(e) {
    const instances = this._instances;
    const fieldValue = e.detail.value;
    instances.submit_entity.invoke(fieldValue);
  }
}
export default HIP.factory.element(TemplateEntityDetailsInlineElement);
