
import { LitElement } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorEntityList } from './ai-behavior-entity-list.js';
export class TemplateEntityListElement extends BehaviorEntityList(BehaviorTemplate(AsLitTemplateHILC(LitElement))) {
  static get is() {
    return "ai-template-entity-list";
  }
  _injectInstances() {
    return ["entities", "entities_row_actions"];
  }
  _render() {
    return this._renderList();
  }
  async _list__onUpdateMutationsEnded(e) {
    const mutations = e.detail.value;
    const editQueryParametersI = this.runtime.workspace.queryInstance("edit_query_parameters");
    if (!editQueryParametersI) {
      return;
    }
    await editQueryParametersI.invoke(mutations);
  }
}
export default HIP.factory.element(TemplateEntityListElement);
