
import { LitElement } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorEntityTable } from './ai-behavior-entity-table.js';
import '../../../aip/element/ai-factory-edit/ai-factory-edit.js';
import '../../../aip/element/ai-factory-view/ai-factory-view.js';
import '../../../vip/element/vi-grid/vi-grid.js';
export class TemplateEntityTableElement extends BehaviorEntityTable(BehaviorTemplate(AsLitTemplateHILC(LitElement))) {
  static get is() {
    return "ai-template-entity-table";
  }
  connectedCallback() {
    super.connectedCallback();
    this.style.height = "100%";
  }
  _injectInstances() {
    return ["entities"];
  }
  _render() {
    return this._renderTable();
  }
  async _grid__onUpdateMutationsEnded(e) {
    const mutations = e.detail.value;
    const editQueryParametersI = this.runtime.workspace.queryInstance("edit_query_parameters");
    if (!editQueryParametersI) {
      return;
    }
    await editQueryParametersI.invoke(mutations);
  }
}
export default HIP.factory.element(TemplateEntityTableElement);
