
import { LitElement, html } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import '../../../aip/element/ai-factory-viewer/ai-factory-viewer.js';
import '../../../eip/element/hi-accordion/hi-accordion.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class TemplateEntityViewerListElement extends BehaviorTemplate(AsLitTemplateHILC(LitElement)) {
  static get is() {
    return "ai-template-entity-viewer-list";
  }
  _injectInstances() {
    return ["entities"];
  }
  _render() {
    const instances = this._instances;
    const { value: _entitiesValue, type: entitiesType } = instances.entities.state();
    const formsValue = f1.is.nil(_entitiesValue) ? [] : f1.is.array(_entitiesValue) ? _entitiesValue : [_entitiesValue];
    const ns = this.ns;
    const formElements = formsValue.map((form) => {
      const formGid = `entity-viewer-form-${f1.id()}`;
      return html`
        <hi-bar>${form.entity_form_title ? form.entity_form_title : "Form"}</hi-bar>
        <hi-note>
          <hi-panel gid=${formGid} .ns=${ns} class="mtm"></hi-panel>
          <ai-factory-viewer
            gid="force-paint"
            for=${formGid}
            .ns=${ns}
            .value=${form}
            .type=${entitiesType}
          ></ai-factory-viewer>
        </hi-note>
      `;
    });
    return html` <hi-accordion> ${formElements} </hi-accordion> `;
  }
}
export default HIP.factory.element(TemplateEntityViewerListElement);
