
import { LitElement, html } from '../../../hip/library/lit-element/lit-element.js';
import { nothing } from '../../../hip/library/lit-html/lit-html.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import '../../../aip/element/ai-factory-viewer/ai-factory-viewer.js';
export class TemplateEntityViewerElement extends BehaviorTemplate(AsLitTemplateHILC(LitElement)) {
  static get is() {
    return "ai-template-entity-viewer";
  }
  _injectInstances() {
    return ["entity"];
  }
  _render() {
    const instances = this._instances;
    const { value: entityValue, type: entityType } = instances.entity.state();
    if (f1.is.nil(entityValue) || f1.is.empty(entityValue)) {
      return nothing;
    }
    const ns = this.ns;
    const entityGid = `entity-viewer-form`;
    return html`<hi-panel gid=${entityGid} .ns=${ns}></hi-panel>
      <ai-factory-viewer gid="force-paint" for=${entityGid} .ns=${ns} .value=${entityValue} .type=${entityType}>
      </ai-factory-viewer>`;
  }
}
export default HIP.factory.element(TemplateEntityViewerElement);
