
import { LitElement, html } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
export class TemplateMessageElement extends BehaviorTemplate(AsLitTemplateHILC(LitElement)) {
  static get is() {
    return "ai-template-message";
  }
  _defaultRuntime() {
    return {
      tasks: {
        message: {
          $is: "task",
          initial_value: {
            description: "Add your description here",
            status: "Message status",
            image: "Add image URL"
          }
        }
      }
    };
  }
  _injectInstances() {
    return ["message"];
  }
  _render() {
    const instances = this._instances;
    const message = instances.message.value();
    return html`
      <section l-kind="vert" class="mtm" l-align="center">
        <h1 class="prefab-message-title ptl pbm mll mrl mbm bbs bdr-solid clr-gray_40-bdr text-center">
          ${message.title}
        </h1>
        <div class="prefab-message-image">
          <img src=${message.image} alt="" />
        </div>
        <h2 class="mtm">${message.status}</h2>
        <p class="ptsx">${message.description}</p>
      </section>
    `;
  }
}
HIP.factory.element(TemplateMessageElement);
