
import { LitElement, html } from '../../../hip/library/lit-element/lit-element.js';
import { nothing } from '../../../hip/library/lit-html/lit-html.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
export class TemplateNavMenuElement extends BehaviorTemplate(AsLitTemplateHILC(LitElement)) {
  static get is() {
    return "ai-template-nav-menu";
  }
  _defaultRuntime() {
    return {
      tasks: {
        index: {
          $is: "task",
          initial_value: []
        }
      }
    };
  }
  _injectInstances() {
    return ["index"];
  }
  _render() {
    const instances = this._instances;
    const indexList = instances.index.value();
    return html` ${this.__renderStyles()}
      <ul kind="index">
        ${f1.map(({ title, uri, icon }) => {
      const linkHref = f1.safe("#", uri);
      const linkTitle = f1.safe("--", title);
      return html`<li kind="item">
            ${icon ? html`<hi-icon glyph=${icon} size="large" mode="presentation" class="mr-4"></hi-icon>` : nothing}
            <hi-link href=${linkHref} class="text-sz-l">${linkTitle}</hi-link>
          </li> `;
    }, indexList)}
      </ul>`;
  }
  __renderStyles() {
    return html`<style>
      ai-template-nav-menu li[kind='item'] {
        padding: var(--hi-px-20);
      }

      ai-template-nav-menu li[kind='item']:first-of-type {
        border-top: var(--hi-menu--border);
        margin-top: var(--hi-px-20);
      }
    </style>`;
  }
}
export default HIP.factory.element(TemplateNavMenuElement);
