
import { html, nothing } from '../../../hip/library/lit-element/lit-element.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import adt from '../../../pip/library/pi-adt/pi-adt.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import { BehaviorPrint } from './ai-behavior-print.js';
export function BaseBehaviorPrintEntity(Base) {
  class BehaviorPrintEntity2 extends BehaviorPrint(BehaviorBehavior(Base)) {
    constructor() {
      super(...arguments);
      this.fieldMutations = adt.mutation("fields");
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorPrintEntity");
    }
    _renderEntity(entity, _type, gid) {
      const ns = this.ns;
      const type = this.fieldMutations.invokeType(_type);
      const fieldWithoutTitle = f1.filter((field) => !this.__titleFieldFilterFn(field), type.fields);
      const typeWithoutTitle = {
        ...type,
        fields: fieldWithoutTitle
      };
      return html`<hi-panel gid="${gid}" .ns=${ns}></hi-panel>
        <ai-factory-viewer
          gid="force-paint"
          for="${gid}"
          .type=${typeWithoutTitle}
          .value=${entity}
          .ns=${ns}
        ></ai-factory-viewer>`;
    }
    __titleFieldFilterFn(field) {
      return field.alias === "title" || field.name === "title";
    }
    _renderEntityWithHeading(entity, _type, gid) {
      const type = this.fieldMutations.invokeType(_type);
      const entityHeadingLevel = 2;
      return html` ${this.__renderTitle(entity, type, entityHeadingLevel)} ${this._renderEntity(entity, type, gid)} `;
    }
    __renderTitle(entity, type, level = 1) {
      const titleFieldFn = (field) => field.alias === "title" || field.name === "title";
      const titleField = f1.find(titleFieldFn, type.fields);
      if (f1.is.empty(titleField)) {
        return nothing;
      }
      const titleFieldName = f1.read("/name", "title", adt.expression.evaluateAll(titleField, entity));
      const title = f1.read(`/${titleFieldName}`, "", entity);
      if (f1.is.empty(title)) {
        return nothing;
      }
      return html`<hi-title level="${level}" class="mbm display-block" title=${title}></hi-title>`;
    }
  }
  return HIP.factory.mixin(BehaviorPrintEntity2);
}
export const BehaviorPrintEntity = dedupingMixin(BaseBehaviorPrintEntity);
