
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import { BehaviorTemplate } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
export function BaseBehaviorPrint(Base) {
  class BehaviorPrint2 extends BehaviorTemplate(BehaviorBehavior(Base)) {
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorPrint");
      this.__onPrintDialogClosedBound = this.__onPrintDialogClosed.bind(this);
      window.addEventListener("afterprint", this.__onPrintDialogClosedBound);
    }
    __onPrintDialogClosed() {
      const printedTask = this._instances.printed;
      if (!printedTask) {
        return;
      }
      printedTask.invoke();
    }
    shouldUpdate(changedProperties) {
      const hasPropertiesUpdated = !f1.is.empty(changedProperties);
      return hasPropertiesUpdated;
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      window.removeEventListener("afterprint", this.__onPrintDialogClosedBound);
    }
    async updated() {
      if (!this.updateComplete) {
        return;
      }
      await this.updateComplete;
      const runningTasks = Object.keys(this._instances).filter(
        (instance) => f1.read(`/${instance}/job/state/running`, true, this._instances)
      );
      if (!f1.is.empty(runningTasks)) {
        return;
      }
      const parentEl = this.parentElement;
      if (!parentEl) {
        return;
      }
      const aiViewHead = parentEl.querySelector("ai-view-head");
      const aiViewFoot = parentEl.querySelector("ai-view-foot");
      if (!aiViewHead || !aiViewFoot) {
        return;
      }
      const viewRenderPromises = [
        aiViewHead["updateComplete"],
        aiViewFoot["updateComplete"],
        this.updateComplete
      ];
      await Promise.all(viewRenderPromises);
      window.print();
    }
  }
  return HIP.factory.mixin(BehaviorPrint2);
}
export const BehaviorPrint = dedupingMixin(BaseBehaviorPrint);
