
import { LitElement } from '../../../hip/library/lit-element/lit-element.js';
import { html } from '../../../hip/library/lit-html/lit-html.js';
import adt from '../../../pip/library/pi-adt/pi-adt.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import '../../../aip/element/ai-factory-control/ai-factory-control.js';
import '../../../aip/element/ai-factory-viewer/ai-factory-viewer.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import { BehaviorPrintEntity } from './ai-behavior-print-entity.js';
export class TemplatePrintEntityListElement extends BehaviorPrintEntity(
  BehaviorTemplate(AsLitTemplateHILC(LitElement))
) {
  constructor() {
    super(...arguments);
    this.fieldMutations = adt.mutation("fields");
  }
  static get is() {
    return "ai-template-print-entity-list";
  }
  _defaultRuntime() {
    return {
      startup: [
        {
          $is: "reference",
          id: "view"
        },
        {
          $is: "reference",
          id: "entities"
        },
        {
          $is: "reference",
          id: "entity_header"
        }
      ]
    };
  }
  _injectInstances() {
    return ["entities", "entity_header", "printed"];
  }
  __renderEntities() {
    let { type: entitiesType, value: entities } = this._instances.entities.state();
    entitiesType = this.fieldMutations.invokeType(entitiesType);
    entities = f1.to.array(entities);
    return html`${entities.map(
      (entity, index) => html`
        <div class="baz bdr-solid bts clr-gray_40-bdr mtm ptm">
          ${this._renderEntityWithHeading.bind(this)(entity, entitiesType, `entity-list-item-${index}`)}
        </div>
      `
    )}`;
  }
  __renderHeaderContent() {
    const { value: headerContent } = this._instances.entity_header.state();
    let { type: headerContentType } = this._instances.entity_header.state();
    headerContentType = this.fieldMutations.invokeType(headerContentType);
    return html` ${this._renderEntity.call(this, headerContent, headerContentType, `entity-list-content-header`)}`;
  }
  _render() {
    return html`${this.__renderHeaderContent()} ${this.__renderEntities()}`;
  }
}
export default HIP.factory.element(TemplatePrintEntityListElement);
