
import { LitElement } from '../../../hip/library/lit-element/lit-element.js';
import { html } from '../../../hip/library/lit-html/lit-html.js';
import { BehaviorTemplate, AsLitTemplateHILC } from '../../../aip/element/ai-behavior-template/ai-behavior-template.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import '../../../aip/element/ai-factory-control/ai-factory-control.js';
import '../../../aip/element/ai-factory-viewer/ai-factory-viewer.js';
import { BehaviorPrintEntity } from './ai-behavior-print-entity.js';
export class TemplatePrintEntityElement extends BehaviorPrintEntity(BehaviorTemplate(AsLitTemplateHILC(LitElement))) {
  static get is() {
    return "ai-template-print-entity";
  }
  _defaultRuntime() {
    return {
      startup: [
        {
          $is: "reference",
          id: "view"
        },
        {
          $is: "reference",
          id: "entity"
        },
        {
          $is: "reference",
          id: "entity_header"
        }
      ]
    };
  }
  _injectInstances() {
    return ["entity", "entity_header", "printed"];
  }
  __renderEntity() {
    const { type, value: entity } = this._instances.entity.state();
    return html`<div class="baz bdr-solid bts clr-gray_40-bdr mtm ptm">
      ${this._renderEntityWithHeading.bind(this)(entity, type, `entity-item`)}
    </div>`;
  }
  __renderHeaderContent() {
    const { type, value } = this._instances.entity_header.state();
    return html`${this._renderEntity.bind(this)(value, type, `entity-content-header`)}`;
  }
  _render() {
    return html`${this.__renderHeaderContent()} ${this.__renderEntity()}`;
  }
}
export default HIP.factory.element(TemplatePrintEntityElement);
