
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorObject } from '../../../eip/element/hi-behavior-object/hi-behavior-object.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class FieldElement extends BehaviorObject(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "ai-field";
  }
  static get autoBinding() {
    return {
      signal: "value-notified",
      field: "prop"
    };
  }
  setDefaults(field) {
    field.id = field.id || this.id || this.getAttribute("prop-id");
    field.title = field.title || this.getAttribute("prop-title");
    field.name = field.name || this.getAttribute("prop-name");
    HIP.visitor.setRequestDefaults(field);
    return field;
  }
}
HIP.factory.element(FieldElement);
