
import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import { Debouncer } from '../../../hip/library/polymer/polymer.js';
import { idlePeriod } from '../../../hip/library/polymer/polymer.js';
import { BehaviorIO } from '../../../eip/element/hi-behavior-io/hi-behavior-io.js';
import { BehaviorContainer } from '../../../eip/element/hi-behavior-container/hi-behavior-container.js';
import { BehaviorItemGroup } from '../../../eip/element/hi-behavior-group/hi-behavior-item-group.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import './ai-field.js';
export class TypeElement extends BehaviorItemGroup(
  BehaviorContainer(BehaviorIO(BehaviorElement(AsHIC(PolymerElement))))
) {
  constructor() {
    super("type");
  }
  static get is() {
    return "ai-type";
  }
  static get template() {
    return html`<slot id="items"></slot>`;
  }
  static get properties() {
    return {
      name: {
        type: String
      },
      typeRef: {
        type: String,
        notify: true
      }
    };
  }
  static get autoBinding() {
    return {
      signal: "output-changed",
      field: "input"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
    this.addEventListener("value-notified", this.__field_onValueNotified);
    this.group = "type";
  }
  __field_onValueNotified(e) {
    if (e.srcElement.nodeName === "AI-FIELD") {
      const fieldEl = e.srcElement;
      const object = fieldEl.setDefaults(fieldEl.value);
      this.input = this.input || {};
      this.input[object.name] = object;
      this.__flushDebounce = Debouncer.debounce(this.__flushDebounce, idlePeriod, () => {
        this._group__stateChanged();
        this.flush();
      });
    }
  }
}
HIP.factory.element(TypeElement);
