
import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class ViewFooterElement extends BehaviorElement(AsHIC(PolymerElement)) {
  static get is() {
    return "ai-view-footer";
  }
  static get template() {
    return html`
      <!-- footer message -->
      <hi-panel gid="_view_footer__panel" region="view_footer" ns$="[[ ns ]]" class="ptmx">
        <ai-builder-message
          gid="_view_footer__message_group__builder"
          id="_view_footer__message_group__builder"
          ns$="[[ ns ]]"
        >
        </ai-builder-message>
      </hi-panel>
      <hi-binding source="source" sink="_view_footer__message_group__builder" ns$="[[ ns ]]">
        <di-fn-get path="region.view_footer.messages"> </di-fn-get>
      </hi-binding>

      <!-- footer widget -->
      <ai-block gid="_view_footer__block" region="view_footer__widget_group__builder" ns$="[[ ns ]]">
        <div id="_view_footer_none_task__widget_group__builder" l-kind="hort" l-gutter l-width-fixed l-align="center">
          <ai-builder-widget gid="_view_footer_none_task__widget_group__builder" ns$="[[ ns ]]"> </ai-builder-widget>
        </div>
      </ai-block>
      <hi-binding source="source" sink="_view_footer_none_task__widget_group__builder" ns$="[[ ns ]]">
        <di-fn-get path="region.view_footer.tasks.none"> </di-fn-get>
      </hi-binding>

      <!-- footer template -->
      <section>
        <hi-panel id="_view_footer__target" gid="_view_footer__target" ns$="[[ ns ]]"> </hi-panel>
      </section>
      <hi-render id="_view_footer__render" gid="_view_footer__render" for="_view_footer__target" ns$="[[ ns ]]">
      </hi-render>
      <ai-builder-template
        id="_view_footer__template_builder"
        gid="_view_footer__template_builder"
        for="_view_footer__render"
        mode="template"
        ns$="[[ ns ]]"
      >
      </ai-builder-template>
      <hi-binding source="context" field="template" sink="_view_footer__template_builder" ns$="[[ ns ]]">
        <di-fn-get path="template_footer"></di-fn-get>
      </hi-binding>
      <hi-binding source="view_footer_type" sink="_view_footer__template_builder" ns$="[[ ns ]]"> </hi-binding>
      <hi-binding source="view_footer" sink="_view_footer__render" ns$="[[ ns ]]"> </hi-binding>
    `;
  }
  static get properties() {
    return {
      context: {
        type: Object
      }
    };
  }
  _attachDom(dom) {
    this.classList.add("display-block");
    this.appendChild(dom);
    return null;
  }
}
HIP.factory.element(ViewFooterElement);
