
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorModifier } from '../../../eip/element/hi-behavior-modifier/hi-behavior-modifier.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class FnCompactElement extends BehaviorModifier(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "di-fn-compact";
  }
  static get properties() {
    return {
      field: {
        type: String,
        reflectToAttribute: true
      }
    };
  }
  static get observers() {
    return ["__settingsWatcher(field)"];
  }
  get purpose() {
    return "compact";
  }
  _modify(input, owner) {
    if (!Array.isArray(input)) {
      return input;
    }
    const compactBy = this.field;
    if (compactBy) {
      return input.filter((_) => _[compactBy] != null);
    }
    return input.filter((o) => o != null);
  }
}
HIP.factory.element(FnCompactElement);
