
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorModifier } from '../../../eip/element/hi-behavior-modifier/hi-behavior-modifier.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import ifn from '../../../pip/library/pi-ifn/pi-ifn.js';
export class FnGetElement extends BehaviorModifier(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "di-fn-get";
  }
  static get properties() {
    return {
      kind: {
        type: String,
        value: "object",
        reflectToAttribute: true
      },
      path: {
        type: String,
        reflectToAttribute: true
      }
    };
  }
  static get observers() {
    return ["__settingsWatcher(path)"];
  }
  get purpose() {
    return "get";
  }
  _modify(input) {
    if (!input) {
      return input;
    }
    const defaultValue = input;
    const path = this.path;
    switch (this.kind) {
      case "collection":
        return f1.map((o) => ifn.getWithDefault(defaultValue, path, o), input);
      case "object":
        return ifn.getWithDefault(defaultValue, path, input);
      default:
        return input;
    }
  }
}
HIP.factory.element(FnGetElement);
