
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorModifier } from '../../../eip/element/hi-behavior-modifier/hi-behavior-modifier.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class FnIndexableElement extends BehaviorModifier(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "di-fn-indexable";
  }
  static get properties() {
    return {
      indexKey: {
        type: String
      }
    };
  }
  static get observers() {
    return ["__settingsWatcher(indexKey)"];
  }
  get purpose() {
    return "indexable";
  }
  _modify(input) {
    if (input == null) {
      return input;
    }
    return this.__walk(input, this.indexKey || "nk");
  }
  __walk(node, indexKey) {
    if (f1.is.array(node)) {
      return f1.reduce(
        (top, _value) => {
          const assignment = _value[indexKey];
          if (assignment != null) {
            top[assignment] = _value;
          }
          return top;
        },
        {},
        node
      );
    }
    return node;
  }
}
HIP.factory.element(FnIndexableElement);
