
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorModifier } from '../../../eip/element/hi-behavior-modifier/hi-behavior-modifier.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import ifn from '../../../pip/library/pi-ifn/pi-ifn.js';
export class FnInitElement extends BehaviorModifier(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "di-fn-init";
  }
  static get properties() {
    return {
      value: {
        type: Object,
        value: () => {
          return {};
        }
      },
      hoistPath: {
        type: String,
        reflectToAttribute: true
      }
    };
  }
  static get observers() {
    return ["__settingsWatcher(value, hoistPath)"];
  }
  get purpose() {
    return "init";
  }
  _modify(input) {
    const value = this.value == null ? input : f1.copy(this.value);
    if (this.hoistPath != null) {
      ifn.set(this.hoistPath, value, input);
    }
    return value;
  }
}
HIP.factory.element(FnInitElement);
