
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorModifier } from '../../../eip/element/hi-behavior-modifier/hi-behavior-modifier.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class FnPaginateElement extends BehaviorModifier(BehaviorElement(AsHIC(PolymerElement))) {
  constructor() {
    super(...arguments);
    this.pageIndex = 0;
  }
  static get is() {
    return "di-fn-paginate";
  }
  static get properties() {
    return {
      pageIndex: {
        type: Number,
        reflectToAttribute: true,
        notify: true
      },
      pageSize: {
        type: Number,
        reflectToAttribute: true,
        notify: true
      }
    };
  }
  static get observers() {
    return ["_settingsWatcher(pageIndex, pageSize)"];
  }
  static get autoBinding() {
    return {
      signal: "modify-ended",
      field: "pageIndex"
    };
  }
  get purpose() {
    return "paginate";
  }
  _modify(input) {
    const start = f1.to.integer(this.pageIndex) * f1.to.integer(this.pageSize);
    const end = start + f1.to.integer(this.pageSize);
    if (!Array.isArray(input)) {
      return input;
    }
    return input.slice(start, end);
  }
}
HIP.factory.element(FnPaginateElement);
