
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorModifier } from '../../../eip/element/hi-behavior-modifier/hi-behavior-modifier.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export class FnSortElement extends BehaviorModifier(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "di-fn-sort";
  }
  static get properties() {
    return {
      field: {
        type: String,
        reflectToAttribute: true,
        notify: true
      },
      order: {
        type: String,
        reflectToAttribute: true
      }
    };
  }
  static get observers() {
    return ["__settingsWatcher(field, order)"];
  }
  get purpose() {
    return "sort";
  }
  _modify(input) {
    if (!Array.isArray(input)) {
      return input;
    }
    const field = this.field;
    const order = this.order || "asc";
    return field && order ? input.sort((a, b) => HIP.data.sortComparator(a, b, field, order)) : input;
  }
}
HIP.factory.element(FnSortElement);
