
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorModifier } from '../../../eip/element/hi-behavior-modifier/hi-behavior-modifier.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class FnTypeElement extends BehaviorModifier(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "di-fn-type";
  }
  static get properties() {
    return {
      typePromotion: {
        type: String,
        observe: "__typePromotionChanged"
      }
    };
  }
  static get observers() {
    return ["__settingsWatcher(typePromotion)"];
  }
  get purpose() {
    return "type";
  }
  _modify(input) {
    if (this.typePromotion && f1.is.array(input)) {
      return {
        type: {
          [this.typePromotion.replace("#/type/", "")]: input
        }
      };
    }
    return input;
  }
  __typePromotionChanged(typePromotion) {
    return (typePromotion || "").replace("#/type/", "");
  }
}
HIP.factory.element(FnTypeElement);
