
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorModifier } from '../../../eip/element/hi-behavior-modifier/hi-behavior-modifier.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class FnUniqueElement extends BehaviorModifier(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "di-fn-unique";
  }
  get purpose() {
    return "unique";
  }
  static get properties() {
    return {
      kind: {
        type: String
      },
      uniqueBy: {
        type: String
      }
    };
  }
  __uniqueBy(arr, uniqueByKey) {
    return [
      ...arr.reduce((map, item) => {
        const key = f1.is.record(item) ? item[uniqueByKey] : item;
        map.has(key) || map.set(key, item);
        return map;
      },  new Map()).values()
    ];
  }
  _modify(input) {
    if (!Array.isArray(input)) {
      return input;
    }
    if (this.kind === "collection") {
      return this.__uniqueBy(input, this.uniqueBy);
    }
    return Array.from(new Set(input));
  }
}
HIP.factory.element(FnUniqueElement);
