
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { LitElement, css, html } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { HIP, AsLitHIC } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorContainer } from '../../../eip/element/hi-behavior-container/hi-behavior-container.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import './hi-avatar.js';
export const styles = css`
  #container {
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
  }

  :host([kind='grid']) #container {
    flex-wrap: wrap;
  }

  :host([kind='stack']) #container ::slotted(hi-avatar),
  :host([kind='collapse']) #container ::slotted(hi-avatar) {
    margin-right: -1.25ch;
    position: relative;
  }
`;
export class AvatarGroupElement extends BehaviorContainer(BehaviorElement(AsLitHIC(LitElement))) {
  constructor() {
    super();
    this.kind = "collapse";
    f1.write("/features/behavior-container/index-children", false, this);
  }
  static get is() {
    return "hi-avatar-group";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  static get properties() {
    return {
      kind: {
        type: String,
        reflect: true
      }
    };
  }
  render() {
    return html`
      <div id="container">
        <slot id="items"></slot>
      </div>
    `;
  }
  __onSlotChanged() {
    const avatars = this._readSlotChildren();
    const avatarsLength = avatars.length;
    dom.write(() => {
      avatars.forEach((node, index) => {
        node.style.zIndex = `${avatarsLength - index}`;
      });
    });
  }
}
export default HIP.factory.element(AvatarGroupElement);
