
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP, AsHIC } from '../../../eip/element/hi-hip/hi-hif.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import '../../../eip/element/hi-hip/hi-hif.js';
import ess from '../../../pip/library/pi-ess/pi-ess.js';
import ifn from '../../../pip/library/pi-ifn/pi-ifn.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorAssignment(Base) {
  class BehaviorAssignment2 extends AsHIC(BehaviorBehavior(Base)) {
    static get properties() {
      return {
        sink: {
          type: Object,
          reflectToAttribute: true
        },
        nsSink: {
          type: String
        },
        field: {
          type: String,
          reflectToAttribute: true
        },
        sinkProperty: {
          type: String,
          reflectToAttribute: true
        },
        expression: {
          type: String
        },
        constant: {
          type: Object
        },
        inject: {
          type: Object,
          observer: "__injectChanged"
        },
        pullSource: {
          type: String
        },
        pullField: {
          type: String,
          reflectToAttribute: true
        },
        fieldPath: {
          type: String,
          reflectToAttribute: true
        },
        valuePath: {
          type: String,
          reflectToAttribute: true
        },
        sourceProperty: {
          type: String,
          reflectToAttribute: true
        },
        mapFn: {
          type: Function
        },
        noValue: {
          type: Boolean,
          reflectToAttribute: true
        }
      };
    }
    static get observers() {
      return ["__deprecatedWatcher(sourceProperty, valuePath, fieldPath)"];
    }
    connectedCallback() {
      super.connectedCallback();
      this.setAttribute("hidden", "hidden");
      this._registerBehavior("BehaviorAssignment");
    }
    _unlinkReferences() {
      this._pullSourceEl = void 0;
      this._sourceEl = void 0;
      this.source = void 0;
      this.sink = void 0;
    }
    __deprecatedWatcher(sourceProperty, valuePath, fieldPath) {
      if (valuePath && sourceProperty != valuePath) {
        this.sourceProperty = valuePath;
      } else if (fieldPath && sourceProperty != fieldPath) {
        this.sourceProperty = fieldPath;
      }
    }
    _invoke(value, event = document.createEvent("CustomEvent")) {
      if (this.disabled) {
        return Promise.resolve("disabled");
      }
      const sink = this.sink instanceof HTMLElement ? [this.sink] : this.sink;
      const sinkEls = this._sinkEl = this._lookupNodes(sink, this.nsSink);
      if (f1.is.empty(sinkEls)) {
        return Promise.resolve(this.__attemptRelink(`binding sink invalid: ${this.toString()}`));
      }
      const sinkEl0 = f1.safe({}, f1.nth(0, sinkEls));
      const autoBindingSink = sinkEl0.autoBinding;
      const field = this.field = this.field || sinkEl0.getAttribute("override-field") || autoBindingSink && autoBindingSink["slot"] || autoBindingSink?.field;
      if (!field) {
        return Promise.resolve(this.__attemptRelink(`binding field invalid: ${this.toString()}`));
      }
      const sinkProperty = this.sinkProperty || "";
      const fieldSeparator = sinkProperty[0] === "." ? "" : ".";
      const fullField = sinkProperty ? `${field}${fieldSeparator}${sinkProperty}` : `${field}`;
      if (sinkEls.length === 1) {
        return this.__invokeOnSink(sinkEl0, fullField, value, event);
      }
      return ifn.map((sinkEl) => this.__invokeOnSink(sinkEl, fullField, value, event), sinkEls);
    }
    __attemptRelink(reason) {
      return reason;
    }
    __invokeOnSink(sinkEl, field, value, event) {
      try {
        const _value = this.__getPullSourceValue(value);
        const __value = this.__getValue(_value);
        if (__value === void 0) {
          throw new Error("no value");
        }
        const children = this.children;
        const ___value = this.__descendPath(__value, this.sourceProperty);
        const ____value = HIP.data.applyModifiers(children, ___value, this._sourceEl);
        const _____value = HIP.data.applyConditions(children, ____value, this._sourceEl);
        const conditionWasFalse = _____value === void 0;
        if (conditionWasFalse) {
          return Promise.resolve(_____value);
        }
        const context = {
          $source: this._sourceEl,
          $sink: sinkEl,
          $event: event,
          output: _____value,
          input: _____value,
          event
        };
        if (typeof this["source"] === "string") {
          context[this["source"]] = this._sourceEl;
        }
        if (typeof this.sink === "string") {
          context[this.sink] = sinkEl;
        }
        if (this._pullSourceEl) {
          context[this.pullSource] = this._pullSourceEl;
        }
        if (this.inject) {
          const inject = this.inject;
          for (let i = 0; i < inject.length; i++) {
            context[inject[i]] = HIP.browser.queryElementId(inject[i], this.ns);
          }
        }
        HIP.data.applyExpressions(sinkEl);
        let output;
        if (this.noValue === true) {
        } else if (this.constant === "~@") {
          console.warn(`[deprecation] (${this.componentName}) use \`no-value\` and not \`constant=~@`);
        } else if (typeof this.mapFn === "function") {
          output = this.mapFn(context);
        } else if (this.__code != null && this.__code.length > 0 && typeof super["invoke"] === "function") {
          output = super["invoke"].call(this, context);
        } else {
          output = context.output;
        }
        if (output instanceof Promise) {
          return output.then((promiseOutput) => {
            return this.__commitOutput(sinkEl, field, promiseOutput, event);
          }).catch((error) => {
            ess.ele(this, {
              status: "failure",
              action: "assign",
              data: {
                binding: this.memento(),
                error,
                event
              }
            });
            return Promise.reject(void 0);
          });
        } else {
          return this.__commitOutput(sinkEl, field, output, event);
        }
      } catch (error) {
        const data = {
          binding: this.memento(),
          error,
          event
        };
        if (error.message === "no value") {
          ess.ele(this, {
            status: "failure",
            action: "assign",
            reason: "no value",
            data
          });
        } else if (!sinkEl) {
          ess.ele(this, {
            status: "warning",
            action: "assign",
            reason: "no sink",
            data
          });
        } else if (error.constructor.name === "GuardError") {
          ess.ele(this, {
            status: "info",
            action: "guarded",
            reason: "guard stopped value from throwing through assignment",
            data
          });
        } else {
          ess.ele(this, {
            status: "fatal",
            action: "assign",
            data
          });
        }
        return Promise.reject(void 0);
      }
    }
    __commitOutput(sinkEl, field, output, event) {
      const children = this.children;
      return HIP.data.runTasks(children, output, event).then(() => HIP.data.assignTo(sinkEl, field, output, event)).then((v) => {
        ess.ele(this, {
          action: "assign",
          data: {
            memento: this.memento(),
            output,
            event
          }
        });
        return v;
      });
    }
    __getPullSourceValue(existingValue) {
      this._pullSourceEl = void 0;
      if (!this.pullSource) {
        return existingValue;
      }
      const pullSourceEl = this._pullSourceEl = HIP.browser.queryOne(this.pullSource, this.ns);
      if (pullSourceEl == null) {
        return existingValue;
      }
      const eventKey = this.pullField || pullSourceEl.autoBinding.signal || "";
      const eventValue = HIP.data.eventAsValueOf(eventKey, pullSourceEl);
      if (eventValue != null) {
        return eventValue;
      }
      const eventMethod = HIP.data.eventAsMethodOf(eventKey, pullSourceEl);
      if (eventMethod != null) {
        return eventMethod;
      }
      const pullElValue = HIP.data.invokeOn(eventKey, pullSourceEl);
      if (pullElValue != null) {
        return pullElValue;
      }
      return existingValue;
    }
    __getValue(value) {
      if (this.expression !== void 0) {
        return HIP.data.evaluateExpression(this.expression, this);
      } else if (this.constant !== void 0) {
        return this.constant;
      } else if (value && f1.is.in("model", value)) {
        return f1.read("/model/__data/item", void 0, value);
      } else {
        return value;
      }
    }
    __descendPath(value, path) {
      return path && path.length > 0 ? f1.read(f1.path(path), void 0, value) : value;
    }
    __injectChanged(inject) {
      if (f1.is.string(inject)) {
        this.inject = inject.split(",");
      }
    }
    memento() {
      return {
        pullSource: this.pullSource,
        pullField: this.pullField,
        sourceProperty: this.sourceProperty,
        sinkProperty: this.sinkProperty,
        expression: this.expression,
        constant: this.constant,
        inject: this.inject,
        field: this.field,
        sink: this.sink,
        signal: this.signal,
        source: this.source,
        bound: this.bound,
        sourceField: this.sourceField,
        id: this.id
      };
    }
    toString() {
      return `${this.source || "--"}:${this.signal || this.sourceField || "--"} =>> ${this.sink || "--"}:${this.field || "--"}`;
    }
    _lookupNode(nodeId, namespace = this.ns) {
      return HIP.browser.queryOne(nodeId, namespace, this);
    }
    _lookupNodes(nodesId, namespace = this.ns) {
      return HIP.browser.queryAll(nodesId, namespace, this);
    }
  }
  return HIP.factory.mixin(BehaviorAssignment2);
}
export const BehaviorAssignment = dedupingMixin(BaseBehaviorAssignment);
HIP["BehaviorAssignment"] = BehaviorAssignment;
