
import { afterNextRender } from '../../../hip/library/polymer/polymer.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorContainer(Base) {
  class BehaviorContainer2 extends BehaviorBehavior(Base) {
    constructor() {
      super(...arguments);
      this.__hiddenChildren = [];
      this.__slotChildren = [];
      this.__allChildren = [];
      this.__slotChildValue = void 0;
      this.__slotChildValueFormatted = "";
    }
    static get properties() {
      return {
        allowBubbling: {
          type: Boolean,
          attribute: "allow-bubbling"
        }
      };
    }
    get _items() {
      return this.$ ? this.$.items : this.shadowRoot?.querySelector("#items");
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorContainer");
      if (this["__onSlotChanged"]) {
        this.__onSlotChangedBound = this["__onSlotChanged"].bind(this);
      } else if (this._onSlotChanged) {
        this.__onSlotChangedBound = this._onSlotChanged.bind(this);
      }
      if (this.$) {
        afterNextRender(this, function() {
          this.__attachSlotChangeHandler();
        });
      }
      this.addEventListener("value-notified", this._onValueNotified);
    }
    firstUpdated() {
      this.__attachSlotChangeHandler();
    }
    __attachSlotChangeHandler() {
      if (this.__onSlotChangedBound && this._items) {
        this._items.addEventListener("slotchange", this.__onSlotChangedBound);
        this.__onSlotChangedBound(new CustomEvent("invoke-first"));
      }
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      if (this.__onSlotChangedBound && this._items) {
        this._items.removeEventListener("slotchange", this.__onSlotChangedBound);
      }
      this.__slotChildren = [];
      this.__hiddenChildren = [];
      this.__allChildren = [];
    }
    get allChildren() {
      return this.__allChildren || [];
    }
    get slotChildren() {
      return this.__slotChildren || [];
    }
    get hiddenChildren() {
      return this.__hiddenChildren || [];
    }
    get firstSlotChild() {
      return this.slotChildren[0];
    }
    get firstSlotChildValue() {
      return this.__slotChildValue;
    }
    get hasAnySlotChildren() {
      return this.slotChildren.length >= 1;
    }
    _onSlotChanged() {
      this.refreshContainer();
    }
    _onValueNotified(event) {
      const valueChild = event.detail.srcElement;
      const value = event.detail.value;
      const valueFormatted = event.detail.valueFormatted || valueChild.valueFormatted || (value != null ? value + "" : "");
      if (valueChild === this) {
        return void 0;
      }
      if (!this.allowBubbling) {
        event.stopPropagation();
      }
      this.__slotChildValueFormatted = valueFormatted;
      this.__slotChildValue = value;
      return value;
    }
    refresh() {
      return this._readSlotChildren();
    }
    refreshContainer() {
      return this._readSlotChildren();
    }
    _readSlotChildren(elSlot, nodeFilter = dom.is.node) {
      elSlot = elSlot || this._items;
      if (!elSlot || typeof elSlot["assignedNodes"] !== "function") {
        return this.__slotChildren = [];
      }
      const templateTags = ["dom-repeat", "dom-if", "hi-repeat", "hi-custom", "hi-iterator", "vi-loop"];
      const isValidElement = dom.is.element;
      const _slotChildren = this._importChildren(elSlot, nodeFilter);
      const _validChildren = _slotChildren.filter(
        (el) => !el.hasAttribute("exclude") && isValidElement(el)
      );
      this.__hiddenChildren = _validChildren.filter(
        (node) => dom.is.someTag(templateTags, node)
      );
      this.__slotChildren = _validChildren.filter(
        (node) => !dom.is.someTag(templateTags, node)
      );
      this.__allChildren = _slotChildren;
      if (f1.read("/features/behavior-container/index-children", void 0, this) !== false) {
        this.__indexChildren();
      }
      return this.__slotChildren;
    }
    __indexChildren() {
      const slotChildren = this.__slotChildren;
      slotChildren.forEach((el, index) => {
        el.removeAttribute("index-first");
        el.removeAttribute("index-last");
        el["index"] = index;
      });
      const firstIndex = 0;
      if (slotChildren[firstIndex]) {
        slotChildren[firstIndex].setAttribute("index-first", `${firstIndex}`);
      }
      const lastIndex = slotChildren.length - 1;
      if (slotChildren[lastIndex]) {
        slotChildren[lastIndex].setAttribute("index-last", `${lastIndex}`);
      }
    }
    _importChildren(elSlot, nodeFilter = dom.is.node) {
      return elSlot.assignedNodes({
        flatten: false
      }).filter(nodeFilter);
    }
    _lookupChild(el) {
      return this.slotChildren[this.__getIndex(el)];
    }
    _getChildNextSibling(el) {
      return this.slotChildren[this.__getIndex(el) + 1];
    }
    _getChildPreviousSibling(el) {
      return this.slotChildren[this.__getIndex(el) - 1];
    }
    __getIndex(el) {
      return el["index"];
    }
    _hasSlotChildren(n) {
      return this.slotChildren && this.slotChildren.length === n;
    }
    _container_proxyToFirstChild_onKeyAny(event) {
      if (this.hasAnySlotChildren) {
        this.firstSlotChild.dispatchEvent(event);
        this._dispatchProcess(`${event.key.replace("Arrow", "").toLowerCase()}-${event.type}`, event.detail);
      }
    }
  }
  return HIP.factory.mixin(BehaviorContainer2);
}
export const BehaviorContainer = dedupingMixin(BaseBehaviorContainer);
HIP["BehaviorContainer"] = BehaviorContainer;
