
import { css } from '../../../hip/library/lit-element/lit-element.js';
export const styles = css`
  :host {
    position: relative;
    display: block;
  }

  :host([kind='flow']) {
    display: flex;
  }

  :host([kind='no-flow']) {
    display: block;
  }

  :host([flow='left-right']) {
    flex-direction: row;
  }

  :host([flow='right-left']) {
    flex-direction: row-reverse;
  }

  :host([flow='top-bottom']) {
    flex-direction: column;
  }

  :host([flow='bottom-top']) {
    flex-direction: column-reverse;
  }

  :host([wrap][flow='left-right']),
  :host([wrap][flow='top-bottom']) {
    flex-wrap: wrap;
  }

  :host([wrap][flow='right-left']),
  :host([wrap][flow='bottom-top']) {
    flex-wrap: wrap-reverse;
  }
`;
const template = document.createElement("template");
template.innerHTML = `<dom-module id="hi-behavior-flow">
  <template>
    <style>
      ${styles.cssText}
    </style>
  </template>
</dom-module>`;
document.head.appendChild(template.content);
