
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import './hi-visitor-format-fallback.js';
export function BaseBehaviorFormat(Base) {
  class BehaviorFormat2 extends BehaviorBehavior(Base) {
    static get properties() {
      return {
        formatter: {
          type: String,
          reflectToAttribute: true
        },
        formatterRule: Object
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorFormat");
    }
    _format__applyFormatter(value, formatter = this.formatter, formatterRule = this.formatterRule) {
      return HIP.fn.format(value, formatter, formatterRule);
    }
  }
  HIP.fn.format = function(value, formatter, formatterRule = {}) {
    if (!formatter) {
      return value;
    }
    const formatVisitor = HIP.visitor.query(
      {
        entity: "format",
        render_type: formatter
      },
      "format"
    );
    return formatVisitor ? formatVisitor.build(value, formatterRule) : value;
  };
  return HIP.factory.mixin(BehaviorFormat2);
}
export const BehaviorFormat = dedupingMixin(BaseBehaviorFormat);
HIP["BehaviorFormat"] = BehaviorFormat;
