
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import {
  HIP,
  BehaviorElement
} from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorContainer } from '../../../eip/element/hi-behavior-container/hi-behavior-container.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { ServiceNamespace } from '../../../eip/element/hi-component/hi-component.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorItemGroup(Base) {
  class BehaviorItemGroup2 extends BehaviorContainer(BehaviorBehavior(BehaviorElement(Base))) {
    constructor(_groupName = "group") {
      super();
      this.groupName = _groupName;
    }
    static get properties() {
      return {
        group: {
          type: String,
          reflectToAttribute: true,
          reflect: true,
          observer: "_groupChanged"
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorItemGroup");
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      f1.map((grp) => this._group__remove(grp), this.__get_groups());
    }
    set groupName(_groupName) {
      this._groupName = _groupName;
    }
    get groupName() {
      return this._groupName;
    }
    __get_groups(group = this.group) {
      return group ? group.split(",") : [];
    }
    _nsChanged(ns, nsOld) {
      super._nsChanged(ns, nsOld);
      const hasInvalidOldNS = f1.is.nil(nsOld);
      if (hasInvalidOldNS) {
        nsOld = ServiceNamespace["defaultNS"];
      }
      const group = this.group;
      const groups = this.__get_groups(group);
      f1.map((grp) => this._group__remove(grp, nsOld), groups);
      f1.map((grp) => this._group__add(grp), groups);
    }
    _groupChanged(group, groupOld) {
      f1.map((grp) => this._group__remove(grp), this.__get_groups(groupOld));
      f1.map((grp) => this._group__add(grp), this.__get_groups(group));
    }
    _group__remove(group, ns = this.ns) {
      if (group) {
        HIP.db.group.removeKey(this._group__groupName(), this, ns);
        HIP.hooks.invoke(`removed-${this._group__groupName(group)}`, this, this);
      }
    }
    _group__add(group, ns = this.ns) {
      if (group) {
        HIP.db.group.addKey(this._group__groupName(), this, ns);
        HIP.hooks.invoke(`added-${this._group__groupName(group)}`, this, this);
      }
    }
    _group__stateChanged() {
      f1.map((grp) => HIP.hooks.invoke(`changed-${this._group__groupName(grp)}`, this, this), this.__get_groups());
    }
    _group__groupName(group = this.group) {
      return `${this._groupName}-${group}`;
    }
    _group__groupSet() {
      return f1.reduce(
        (groups, grp) => groups.concat(HIP.db.group.queryAll(this._group__groupName(grp), this.ns)),
        [],
        this.__get_groups(this.group)
      );
    }
  }
  return HIP.factory.mixin(BehaviorItemGroup2);
}
export const BehaviorItemGroup = dedupingMixin(BaseBehaviorItemGroup);
HIP["BehaviorItemGroup"] = BehaviorItemGroup;
