
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import {
  HIP,
  BehaviorElement
} from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { ServiceNamespace } from '../../../eip/element/hi-component/hi-component.js';
import { inputService } from '../../../eip/element/hi-behavior-input/hi-service-input.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorSetGroup(Base) {
  class BehaviorSetGroup2 extends BehaviorBehavior(BehaviorElement(Base)) {
    constructor(_groupName = "group") {
      super();
      this.setChildren = [];
      this.totalCount = 0;
      this.valueAttr = "value";
      this.__forceEl = 0;
      this.__force = 0;
      this.groupName = _groupName;
    }
    static get properties() {
      return {
        group: {
          type: String,
          reflectToAttribute: true,
          reflect: true,
          observer: "_groupChanged"
        },
        setChildren: {
          type: Array
        },
        totalCount: {
          type: Number,
          reflectToAttribute: true,
          reflect: true,
          notify: true,
          attribute: "total-count",
          computed: "__totalCountCompute(__forceEl)"
        },
        valueAttr: {
          type: String,
          attribute: "value-attr"
        },
        __force: {
          type: Number
        },
        __forceEl: {
          type: Number
        }
      };
    }
    set groupName(_groupName) {
      this._groupName = _groupName;
    }
    get groupName() {
      return this._groupName;
    }
    __get_groups(group = this.group) {
      return group ? group.split(",") : [];
    }
    connectedCallback() {
      super.connectedCallback();
      this.setAttribute("role", "group");
      this._registerBehavior("BehaviorSetGroup");
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      f1.map((grp) => this.__unregisterHook(grp), this.__get_groups());
    }
    update(props) {
      super.update(props);
      this.totalCount = this.__totalCountCompute();
    }
    _group__slotChange() {
      this.refresh();
      this._group__slotChange__captureGroup();
      this._group__slotChange__applyGroup();
      this._group__slotChange__tetherLabels();
      this._group__slotChange__ensureForOnLabel();
      this._group__slotChange__requestUpdate();
    }
    _group__slotChange__captureGroup() {
      if (this.group) {
        return;
      }
      const firstSlotChild = this.firstSlotChild;
      if (this.hasAnySlotChildren && firstSlotChild.group !== void 0) {
        this.group = firstSlotChild.group;
      } else {
        this.group = `auto-group-${f1.id()}`;
      }
      this._forceRegisterHooks(this.group, this.group);
    }
    _group__slotChange__applyGroup() {
      const groupTagName = this.nodeName.substring(0, this.nodeName.indexOf("-GROUP"));
      const group = f1.safe(this.getAttribute("group"), this.group);
      if (!group) {
        return;
      }
      this.slotChildren.filter((item) => item.nodeName === groupTagName).forEach((item) => {
        item.setAttribute("group", group);
        item.group = group;
      });
    }
    _group__slotChange__tetherLabels() {
      inputService.tetherLabels(this);
    }
    _group__slotChange__ensureForOnLabel() {
      Array.from(this.slotChildren).forEach((el, index, list) => {
        if (el.componentName === "hi-label") {
          const groupItemEl = list[index - 1];
          if (!groupItemEl) {
            return;
          }
          dom.ensureAttr(groupItemEl, "id");
          if (groupItemEl && !el.hasAttribute("for")) {
            el.setAttribute("for", groupItemEl.id);
          }
        }
      });
    }
    _group__slotChange__requestUpdate() {
      const litEl = this;
      if (f1.is.in("requestUpdate", litEl)) {
        litEl.requestUpdate("selectedIndex");
      }
      this.__forceEl += 1;
    }
    _nsChanged(ns, nsOld) {
      super._nsChanged(ns, nsOld);
      const hasInvalidOldNS = f1.is.nil(nsOld);
      if (hasInvalidOldNS) {
        nsOld = ServiceNamespace["defaultNS"];
      }
      const group = this.group;
      const groups = this.__get_groups(group);
      f1.map((grp) => this.__unregisterHook(grp, nsOld), this.__get_groups(group));
      f1.map((grp) => this.__registerHook(grp), this.__get_groups(group));
    }
    _groupChanged(group, groupOld) {
      this._forceRegisterHooks(group, groupOld);
      this._group__slotChange();
    }
    _forceRegisterHooks(group, groupOld) {
      f1.map((grp) => this.__unregisterHook(grp), this.__get_groups(groupOld));
      f1.map((grp) => this.__registerHook(grp), this.__get_groups(group));
    }
    __registerHook(group, ns) {
      if (group) {
        const _group = this._group__groupName(group);
        HIP.hooks.registerElement(
          this,
          {
            [`changed-${_group}`]: `_group__itemChanged`,
            [`removed-${_group}`]: `_group__itemRemoved`,
            [`added-${_group}`]: `_group__itemAdded`
          },
          ns
        );
      }
    }
    __unregisterHook(groupOld, ns) {
      if (groupOld) {
        const _groupOld = this._group__groupName(groupOld);
        HIP.hooks.unregisterElement(
          this,
          {
            [`changed-${_groupOld}`]: `_group__itemChanged`,
            [`removed-${_groupOld}`]: `_group__itemRemoved`,
            [`added-${_groupOld}`]: `_group__itemAdded`
          },
          ns
        );
      }
    }
    _group__itemChanged(hook, el) {
      this.__force += 1;
      this._dispatchProcess("item-changed", {
        groupName: this.groupName,
        item: el,
        hook
      });
    }
    _group__itemRemoved(hook, el) {
      const elIndex = (this.setChildren || []).indexOf(el);
      if (elIndex >= 0) {
        this.setChildren.splice(elIndex, 1);
        this.__force += 1;
        this.__forceEl += 1;
        this._dispatchProcess("item-removed", {
          groupName: this.groupName,
          item: el,
          hook
        });
      }
    }
    _group__itemAdded(hook, el) {
      this.setChildren.push(el);
      this.__force += 1;
      this.__forceEl += 1;
      this._dispatchProcess("item-added", {
        groupName: this.groupName,
        item: el,
        hook
      });
    }
    _group__groupName(group = this.group) {
      return `${this._groupName}-${group}`;
    }
    _group__groupSet() {
      return f1.reduce(
        (groups, grp) => groups.concat(HIP.db.group.queryAll(this._group__groupName(grp), this.ns)),
        [],
        this.__get_groups(this.group)
      );
    }
    __totalCountCompute() {
      return f1.size(this._group__groupSet());
    }
  }
  return HIP.factory.mixin(BehaviorSetGroup2);
}
export const BehaviorSetGroup = dedupingMixin(BaseBehaviorSetGroup);
HIP["BehaviorSetGroup"] = BehaviorSetGroup;
