
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
export function BaseBehaviorImperativeElement(Base) {
  class ImperativeElement extends BehaviorBehavior(Base) {
    static get properties() {
      return {
        returnVariable: {
          type: String,
          value: "output"
        },
        output: {
          type: Object,
          notify: true
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("ImperativeElement");
      const code = Array.from(this.childNodes).filter((node) => node.nodeName === "#text").reduce((code2, node) => code2 + node.data, "");
      this.__code = (code == null ? "" : code).trim();
    }
    get code() {
      return this.__code;
    }
    invoke(context = {}, returnVariable = "output") {
      const _returnVariable = this.returnVariable || returnVariable;
      const code = this.__code;
      if (code) {
        return $ip.unsafe(code, context, _returnVariable);
      } else {
        return context[_returnVariable];
      }
    }
  }
  return HIP.factory.mixin(ImperativeElement);
}
export const BehaviorImperativeElement = dedupingMixin(BaseBehaviorImperativeElement);
HIP["BehaviorImperativeElement"] = BehaviorImperativeElement;
