
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { BehaviorInput } from './hi-behavior-input.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
export function BaseBehaviorInputTime(Base) {
  class BehaviorInputTime2 extends BehaviorInput(BehaviorBehavior(Base)) {
    static get properties() {
      return {
        max: {
          type: String
        },
        min: {
          type: String
        },
        step: {
          type: Number
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorInputTime");
    }
    get willValidate() {
      return this.novalidate !== true && (this.required != null || this.max != null || this.min != null);
    }
    get validity() {
      const rangeUnderflow = this.__isRangeUnderflow();
      const rangeOverflow = this.__isRangeOverflow();
      const valueMissing = this.__isValueMissing();
      const typeMismatch = this.__isTimeInvalid();
      return this._computeValidity({
        rangeUnderflow,
        rangeOverflow,
        valueMissing,
        typeMismatch
      });
    }
    __isValueMissing() {
      return this.required && this.value == null;
    }
    __isTimeInvalid() {
      return this.value != null && this.parseTime(this.value).isValid() === false;
    }
    __isRangeUnderflow() {
      return this.min == null ? false : this.value != null && this.parseTime(this.value).diff(this.parseTime(this.min)) < 0;
    }
    __isRangeOverflow() {
      return this.max == null ? false : this.value != null && this.parseTime(this.value).diff(this.parseTime(this.max)) > 0;
    }
    parseTime(time, format = this.timeFormat || "h:mm A") {
      if (typeof time === "object") {
        return time;
      }
      return time === "now" ? window.moment() : window.moment(time, format);
    }
  }
  return HIP.factory.mixin(BehaviorInputTime2);
}
export const BehaviorInputTime = dedupingMixin(BaseBehaviorInputTime);
HIP["BehaviorInputTime"] = BehaviorInputTime;
