
import { afterNextRender } from '../../../hip/library/polymer/polymer.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { Debouncer } from '../../../hip/library/polymer/polymer.js';
import { microTask } from '../../../hip/library/polymer/polymer.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorIO(Base) {
  class BehaviorIO2 extends BehaviorBehavior(Base) {
    static get properties() {
      return {
        __forceIO: Number,
        parameters: {
          type: Object,
          notify: true
        },
        argument: {
          type: Object
        },
        autoInvoke: {
          type: Boolean,
          reflectToAttribute: true
        },
        initial_value: {
          type: Object
        },
        input: {
          type: Object,
          observer: "_inputChanged"
        },
        output: {
          type: Object,
          notify: true,
          computed: "_outputCompute(input, __forceIO)"
        },
        confirmation: {
          type: Object
        },
        disabledExpressions: {
          type: Boolean,
          reflectToAttribute: true
        }
      };
    }
    static get observers() {
      return ["__parametersWatcher(parameters)"];
    }
    static get api() {
      return ["trigger", "append", "delete", "invoke", "flush", "clear", "pump", "size", "nth"];
    }
    connectedCallback() {
      super.connectedCallback();
      this.setAttribute("x-io", "");
      this._registerBehavior("BehaviorIO");
      if (this.initial_value != null && !this.autoInvoke) {
        this.input = this.initial_value;
      }
      if (this.autoInvoke) {
        afterNextRender(this, () => {
          this.invoke(this.initial_value || {});
        });
      }
    }
    _inputChanged(input) {
    }
    _process(argument) {
      return argument;
    }
    __parametersWatcher() {
      HIP.data.applyExpressions(this);
    }
    _outputCompute(_input) {
      if (this.disabled) {
        return this.output;
      }
      if (this.__passive__) {
        this.__passive__ = false;
        return HIP.util.clone(this.output);
      }
      if (_input == null) {
        return this.output;
      } else if (this.__io_mutexInput__) {
        this.__io_mutexInput__ = false;
        return _input;
      }
      const __input = HIP.data.applyConditions(
        this.children,
        _input,
        this
      );
      const ___input = __input != null ? HIP.data.applyModifiers(
        this.children,
        __input,
        this
      ) : __input;
      const output = ___input;
      if (HIP.data.hasMutator(this.children)) {
        this.__io_mutexInput__ = true;
        this.input = output;
      }
      this._dispatchProcess("update", {
        value: this.input
      });
      this.__outputWasCalculated = true;
      return output;
    }
    size() {
      return f1.size(this.output);
    }
    delete(index) {
      if (f1.is.array(this.output)) {
        this.output = this.output.splice(index, 1);
      } else if (f1.is.record(this.output)) {
        delete this.output[index];
      }
      return this.output;
    }
    first() {
      return this.nth(0);
    }
    last() {
      return this.nth(-1);
    }
    nth(index) {
      return f1.nth(index, f1.values(f1.safe({}, this.output)));
    }
    pump() {
      return this.flush();
    }
    wake() {
      this.__passive__ = true;
      this.flush();
    }
    flush() {
      this.__inputIODebouncer = Debouncer.debounce(this.__inputIODebouncer, microTask, () => {
        this.__forceRefresh();
      });
    }
    __forceRefresh() {
      this.__forceIO = (this.__forceIO || 0) + 1;
    }
    clear() {
      return this.invoke({});
    }
    trigger(input) {
      return this.__update(input);
    }
    invoke(input) {
      if (this.disabled) {
        return Promise.resolve();
      }
      if (this.confirmation == null) {
        return this.__update(input);
      }
      return HIP.fn.confirmation(this.confirmation).then(() => this.__update(input)).catch(() => null);
    }
    append(input) {
      return this.combine(input);
    }
    combine(input) {
      return this.__update(input, (input2) => HIP.data.concatenate(this.input, input2));
    }
    __update(input, fn = (u) => u) {
      this.__outputWasCalculated = false;
      input = this._applyArgument(input);
      input = this._process(input);
      if (input != null) {
        this.input = fn(input);
      }
      if (!this.__outputWasCalculated) {
        this.__forceRefresh();
      }
      return this.output;
    }
    _applyArgument(argument) {
      this.argument = argument;
      if (!this.disabledExpressions) {
        HIP.data.applyExpressions(this);
      }
      return argument;
    }
    toString() {
      try {
        return JSON.stringify(this.output, null, 2);
      } catch (e) {
        return `output cannot stringify`;
      }
    }
  }
  return HIP.factory.mixin(BehaviorIO2);
}
export const BehaviorIO = dedupingMixin(BaseBehaviorIO);
HIP["BehaviorIO"] = BehaviorIO;
