
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP, BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
export function BaseBehaviorMirror(Base) {
  class BehaviorMirror2 extends BehaviorBehavior(BehaviorElement(Base)) {
    get valueEventChannel() {
      return "form";
    }
    static get properties() {
      return {
        html5: {
          type: String
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorMirror");
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      this.__disconnectMirroredInput();
    }
    attributeChangedCallback(name, valueOld, valueNew) {
      super.attributeChangedCallback(name, valueOld, valueNew);
      this.__reflectAttributesToMirroredInput(name, valueOld, valueNew);
    }
    _internalInput() {
      return {};
    }
    get inputMirrorType() {
      return "";
    }
    isMirrored() {
      return !!this.html5;
    }
    __findForm(html5) {
      const explicitFormEl = html5.length > 0 ? dom.queryOne(html5, document.body) : void 0;
      return explicitFormEl || this.closest("form");
    }
    __defineMirroredInput(formEl) {
      let input;
      if (this.inputMirrorType == "textarea") {
        input = document.createElement("textarea");
        input.style.display = "none";
      } else {
        input = document.createElement("input");
        input.style.display = "none";
      }
      this.__mirroredInput = this.__mirroredInput || input;
      formEl.appendChild(this.__mirroredInput);
    }
    __getAllAttributes(el) {
      const attrNames = el.getAttributeNames();
      return attrNames.reduce((obj, name) => {
        obj[name] = el.getAttribute(name);
        return obj;
      }, {});
    }
    __reflectAttributesToMirroredInput(name, valueOld, valueNew) {
      const html5 = this.html5;
      if (f1.is.nil(html5)) {
        return;
      }
      const formEl = this.__findForm(html5);
      if (f1.is.nil(formEl)) {
        return;
      }
      if (!this.__mirroredInput) {
        this.__defineMirroredInput(formEl);
      }
      dom.setAttrs(this.__mirroredInput, this.__pullInputAttributes());
    }
    __pullInputAttributes() {
      const hasInternalInput = this._internalInput();
      let type = this.inputMirrorType;
      let value = this.value;
      let checked;
      if (type === "checkbox") {
        value = this.checked ? "true" : "false";
        checked = this.checked ? true : false;
      } else if (type === "radio") {
        this.name = this.getAttribute("name");
        checked = this.checked ? true : false;
        this.__mirroredInput.checked = this.checked;
      } else if (type === "textarea" && !f1.is.undefined(value)) {
        this.__mirroredInput.innerHTML = value;
      } else if (type === "select") {
        value = this.multiple ? this.values : this.value;
        type = "text";
      }
      const overrideAttrs = {
        id: `mirrored-input-${this.id}-${this.name}`,
        "data-source-input": this.id,
        type,
        value,
        checked,
        name: this.name || this.getAttribute("name") || this.id,
        disabled: this.disabled,
        readonly: this.readonly,
        hidden: true
      };
      if (this.$ && this.$.input) {
        const {
          ["aria-label"]: label,
          ["aria-controls"]: controls,
          ["aria-autocomplete"]: autocomplete,
          role,
          tabindex,
          mixin,
          focusable,
          ...getAllAttributesOfInput
        } = this.__getAllAttributes(hasInternalInput);
        return f1.merge("over", getAllAttributesOfInput, overrideAttrs);
      }
      return overrideAttrs;
    }
    __disconnectMirroredInput() {
      if (this.__mirroredInput) {
        this.__mirroredInput.remove();
      }
    }
  }
  return HIP.factory.mixin(BehaviorMirror2);
}
export const BehaviorMirror = HIP["BehaviorInput"] = dedupingMixin(BaseBehaviorMirror);
