
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { Debouncer } from '../../../hip/library/polymer/polymer.js';
import { microTask } from '../../../hip/library/polymer/polymer.js';
import {
  HIP
} from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
export function BaseBehaviorModifier(Base) {
  class BehaviorModifier2 extends BehaviorBehavior(Base) {
    static get api() {
      return ["modify"];
    }
    static get autoBinding() {
      return {
        signal: "modify-ended",
        field: "value"
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this.setAttribute("hidden", "hidden");
      this._registerBehavior("BehaviorModifier");
    }
    get mutator() {
      return false;
    }
    modify(_input, owner) {
      HIP.data.applyExpressions(this);
      const __input = HIP.data.applyConditions(this.children, _input, this);
      const ___input = __input != null ? this._modify(__input, owner) : __input;
      const output = ___input;
      return output;
    }
    get typeGroup() {
      return this.__typeGroup;
    }
    _ensureTypeGroup() {
      this.__typeGroup = HIP.db.gid.queryOne("type_group", this.ns);
    }
    get source() {
      return this.__source;
    }
    _ensureSource(typeGroupId = "source") {
      this.__source = HIP.db.gid.queryOne(typeGroupId, this.ns);
    }
    __settingsWatcher() {
      this._settingsWatcher();
    }
    _settingsWatcher() {
      const doesRespondToModifiers = this.parentElement && this.parentElement.respondToModifiers;
      if (!doesRespondToModifiers) {
        return;
      }
      this.__settingsDebouncer = Debouncer.debounce(this.__settingsDebouncer, microTask, () => {
        this._dispatchNotification("modified");
      });
    }
  }
  return HIP.factory.mixin(BehaviorModifier2);
}
export const BehaviorModifier = dedupingMixin(BaseBehaviorModifier);
HIP["BehaviorModifier"] = BehaviorModifier;
