
import { afterNextRender } from '../../../hip/library/polymer/polymer.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import ess from '../../../pip/library/pi-ess/pi-ess.js';
export function BaseBehaviorObject(Base) {
  class BehaviorObject2 extends BehaviorBehavior(Base) {
    static get properties() {
      return {
        props: {
          type: Object,
          observer: "__propsChanged",
          value() {
            return {};
          }
        },
        value: {
          type: Object,
          notify: true,
          observer: "_valueChanged",
          computed: "__valueCompute(__forcePropUpdate)"
        },
        __forcePropUpdate: {
          type: Number,
          value: 0
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this.setAttribute("hidden", "hidden");
      this._registerBehavior("BehaviorObject");
      afterNextRender(this, () => {
        this.__observer = new MutationObserver(() => {
          this.refresh();
        });
        this.__observer.observe(this, {
          attributes: true,
          childList: false,
          subtree: false
        });
      });
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      if (this.__observer) {
        this.__observer.disconnect();
      }
    }
    __valueCompute() {
      return BehaviorObject2.value(this);
    }
    _valueChanged(value) {
      this._dispatchNotification("value", {
        value
      });
    }
    __propsChanged() {
      this.refresh();
    }
    refresh() {
      this.__forcePropUpdate += 1;
      return this;
    }
    evaluate() {
      return BehaviorObject2.value(this);
    }
    static value(_node) {
      const propPrefix = "prop-";
      const removePrefix = propPrefix.length;
      const attrs = _node.attributes;
      const kebabToCamel = /(-.)/g;
      const n = attrs.length;
      let value = {};
      try {
        value = JSON.parse(`${_node.getAttribute("props")}`);
      } catch (e) {
        ess.ele(_node, {
          status: "failure",
          action: "parse",
          data: _node.getAttribute("props")
        });
      }
      value = value || {};
      for (let i = 0; i < n; i++) {
        const attr = attrs[i];
        const name = attr.name;
        if (name.indexOf(propPrefix) === 0) {
          const _key = name.slice(removePrefix);
          const key = _key.replace(kebabToCamel, (o) => (o[1] || "").toUpperCase());
          value[key] = HIP.data.attributeToValue(attr.value);
        }
      }
      return value;
    }
    toString() {
      return JSON.stringify(this.value || {});
    }
  }
  return HIP.factory.mixin(BehaviorObject2);
}
export const BehaviorObject = dedupingMixin(BaseBehaviorObject);
HIP["BehaviorObject"] = BehaviorObject;
