
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import './hi-visitor-parse-fallback.js';
export function BaseBehaviorParse(Base) {
  class BehaviorParse2 extends BehaviorBehavior(Base) {
    static get properties() {
      return {
        parser: {
          type: String,
          reflectToAttribute: true
        },
        parserRule: Object
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorParse");
    }
    _parse__applyParser(value, parser = this.parser, parserRule = this.formatterRule) {
      return HIP.fn.parse(value, parser, parserRule);
    }
  }
  HIP.fn.parse = function(value, parser, parserRule) {
    if (!parser) {
      return value;
    }
    const parseVisitor = HIP.visitor.query(
      {
        entity: "parser",
        render_type: parser
      },
      "parse"
    );
    return parseVisitor ? parseVisitor.build(value, parserRule) : value;
  };
  return HIP.factory.mixin(BehaviorParse2);
}
export const BehaviorParse = dedupingMixin(BaseBehaviorParse);
HIP["BehaviorParse"] = BehaviorParse;
