
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import {
  HIP
} from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
export function BaseBehaviorPopout(Base) {
  class BehaviorPopout2 extends BehaviorBehavior(Base) {
    constructor() {
      super(...arguments);
      this.__popperDefaultModifiers = [
        {
          name: "flip",
          options: {
            flipVariations: false,
            fallbackPlacements: ["left-start", "right-start", "left-end", "right-end"]
          }
        },
        {
          name: "computeStyles",
          options: {
            gpuAcceleration: true
          }
        },
        {
          name: "preventOverflow",
          options: {
            padding: 16,
            altBoundary: true
          }
        }
      ];
    }
    static get properties() {
      return {
        placement: {
          type: String,
          value: "auto"
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorPopout");
    }
    _popout_createPopout(from, to, popperReference, popperHolder, popperConfig = {}) {
      dom.ensureAttr(this, "id");
      if (!popperReference) {
        return;
      }
      this.popoutObject = Popper.createPopper(popperReference, popperHolder, {
        placement: this.placement || popperConfig.placement || "auto",
        strategy: popperConfig.strategy || "fixed",
        modifiers: [...this.__popperDefaultModifiers, ...popperConfig.modifiers || []]
      });
      if (this.popoutObject) {
        this.popoutObject.forceUpdate();
      }
    }
    _popout_destroyPopout() {
      if (this.popoutObject && typeof this.popoutObject.destroy === "function") {
        this.popoutObject.destroy();
      }
      this.popoutObject = void 0;
    }
  }
  return HIP.factory.mixin(BehaviorPopout2);
}
export const BehaviorPopout = dedupingMixin(BaseBehaviorPopout);
HIP["BehaviorPopout"] = BehaviorPopout;
