
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorItemFocus(Base) {
  class BehaviorItemFocus2 extends BehaviorBehavior(Base) {
    static get properties() {
      return {
        directMode: {
          type: Boolean
        },
        index: {
          type: Number
        },
        value: {
          type: Object
        },
        focused: {
          type: Boolean,
          observer: "__focusedChanged",
          reflectToAttribute: true,
          notify: true,
          reflect: true
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorItemFocus");
      if (!this.hasAttribute("id")) {
        this.setAttribute("id", "hi-item--" + f1.id());
      }
    }
    _itemFocus__onTap() {
      this.trigger();
    }
    trigger() {
      this.focus();
      this._dispatchBubblingEvent(`set-focus-item-tapped`, {
        index: this.index,
        item: this
      });
    }
    _itemFocus__onMouseEnter() {
    }
    focus() {
      this.focused = true;
    }
    updated(changedProperties) {
      if (changedProperties.has("focused")) {
        const prevFocusedValue = changedProperties.get("focused");
        this.__focusedChanged(this.focused, prevFocusedValue);
      }
    }
    __focusedChanged(focused, oldFocused) {
      if (focused && !oldFocused) {
        this._dispatchBubblingEvent(`set-focus-item-focused`, {
          index: this.index,
          focused,
          item: this
        });
      }
    }
  }
  return HIP.factory.mixin(BehaviorItemFocus2);
}
export const BehaviorItemFocus = dedupingMixin(BaseBehaviorItemFocus);
HIP["BehaviorItemFocus"] = BehaviorItemFocus;
