
import { BehaviorItemFocus } from '../../../eip/element/hi-behavior-set-focus/hi-behavior-item-focus.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
export function BaseBehaviorItemSelect(Base) {
  class BehaviorItemSelect2 extends BehaviorItemFocus(Base) {
    static get properties() {
      return {
        selected: {
          type: Boolean,
          observer: "_selectedChanged",
          reflectToAttribute: true,
          notify: true
        }
      };
    }
    static get api() {
      return ["select", "deselect"];
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorItemSelect");
      this.setAttribute("aria-selected", "false");
    }
    select() {
      this.selected = true;
    }
    deselect() {
      this.selected = false;
    }
    deactivate() {
      return this;
    }
    activate() {
      return this;
    }
    _selectedChanged(selected) {
      if (!this.directMode && selected != null) {
        this._dispatchBubblingEvent(`set-item-selected`, {
          index: this.index,
          item: this,
          selected
        });
      }
      this.setAttribute("aria-selected", `${!!selected}`);
    }
  }
  return HIP.factory.mixin(BehaviorItemSelect2);
}
export const BehaviorItemSelect = dedupingMixin(BaseBehaviorItemSelect);
HIP["BehaviorItemSelect"] = BehaviorItemSelect;
