
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BaseBehaviorItemFocus } from '../../../eip/element/hi-behavior-set-focus/hi-behavior-item-focus.js';
import { TreeService } from './hi-service-tree.js';
import '../../../eip/element/hi-behavior-set-focus/hi-behavior-item-focus.js';
export function BehaviorItemTreeBehavior(Base) {
  class BehaviorItemTree2 extends BaseBehaviorItemFocus(Base) {
    constructor() {
      super(...arguments);
      this.of = "leaf";
    }
    static get properties() {
      return {
        of: {
          type: String,
          readOnly: true,
          value: "leaf"
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorItemTree");
    }
    __focusedChanged(focused, oldFocused) {
      if (this.readonly) {
        this.focused = false;
        return;
      }
      super.__focusedChanged(focused, oldFocused);
      if (!this.tree) {
        return;
      }
      this.tree.slotChildren.forEach((o) => {
        o.active = false;
      });
      this.active = true;
    }
    _itemTree__onTap(e) {
      super._itemFocus__onTap(e);
      this.focused = true;
      TreeService.notifyOfSelection(this.tree, this);
      this.tree.opened = false;
    }
    _itemTree__onMouseEnter(e) {
      super._itemFocus__onMouseEnter(e);
      this.focused = true;
    }
    get tree() {
      return this.closest('[of="tree"]');
    }
    get parent() {
      return this.parentNode;
    }
  }
  return HIP.factory.mixin(BehaviorItemTree2);
}
export const BehaviorItemTree = dedupingMixin(BehaviorItemTreeBehavior);
HIP["BehaviorItemTree"] = BehaviorItemTree;
