
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorItemFocus } from '../../../eip/element/hi-behavior-set-focus/hi-behavior-item-focus.js';
import { TreeService } from './hi-service-tree.js';
import { BehaviorContainer } from '../../../eip/element/hi-behavior-container/hi-behavior-container.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import './hi-service-tree.js';
export function BehaviorNodeTreeBehavior(Base) {
  class BehaviorNodeTree2 extends BehaviorContainer(BehaviorItemFocus(Base)) {
    constructor() {
      super();
      this.of = "node";
      this.opened = false;
    }
    static get properties() {
      return {
        opened: {
          type: Boolean,
          reflectToAttribute: true,
          observer: "_nodeTree__openedChanged",
          notify: true
        },
        active: {
          type: Boolean,
          reflectToAttribute: true
        },
        of: {
          type: String,
          readOnly: true,
          value: "node"
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorNodeTree");
      this.__nodeId = f1.id();
    }
    _nodeTree__openedChanged(opened) {
      if (!this.hasAnySlotChildren && !opened) {
        return this.opened = false;
      }
      if (this.disabled) {
        return;
      }
      if (!this.tree) {
        return;
      }
      this.tree.slotChildren.forEach((o) => {
        o.active = false;
        o.focused = false;
      });
      const nodeIndex = opened ? this._includeNodes(this) : this._excludeNodes(this);
      this.tree.slotChildren.forEach((o, index) => {
        o.setAttribute("index", `${index}`);
        o.active = false;
      });
      this.focused = true;
      this.active = true;
      this.tree.focusedIndex = nodeIndex;
      return true;
    }
    _includeNodes(tree) {
      return -1;
    }
    _excludeNodes(tree) {
      return -1;
    }
    _setTree__onSlotChanged() {
      const children = this._readSlotChildren();
      this.__leaves = children.filter(TreeService.leafFilter);
      this.__nodes = children.filter(TreeService.nodeFilter);
    }
    get nodeId() {
      return this.__nodeId;
    }
    get tree() {
      return this.closest('[of="tree"]');
    }
    get parent() {
      return this.parentNode;
    }
    get leaves() {
      return this.__leaves;
    }
    get nodes() {
      return this.__nodes;
    }
  }
  return HIP.factory.mixin(BehaviorNodeTree2);
}
export const BehaviorNodeTree = dedupingMixin(BehaviorNodeTreeBehavior);
HIP["BehaviorNodeTree"] = BehaviorNodeTree;
