
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorSetFocus } from '../../../eip/element/hi-behavior-set-focus/hi-behavior-set-focus.js';
import { TreeService } from './hi-service-tree.js';
import './hi-service-tree.js';
export function BehaviorSetTreeBehavior(Base) {
  class BehaviorSetTree2 extends BehaviorSetFocus(Base) {
    constructor() {
      super();
      this._isCollapsible = false;
      this.of = "tree";
      this.opened = false;
      this._isCollapsible = false;
    }
    static get properties() {
      return {
        opened: {
          type: Boolean,
          reflectToAttribute: true,
          observer: "_setTree__openedChanged",
          notify: true
        },
        of: {
          type: String,
          reflectToAttribute: true,
          readOnly: true,
          value: "tree"
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorSetTree");
      this._setTree__onFocusoutBound = this._setTree__onFocusout.bind(this);
      this.addEventListener("focusout", this._setTree__onFocusoutBound);
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      if (this._setTree__onFocusoutBound) {
        this.removeEventListener("focusout", this._setTree__onFocusoutBound);
      }
    }
    expand() {
      this.opened = true;
      this.expandImmediate();
      this.expandChildren();
    }
    collapse() {
      this.collapseChildren();
      this.collapseImmediate();
      this.opened = false;
    }
    expandImmediate() {
      this.refresh().filter(TreeService.nodeFilter).forEach((o) => {
        o.opened = true;
      });
    }
    collapseImmediate() {
      this.refreshContainer().filter(TreeService.nodeFilter).forEach((o) => {
        o.opened = false;
      });
    }
    expandChildren() {
      TreeService.traverseNode(this._noop, (node) => node, this).values.forEach(
        (o) => {
          o.opened = true;
        }
      );
      this.shiftFocusFirst();
    }
    collapseChildren() {
      TreeService.traverseNode(this._noop, (node) => node, this).values.forEach(
        (o) => {
          o.opened = false;
        }
      );
      this.shiftFocusFirst();
    }
    _setTree__openedChanged(_opened) {
      if (_opened) {
        return;
      }
      this.collapseImmediate();
      this.collapseChildren();
      this.clearFocusIndex();
    }
    activate(value, event) {
      this.opened = true;
      this.focus();
    }
    deactivate() {
      this.opened = false;
    }
    toggle() {
      this.opened = !this.opened;
    }
    _setTree__onSlotChanged() {
      this._setFocus__onSlotChanged();
      const children = this.slotChildren;
      this.__originalChildren = children;
      this.__leaves = children.filter(TreeService.leafFilter);
      this.__nodes = children.filter(TreeService.nodeFilter);
    }
    _setTree__onFocusout() {
      if (this._isCollapsible == true) {
        this.collapse();
      }
      this.clearFocusIndex();
    }
    _setFocus__onItemFocused(e) {
      super._setFocus__onItemFocused(e);
    }
    _setFocus__onItemTapped(e) {
      super._setFocus__onItemTapped(e);
    }
    _setTree__onKeyUp_enter() {
      TreeService.notifyOfSelection(this);
    }
    _setTree__onKeyUp_up(e) {
      super._setFocus__onKeyUp_up(e);
    }
    _setTree__onKeyUp_down(e) {
      super._setFocus__onKeyUp_down(e);
    }
    _setTree__onKeyUp_right(e) {
      e.preventDefault();
      this.__toggleFocusedItem(true);
    }
    _setTree__onKeyUp_left(e) {
      e.preventDefault();
      this.__toggleFocusedItem(false);
    }
    _setTree__onKeyUp_esc(e) {
      e.preventDefault();
      this.collapse();
    }
    __toggleFocusedItem(opened) {
      const focusedItem = this._indexToItem(this.focusedIndex);
      if (focusedItem && focusedItem.of === "node") {
        focusedItem.opened = opened;
      }
    }
    get tree() {
      return this.closest('[of="tree"]');
    }
    get parent() {
      return this.parentNode;
    }
    get leaves() {
      return this.__leaves;
    }
    get nodes() {
      return this.__nodes;
    }
  }
  return HIP.factory.mixin(BehaviorSetTree2);
}
export const BehaviorSetTree = dedupingMixin(BehaviorSetTreeBehavior);
HIP["BehaviorSetTree"] = BehaviorSetTree;
