
import { css } from '../../../hip/library/lit-element/lit-element.js';
export const stylesTagBadge = css`
  :host {
    display: inline-flex;
    justify-content: center;
    align-items: center;
    align-content: center;
    min-height: var(--hi-px-20);
    min-width: 2.7ch;
    text-align: center;
    vertical-align: baseline;
    text-transform: none;
    background-color: var(--hi-clr--theme-1);
    color: var(--hi-clr--theme-5);
    padding: var(--hi-px-2) var(--hi-px-6);
    vertical-align: middle;
    font-size: var(--hi-px-13);
    font-variant: small-caps;
    font-weight: var(--hi-font--weight-light);
    line-height: 1;
    border: var(--hi-px-1) solid var(--hi-clr--theme-3);
    border-radius: var(--hi-shape--pill);
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
  }

  :host([hard-edge]) {
    border-radius: var(--hi-shape--radius-2);
  }

  :host([aesthetic='dark']) {
    border: var(--hi-px-1) solid var(--hi-clr--theme-5);
    background-color: var(--hi-clr--theme-3);
    color: var(--hi-clr--theme-text-3);
  }

  :host([aesthetic='minimal']) {
    border-color: var(--hi-clr--theme-1);
    background-color: var(--hi-clr--theme-1);
    font-weight: var(--hi-font--weight-bold);
  }

  :host([aesthetic='ghost']) {
    font-weight: var(--hi-font--weight-bold);
    border-color: var(--hi-clr--transparent);
    background-color: var(--hi-clr--transparent);
    text-shadow: var(--hi-px-1) var(--hi-px-1) var(--hi-px-1) var(--text-shadow-color);
  }

  :host([size='small']) {
    font-size: var(--hi-px-12) !important;
    min-height: var(--hi-px-18);
  }

  :host([size='large']) {
    font-size: var(--hi-font-size--large) !important;
    padding: var(--hi-px-4) var(--hi-px-6);
  }

  :host([allow-text-wrap]) {
    white-space: normal;
  }
`;
