
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { AsHIC } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorSetSelect } from '../../../eip/element/hi-behavior-set-select/hi-behavior-set-select.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import navigation from '../../../pip/library/pi-navigation/pi-navigation.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorTabGroup(Base) {
  class BehaviorTabGroup2 extends BehaviorSetSelect(BehaviorBehavior(AsHIC(Base))) {
    static get properties() {
      return {
        uriState: {
          type: String,
          reflectToAttribute: true
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorTabGroup");
    }
    readActiveState() {
      const uri = navigation.location.active.href;
      const queryParams = navigation.uri.readQuery(uri);
      return f1.key(this.uriState, queryParams);
    }
    selectIndices(_indices, suppressSelectEvent = false) {
      return this.selectIndex(_indices, false);
    }
    _onSlotChanged() {
      this._setSelect__onSlotChanged();
      this.__updateSelectedTabIfUriStateExist();
    }
    __updateSelectedTabIfUriStateExist() {
      const selectedTabValue = this.readActiveState();
      if (f1.is.falsy(selectedTabValue)) {
        return;
      }
      const tabs = f1.to.array(this.children);
      const selectedTab = tabs.find((child) => child.value === selectedTabValue);
      const value = selectedTab ? selectedTab["value"] : "";
      if (f1.is.empty(value)) {
        return;
      }
      this.value = value;
    }
    __setSelect__selectedIndexChanged(_index, _oldIndex) {
      super.__setSelect__selectedIndexChanged(_index, _oldIndex);
      this.__updateUriOnSelectionChange();
    }
    __updateUriOnSelectionChange() {
      const href = navigation.location.active.href;
      const base_hash = navigation.location.active.base_hash;
      const pathname = navigation.location.active.pathname;
      const selectedTabId = this.getAttribute("selected-index");
      if (f1.is.empty(selectedTabId)) {
        return;
      }
      const tabs = f1.filter((el) => el.hasAttribute("x-hip"), f1.to.array(this.children));
      const value = f1.read(`/${selectedTabId}/value`, "", tabs);
      if (f1.is.empty(value)) {
        return;
      }
      const queryParam = this.uriState;
      const queryParameters = navigation.uri.readParameters(href);
      queryParameters[`${queryParam}`] = value;
      if (!f1.is.empty(queryParam)) {
        const routeWithQueryParams = navigation.uri.writeQuery("", [], queryParameters);
        const finalRoute = `${pathname}${base_hash}?${routeWithQueryParams}`;
        navigation.location.changeStateWithoutReload({}, "", finalRoute);
      }
    }
  }
  return HIP.factory.mixin(BehaviorTabGroup2);
}
export const BehaviorTabGroup = dedupingMixin(BaseBehaviorTabGroup);
HIP["BehaviorTabGroup"] = BehaviorTabGroup;
