
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { BehaviorItemSelect } from '../../../eip/element/hi-behavior-set-select/hi-behavior-item-select.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
export function BaseBehaviorTab(Base) {
  class BehaviorTab2 extends BehaviorItemSelect(BehaviorBehavior(Base)) {
    static get properties() {
      return {
        for: {
          type: String,
          reflectToAttribute: true
        }
      };
    }
    static get observers() {
      return ["_applyAXMarkersToTargetWatcher(for)"];
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorTab");
    }
    _applyAXMarkersToTargetWatcher(_for) {
      this._adjustAriaFocus(_for);
    }
    _selectedChanged(selected) {
      this.__reflectSelected(selected);
      return super._selectedChanged(selected);
    }
    activate() {
      this.__reflectSelected(true);
      return super.activate();
    }
    deactivate() {
      this.__reflectSelected(false);
      return super.deactivate();
    }
    __reflectSelected(selected) {
      const target = this.__getTarget(this.for);
      if (!target) {
        return;
      }
      if (selected) {
        this.__enableTarget(target);
      } else {
        this.__disableTarget(target);
      }
    }
    hasDistinctPanels() {
      return this.parentElement ? this.parentElement["panelMode"] !== "shared" : false;
    }
    __enableTarget(target) {
      dom.setAttr(this, "aria-controls", target.getAttribute("id"));
      dom.setAttr(target, "aria-labelledby", this.id);
      dom.setAttr(target, "hidden", false);
    }
    __disableTarget(target) {
      dom.setAttr(target, "hidden", true);
    }
    _adjustAriaFocus(_for) {
      const target = this.__getTarget(_for);
      if (!target) {
        return;
      }
      dom.ensureAttr(target, "id");
      dom.ensureAttr(this, "id");
      dom.setAttrs(target, {
        role: "tabpanel",
        hidden: true,
        tabindex: 0
      });
      dom.setAttr(this, "aria-controls", target.getAttribute("id"));
      dom.setAttr(target, "aria-labelledby", this.id);
    }
    __getTarget(_for) {
      return HIP.browser.queryOne(`${_for || ""}`, this.ns, this);
    }
  }
  return HIP.factory.mixin(BehaviorTab2);
}
export const BehaviorTab = dedupingMixin(BaseBehaviorTab);
HIP["BehaviorTab"] = BehaviorTab;
