
import '../../../hip/library/polymer/polymer.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { PropertyEffects } from '../../../hip/library/polymer/polymer.js';
import { OptionalMutableData } from '../../../hip/library/polymer/polymer.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
export function BaseBehaviorTemplateElement(Base) {
  class TemplateElement extends OptionalMutableData(PropertyEffects(BehaviorBehavior(Base))) {
    constructor() {
      super();
      this.__children = null;
      this.root = null;
      this.$ = null;
    }
    static get properties() {
      return {};
    }
    static get observedAttributes() {
      return ["mutable-data"];
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorTemplateElement");
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      this._removeChildren();
    }
    attributeChangedCallback(name, old, value, namespace) {
      super.attributeChangedCallback(name, old, value, namespace);
      this.mutableData = true;
    }
    _insertChildren() {
      this.parentNode.insertBefore(this.root, this);
    }
    _removeChildren() {
      if (this.__children) {
        for (let i = 0; i < this.__children.length; i++) {
          this.__children[i].remove();
        }
      }
      this.__children = void 0;
    }
    _renderTemplate() {
      const template = this.querySelector("template");
      if (!this.__children) {
        if (template) {
          this.root = this._stampTemplate(template);
          this.$ = this.root.$;
          this.__children = [];
          for (let n = this.root.firstChild; n; n = n.nextSibling) {
            this.__children[this.__children.length] = n;
          }
          this._enableProperties();
        }
        this._insertChildren();
      }
    }
  }
  return HIP.factory.mixin(TemplateElement);
}
export const BehaviorTemplateElement = dedupingMixin(BaseBehaviorTemplateElement);
HIP["BehaviorTemplateElement"] = BehaviorTemplateElement;
