
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import '../../../hip/library/polymer/polymer.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
const ruleToPlaceholder = /[&?*^@]/g;
export function BaseBehaviorValidation(Base) {
  class BehaviorValidation2 extends BehaviorBehavior(Base) {
    static get properties() {
      return {
        reason: {
          type: String
        },
        placeholder: {
          type: String,
          value: ""
        },
        rule: {
          type: String,
          notify: true
        }
      };
    }
    static get observers() {
      return ["_validationChanged(rule, placeholder)"];
    }
    connectedCallback() {
      super.connectedCallback();
      this._registerBehavior("BehaviorValidation");
      this.parentElement.registerValidation(this);
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      this.parentElement.unregisterValidation(this);
    }
    get name() {
      return this.constructor.is.replace("hi-validation-", "").split(`-`).reduce((name, aspect) => name + f1.capitalize(aspect), `custom`);
    }
    value(value) {
      return value;
    }
    _validationChanged(rule, placeholder) {
      const parentEl = this.parentElement;
      if (!parentEl) {
        return;
      }
      parentEl.placeholder = parentEl.placeholder || placeholder || rule.replace(ruleToPlaceholder, "_");
    }
    validationMessage(value) {
      return `${value || "<blank>"} does not coincide with ${this.placeholder || this.rule}`;
    }
  }
  return HIP.factory.mixin(BehaviorValidation2);
}
export const BehaviorValidation = dedupingMixin(BaseBehaviorValidation);
HIP["BehaviorValidation"] = BehaviorValidation;
