
import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import { BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorContainer } from '../../../eip/element/hi-behavior-container/hi-behavior-container.js';
import { AsHIC, HIP } from '../../../eip/element/hi-component/hi-component.js';
import './hi-crumb.js';
export class BreadcrumbElement extends BehaviorContainer(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "hi-breadcrumb";
  }
  static get template() {
    return html`
      <style is="custom-style" include="hi-theme"></style>
      <style>
        :host {
          display: flex;
          justify-content: flex-start;
          align-items: center;
        }
      </style>
      <slot id="items"></slot>
    `;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "list");
  }
}
HIP.factory.element(BreadcrumbElement);
