
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { LitElement, css, html } from '../../../hip/library/lit/lit.js';
import {
  AsLitHIC,
  BehaviorA11yKeyboard,
  BehaviorInteractiveElement,
  BehaviorBrowserEvents,
  BehaviorCustomizable,
  BehaviorElement,
  HIP
} from '../../../eip/element/hi-component/hi-component.js';
export const styles = css`
  :host {
    --hi-loading--circle-size: var(--hi-px-20);
    --text-shadow-color: rgba(64, 64, 64, 0.3);
    --text-shadow-color-hover: rgba(64, 64, 64, 0.5);
  }

  :host {
    transition: box-shadow 0.2s cubic-bezier(0.4, 0, 0.2, 1);
    border: var(--hi-px-1) solid var(--hi-clr--transparent);
    box-shadow: var(--hi-clr--shadow-clickable);
    padding: var(--hi-px-6) var(--hi-px-12);
    border-radius: var(--hi-shape--radius);
    height: var(--hi-el--height);
    min-width: var(--hi-px-24);
    text-overflow: ellipsis;
    will-change: box-shadow;
    vertical-align: middle;
    display: inline-block;
    white-space: nowrap;
    text-align: center;
    user-select: none;
    cursor: pointer;
    filter: none;
    width: auto;
  }

  :host(:not([locked])) ::slotted(*),
  :host(:not([disabled])) ::slotted(*) {
    cursor: pointer;
  }

  :host([size='small']) {
    padding: var(--hi-px-4) var(--hi-px-8);
    height: var(--hi-px-28);
  }

  :host([size='small']) #container {
    font-size: 0.8125rem !important;
  }

  :host([size='large']) {
    padding: var(--hi-px-8) var(--hi-px-12);
  }

  :host([size='large']) #container {
    font-size: 1.125rem !important;
  }

  :host([size='large-x']) {
    padding: var(--hi-px-8);
  }

  :host([size='large-x']) #container {
    font-size: 1.5rem !important;
  }

  :host([size='large-xx']) {
    padding: var(--hi-px-8) var(--hi-px-12);
  }

  :host([size='large-xx']) #container {
    font-size: 1.75rem !important;
  }

  :host([theme='transparent']) {
    text-shadow: none;
  }

  :host([aesthetic='ghost']) {
    will-change: text-shadow;
    transition: text-shadow 0.2s cubic-bezier(0.4, 0, 0.2, 1);
  }

  :host([aesthetic='primary']) {
    filter: contrast(104%) brightness(104%);
    text-shadow: var(--hi-px-1) var(--hi-px-1) var(--hi-px-2) var(--text-shadow-color);
    background-color: var(--hi-clr--theme-3);
    border-color: var(--hi-clr--theme-5);
    color: var(--hi-clr--theme-text-3);
  }

  :host([href]),
  :host([aesthetic='link']),
  :host([aesthetic='secondary']) {
    background-color: var(--hi-clr--theme-1);
    border-color: var(--hi-clr--theme-3);
    color: var(--hi-clr--theme-5);
  }

  :host([aesthetic='icon']),
  :host([aesthetic='ghost']) {
    background-color: var(--hi-clr--transparent);
    border-color: var(--hi-clr--transparent);
    color: var(--hi-clr--theme-5);
  }

  :host([aesthetic='link']) {
    text-decoration: underline;
  }

  :host([aesthetic='ghost']:not([bordered])),
  :host([aesthetic='icon']:not([bordered])) {
    box-shadow: none;
  }

  :host([aesthetic='ghost']) {
    text-shadow: var(--hi-px-1) var(--hi-px-1) var(--hi-px-1) var(--text-shadow-color);
  }

  :host([aesthetic='ghost']:not(:hover):not([disabled])) {
    filter: contrast(1);
  }

  :host([bordered]) {
    border-color: var(--hi-clr--theme-3);
  }

  :host([size='small'][layout='icon']) ::slotted(hi-icon),
  :host([size='small'][aesthetic='icon']) ::slotted(hi-icon),
  :host([size='small']) ::slotted(hi-icon) {
    font-size: 0.8125rem !important;
  }

  :host([layout='icon']) ::slotted(hi-icon),
  :host([aesthetic='icon']) ::slotted(hi-icon),
  ::slotted(hi-icon) {
    font-size: 1rem !important;
  }

  :host([size='large'][layout='icon']) ::slotted(hi-icon),
  :host([size='large'][aesthetic='icon']) ::slotted(hi-icon),
  :host([size='large']) ::slotted(hi-icon) {
    font-size: 1.175rem !important;
  }

  :host([size='large-x'][layout='icon']) ::slotted(hi-icon),
  :host([size='large-x'][aesthetic='icon']) ::slotted(hi-icon),
  :host([size='large-x']) ::slotted(hi-icon) {
    font-size: 1.5rem !important;
  }

  :host([size='large-xx'][layout='icon']) ::slotted(hi-icon),
  :host([size='large-xx'][aesthetic='icon']) ::slotted(hi-icon),
  :host([size='large-xx']) ::slotted(hi-icon) {
    font-size: 2rem !important;
  }

  :host([size='small'][layout='icon']),
  :host([size='small'][aesthetic='icon']) {
    height: var(--hi-px-24);
    padding: var(--hi-px-4) !important;
  }

  /* square the button with only an icon */
  :host([layout='icon']),
  :host([aesthetic='icon']),
  :host([size='medium'][aesthetic='icon']) {
    height: var(--hi-px-34);
    padding: var(--hi-px-8);
  }

  :host([size='large'][layout='icon']),
  :host([size='large'][aesthetic='icon']) {
    height: var(--hi-px-40);
    padding: var(--hi-px-8);
  }

  :host([size='large-x'][layout='icon']),
  :host([size='large-x'][aesthetic='icon']) {
    height: calc(2 * var(--hi-px-24));
    padding: var(--hi-px-12);
  }

  :host([size='large-xx'][layout='icon']),
  :host([size='large-xx'][aesthetic='icon']) {
    height: calc(2 * var(--hi-px-28));
    padding: var(--hi-px-12);
  }

  :host([aesthetic='icon']:focus) {
    fill: var(--hi-clr--theme-5);
  }

  :host(:focus:not([disabled])) {
    filter: contrast(110%);
  }

  @media (hover: hover) {
    :host(:not([aesthetic='primary']):not([disabled]):hover) {
      text-shadow: var(--hi-px-1) var(--hi-px-1) var(--hi-px-2) var(--text-shadow-color-hover);
      filter: contrast(104%);
    }

    :host([aesthetic='primary']:not([disabled]):hover) {
      text-shadow: var(--hi-px-1) var(--hi-px-1) var(--hi-px-2) var(--text-shadow-color-hover);
      filter: contrast(108%) brightness(116%);
    }

    :host(:not([aesthetic='ghost']:not([bordered])):not([disabled]):not([locked]):hover) {
      box-shadow: var(--hi-clr--shadow-down-2);
      border-color: var(--hi-clr--theme-5);
      fill: var(--hi-clr--theme-5);
    }
  }

  :host(:hover:active:not([aesthetic='ghost']:not([bordered])):not([disabled]):not([locked])),
  :host(:focus:active:not([aesthetic='ghost']:not([bordered])):not([disabled]):not([locked])),
  :host(:active:not([aesthetic='ghost']:not([bordered])):not([disabled]):not([locked])) {
    box-shadow: var(--hi-clr--shadow-inset-1);
    text-shadow: none;
    filter: none;
  }

  :host([aesthetic='ghost']:hover:active:not([disabled])),
  :host([aesthetic='ghost']:focus:active:not([disabled])),
  :host([aesthetic='ghost']:active:not([disabled])) {
    text-shadow: none;
  }

  :host(:disabled),
  :host([disabled]) {
    filter: none;
    box-shadow: none;
    text-shadow: none;
  }

  /* TODO: Fix overall disabled state !important */
  :host([disabled][aesthetic='primary']),
  :host([disabled][aesthetic='primary']) ::slotted(*) {
    color: var(--hi-clr--white) !important;
  }

  :host([stretched]),
  :host([stretched]) ::slotted(span) {
    width: 100%;
  }

  #container {
    display: flex;
    align-items: center;
    justify-content: center;
  }

  #container ::slotted([slotted-order]) {
    margin: 0;
  }

  :host(:not([aesthetic='icon'])) #container ::slotted(:nth-child(n):not(:first-child)) {
    margin-left: var(--hi-px-4) !important;
  }

  :host(:not([aesthetic='icon'])) #container ::slotted(:nth-child(n):not(:last-child)) {
    margin-right: var(--hi-px-4) !important;
  }

  :host([layout='icon']) #container ::slotted(:nth-child(n):not(:first-child)),
  :host([layout='icon']) #container ::slotted(:nth-child(n):not(:last-child)) {
    margin: 0 !important;
  }

  :host([layout='icon']) #container ::slotted(hi-icon),
  :host([aesthetic='icon']) #container ::slotted(hi-icon) {
    margin: 0 !important;
  }

  :host([layout='icon']) #container ::slotted(:not(hi-icon):not(hi-hint)),
  :host([aesthetic='icon']) #container ::slotted(:not(hi-icon):not(hi-hint)) {
    position: absolute !important;
    overflow: hidden !important;
    font-size: 0 !important;
    padding: 0 !important;
    margin: 0 !important;
  }

  #container {
    height: 100%;
    font-weight: var(--hi-font--weight-light);
    font-size: var(--hi-font-size--text);
  }

  @keyframes fadeIn {
    0% {
      opacity: 0;
    }

    30% {
      opacity: 1;
    }
  }

  @keyframes spinner {
    0% {
      transform: rotate(0deg);
    }

    100% {
      transform: rotate(360deg);
    }
  }

  :host([locked]),
  :host([locked]:focus),
  :host([locked]:hover) {
    pointer-events: none;
    position: relative;
    box-shadow: none;
    filter: none;
  }

  :host([locked])::after {
    content: '';
    width: var(--hi-loading--circle-size);
    height: var(--hi-loading--circle-size);
    position: absolute;
    top: 50%;
    left: 50%;
    margin-top: calc(-0.5 * var(--hi-loading--circle-size));
    margin-left: calc(-0.5 * var(--hi-loading--circle-size));
    border-radius: 50%;
    border: solid var(--hi-px-3) var(--hi-clr--theme-3);
    border-left-color: rgba(255, 255, 255, 0);
    animation: 1.6s linear infinite spinner, 0.5s ease-in fadeIn;
    z-index: 2;
  }

  :host([locked])::before {
    content: '';
    width: 110%;
    height: 110%;
    position: absolute;
    top: -5%;
    left: -5%;
    background-color: var(--hi-clr--white);
    border-radius: var(--hi-shape--radius);
    opacity: 0.8;
    z-index: 1;
  }

  /* increase size of buttons on mobile for accessiblity */
  @media only screen and (max-width: 40rem) {
    :host([device='mobile']) {
      min-height: var(--hi-el--height-mobile) !important;
      min-width: var(--hi-el--width-mobile) !important;
    }
  }
`;
export class ButtonElement extends BehaviorCustomizable(
  BehaviorA11yKeyboard(BehaviorBrowserEvents(BehaviorInteractiveElement(BehaviorElement(AsLitHIC(LitElement)))))
) {
  constructor() {
    super(...arguments);
    this.kind = "value";
    this.aesthetic = "primary";
    this.target = "_self";
  }
  static get is() {
    return "hi-button";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  static get properties() {
    return {
      kind: {
        type: String,
        reflect: true
      },
      aesthetic: {
        type: String,
        reflect: true
      },
      stretched: {
        type: Boolean,
        reflect: true
      },
      href: {
        type: String,
        reflect: true
      },
      target: {
        type: String
      },
      value: {
        type: Object,
        notify: true,
        converter: (value) => {
          if (value === null) {
            return null;
          } else {
            try {
              return JSON.parse(value);
            } catch (e) {
              return `${value}`;
            }
          }
        }
      },
      enableSilentValue: {
        type: Boolean,
        attribute: "enable-silent-value"
      },
      enableIsolatedEvents: {
        type: Boolean,
        attribute: "enable-isolated-events"
      },
      locked: {
        type: Boolean,
        reflect: true
      }
    };
  }
  static get api() {
    return ["trigger"];
  }
  static get keyBindings() {
    return {
      "space:keydown": "__onKeyDown_space",
      "enter:keydown": "__onKeyDown_enter",
      "space:keyup": "__onKeyUp_space",
      "enter:keyup": "__onKeyUp_enter"
    };
  }
  static get browserBindings() {
    return {
      click: "__onClick"
    };
  }
  static get autoBinding() {
    return {
      signal: "trigger-ended",
      field: "trigger"
    };
  }
  get context() {
    return {
      purpose: this.purpose,
      target: this.target,
      value: this.value,
      href: this.href
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", this.hasAttribute("href") ? "link" : "button");
    this._correctPresentation();
    this._includeQAMarker();
  }
  update(props) {
    super.update(props);
    this._watchChanges(props, [
      {
        properties: ["kind", "href"],
        method: "__kindWatcher"
      }
    ]);
  }
  render() {
    return html`
      <div id="container">
        <slot id="items"></slot>
      </div>
    `;
  }
  trigger() {
    if (this.locked) {
      HIP.fn.announce("please wait, button action is currently active");
      return false;
    }
    if (!this.enableSilentValue) {
      this._dispatchBubblingEvent("value-notified", this.context);
    }
    if (this.hasAttribute("href") && this.kind === "browser") {
      HIP.util.goToHref(this.href, this.target);
      return this.href;
    } else if (this.hasAttribute("action")) {
      return window["eval"](`${this.getAttribute("action")}`);
    } else if (this.value != null) {
      return this.value;
    } else {
      return true;
    }
  }
  waitFor(promise) {
    this.locked = true;
    return promise.then((data) => {
      this.locked = false;
      return data;
    }).catch((err) => {
      this.locked = false;
      return err;
    });
  }
  _correctPresentation() {
    if (this.hasAttribute("layout-icon")) {
      this.setAttribute("layout", "icon");
    }
    if (this.getAttribute("aesthetic") === "icon") {
      this.setAttribute("layout", "icon");
    }
  }
  __onKeyUp_space(event, keyboardEvent) {
    this.__onKeyUp__any(event, keyboardEvent);
  }
  __onKeyDown_space(event, keyboardEvent) {
    this.__onKeyDown_any(event, keyboardEvent);
  }
  __onKeyUp_enter(event, keyboardEvent) {
    this.__onKeyUp__any(event, keyboardEvent);
  }
  __onKeyDown_enter(event, keyboardEvent) {
    this.__onKeyDown_any(event, keyboardEvent);
  }
  __onKeyUp__any(event, keyboardEvent) {
    (keyboardEvent || event).stopPropagation();
    (keyboardEvent || event).preventDefault();
    this.trigger();
  }
  __onKeyDown_any(event, keyboardEvent) {
    (keyboardEvent || event).stopPropagation();
    (keyboardEvent || event).preventDefault();
  }
  __onClick(event) {
    if (this.enableIsolatedEvents) {
      event.stopPropagation();
    }
    event.preventDefault();
    this.trigger();
    this._dispatchProcess("tap", {
      value: this.value,
      args: [event]
    });
  }
  __kindWatcher(kind, href) {
    if (href && kind !== "browser") {
      this.aesthetic = "link";
      this.kind = "browser";
    }
  }
}
export default HIP.factory.element(ButtonElement);
