
import '../../../hip/library/polymer/polymer.js';
import { removeListener, addListener } from '../../../hip/library/polymer/polymer.js';
import { beforeNextRender } from '../../../hip/library/polymer/polymer.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorA11yGestures(Base) {
  class BehaviorA11yGestures2 extends Base {
    connectedCallback() {
      super.connectedCallback();
      const gestureBindings = this.constructor.gestureBindings;
      for (const eventString in gestureBindings) {
        const [eventName, _optEl] = eventString.split(":");
        const el = _optEl ? this.$[_optEl] : this;
        const elName = _optEl ? _optEl : "this";
        const methodName = gestureBindings[eventString];
        const methodNameBound = `__${elName}_${methodName}Bound`;
        if (typeof this[methodNameBound] === "function") {
          removeListener(el, eventName, this[methodNameBound]);
        }
        this[methodNameBound] = function(...args) {
          const processName = eventString.replace(":", "-");
          const value = this[methodName].apply(this, args);
          const event = args[0];
          const announcements = f1.safe({}, this.constructor.announcements);
          const announcementFn = f1.read(`/${eventString}`, null, announcements);
          if (announcementFn) {
            HIP.fn.announce(announcementFn.call(this));
          }
          this._dispatchProcess(processName, {
            event,
            value
          });
          if (this.__gestureRequest_replayTap__) {
            beforeNextRender(this, function() {
              if (this.__gestureRequest_replayTap__) {
                this.__gestureRequest_replayTap__.dispatchEvent(event);
              }
            });
          }
          return value;
        }.bind(this);
        addListener(el, eventName, this[methodNameBound]);
      }
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      const gestureBindings = this.constructor.gestureBindings;
      for (const eventString in gestureBindings) {
        const [eventName, _optEl] = eventString.split(":");
        const el = _optEl ? this.$[_optEl] : this;
        const elName = _optEl ? _optEl : "this";
        const methodName = gestureBindings[eventString];
        const methodNameBound = `__${elName}_${methodName}Bound`;
        removeListener(el, eventName, this[methodNameBound]);
        this[methodNameBound] = void 0;
      }
    }
  }
  return window.HIP.factory.mixin(BehaviorA11yGestures2);
}
export const BehaviorA11yGestures = dedupingMixin(BaseBehaviorA11yGestures);
HIP["BehaviorA11yGestures"] = BehaviorA11yGestures;
