
import '../../../hip/library/polymer/polymer.js';
import { HIP } from './hi-component.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
const R = {
  newLine: /[\n\r]/g
};
export class A11yLabel {
  writeA11yLabel(el, label, labelledBy, describedBy, options = {}) {
    const ariaLabel = f1.safe("", label).trim();
    const ariaLabelledBy = f1.safe("", labelledBy).trim();
    const ariaDescribedBy = f1.safe("", describedBy).trim();
    const ariaAxLabel = this.__getInternalInputAXLabel(ariaLabel, ariaLabelledBy, ariaDescribedBy, options.ns);
    const axLabel = `${f1.safe("", options.placeholder)} ${ariaAxLabel}`.replace(R.newLine, " ").trim();
    dom.setAttr(el, "aria-label", axLabel);
  }
  getTextContentByIds(ids, ns) {
    if (f1.is.nils(ids)) {
      return "";
    }
    const readInnerText = f1.read("/innerText", "");
    const idList = f1.compact(f1.split(" ", ids));
    const elementText = f1.map((id) => readInnerText(HIP.browser.queryOne(id, ns)), idList);
    return elementText.join(" ");
  }
  __getInternalInputAXLabel(ariaLabel, ariaLabelledBy, ariaDescribedBy, ns) {
    const textFromAriaLabelledBy = this.getTextContentByIds(ariaLabelledBy, ns);
    const textFromAriaDescribedBy = this.getTextContentByIds(ariaDescribedBy, ns);
    return ariaLabelledBy ? `${textFromAriaLabelledBy} ${textFromAriaDescribedBy}` : `${ariaLabel} ${textFromAriaDescribedBy}`;
  }
}
export const a11yLabel = new A11yLabel();
