
import '../../../hip/library/polymer/polymer.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorBrowserEvents(Base) {
  class BehaviorBrowserEvents2 extends Base {
    connectedCallback() {
      super.connectedCallback();
      const browserBindings = this.constructor.browserBindings;
      for (const eventString in browserBindings) {
        this._createBrowserEvent(eventString, browserBindings);
      }
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      const browserBindings = this.constructor.browserBindings;
      for (const eventString in browserBindings) {
        this._removeBrowserEvent(eventString, browserBindings);
      }
    }
    _createBrowserEvent(eventString, browserBindings = this.constructor.browserBindings) {
      const { methodNameBound, methodName, eventName, el } = BehaviorBrowserEvents2.__sliceEvent.call(
        this,
        eventString,
        browserBindings
      );
      if (typeof this[methodNameBound] === "function") {
        el.removeEventListener(eventName, this[methodNameBound]);
      }
      this[methodNameBound] = function(...args) {
        const value = this[methodName].apply(this, args);
        const announcements = f1.safe({}, this.constructor.announcements);
        const announcementFn = f1.read(`/${eventString}`, null, announcements);
        if (announcementFn) {
          HIP.fn.announce(announcementFn.call(this));
        }
        this._dispatchProcess(eventString, {
          args,
          value
        });
        return value;
      }.bind(this);
      el.addEventListener(eventName, this[methodNameBound]);
    }
    _removeBrowserEvent(eventString, browserBindings = this.constructor.browserBindings) {
      const { methodNameBound, eventName, el } = BehaviorBrowserEvents2.__sliceEvent.call(
        this,
        eventString,
        browserBindings
      );
      el.removeEventListener(eventName, this[methodNameBound]);
      this[methodNameBound] = void 0;
    }
    static __sliceEvent(eventString, browserBindings) {
      const [eventName, _optEl] = eventString.split(":");
      const el = _optEl ? this.$[_optEl] : this;
      const elName = _optEl ? _optEl : "this";
      const methodName = browserBindings[eventString];
      return {
        methodNameBound: `__${elName}_${methodName}Bound`,
        methodName,
        eventName,
        el
      };
    }
  }
  return window.HIP.factory.mixin(BehaviorBrowserEvents2);
}
export const BehaviorBrowserEvents = dedupingMixin(BaseBehaviorBrowserEvents);
HIP["BehaviorBrowserEvents"] = BehaviorBrowserEvents;
