
import dom from '../../../pip/library/pi-dom/pi-dom.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-hip/hi-hif.js';
export function BaseBehaviorInteractiveElement(Base) {
  class BehaviorInteractiveElement2 extends Base {
    static get properties() {
      return {
        role: {
          type: String,
          reflectToAttribute: true,
          reflect: true
        },
        disabledFocusable: {
          type: Boolean,
          attribute: "disabled-focusable"
        }
      };
    }
    static get observers() {
      return ["_noTabindexWatcher(disabledFocusable, disabled, hidden)"];
    }
    connectedCallback() {
      super.connectedCallback();
      this.__initializeTabIndex();
      this.__updateTabindexState();
    }
    __initializeTabIndex() {
      this.__tabindexInitialValue = parseInt(this.getAttribute("tabindex") || "0");
      if (Number.isNaN(this.__tabindexInitialValue)) {
        this.__tabindexInitialValue = 0;
      }
    }
    update(props) {
      super.update(props);
      this._watchChanges(props, [
        {
          properties: ["disabledFocusable", "disabled", "hidden"],
          method: "_noTabindexWatcher"
        }
      ]);
    }
    _noTabindexWatcher() {
      this.__updateTabindexState();
    }
    forceTabIndex(tabindex) {
      this.__tabindexInitialValue = tabindex;
      this.__updateTabindexState();
    }
    __updateTabindexState() {
      dom.flipAttr(this, "tabindex", this.tabbable, `${this.__tabindexInitialValue || 0}`);
    }
    get isTabbable() {
      return this.tabbable;
    }
    get tabbable() {
      return !dom.is.unfocusable(this);
    }
  }
  return window.HIP.factory.mixin(BehaviorInteractiveElement2);
}
export const BehaviorInteractiveElement = dedupingMixin(BaseBehaviorInteractiveElement);
HIP["BehaviorInteractiveElement"] = BehaviorInteractiveElement;
