
import '../../../hip/library/polymer/polymer.js';
import { css } from '../../../hip/library/lit-element/lit-element.js';
export const styles = css`
  [hidden] {
    display: none !important;
  }

  [show='true'] {
    display: initial !important;
  }

  [show='false'] {
    display: none !important;
  }

  /* -- yi-hover style (Copied to apply styling inside shadow-root) -- */

  [hover='parent'] {
    position: relative;
  }

  [hover='parent'] > [hover='child'] {
    visibility: hidden;
    z-index: -100;
    display: none;
  }

  [hover='parent']:focus > [hover='child'],
  [hover='parent']:hover > [hover='child'],
  [hover='parent'][hover-show] > [hover='child'] {
    z-index: var(--hi-depth--above-all);
    visibility: visible;
    display: block;
  }

  [mixin='ellipsis'] {
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    display: block;
  }

  [mixin='invisible'] {
    position: absolute !important;
    overflow: hidden !important;
    visibility: hidden !important;
    width: 0 !important;
    height: 0 !important;
    display: block !important;
  }

  [x-style='hidden'],
  [mixin='show-ax'],
  [mixin='hidden'] {
    position: absolute;
    z-index: -1000;
    left: -100000px;
    top: -100000px;
    height: 1px;
    width: 1px;
    clip: rect(1px, 1px, 1px, 1px);
    clip-path: polygon(0px 0px, 0px 0px, 0px 0px);
    overflow: hidden !important;
    padding: 0;
    border: 0;
    margin: 0;
  }

  [mixin='input-hidden'] {
    visibility: hidden !important;
    position: relative !important;
    left: -99999px !important;
    width: 0 !important;
    height: 0 !important;
  }

  [mixin='text'] {
    font-family: var(--hi-font--family-sans-serif);
    font-weight: var(--hi-font--weight-light);
    text-rendering: optimizeLegibility;
    font-style: normal;
  }

  [mixin='text-natural'] {
    font-size: var(--hi-font-size--text);
    line-height: var(--hi-font-lh--medium);
    font-weight: var(--hi-font--weight-light);
    font-family: var(--hi-font--family-sans-serif);
    text-rendering: optimizeLegibility;
    font-style: normal;
  }

  [mixin='disabled'],
  [mixin='non-interactive'] {
    -moz-user-focus: ignore !important;
    pointer-events: none !important;
    user-select: none !important;
    cursor: default !important;
  }

  [mixin='text-placeholder'] {
    font-size: var(--hi-font-size--text);
    color: var(--hi-clr--gray-7);
    opacity: 1;
  }

  [mixin='input-placeholder']::placeholder,
  [mixin='input-placeholder']:placeholder-shown {
    font-size: var(--hi-font-size--text);
    color: var(--hi-clr--gray-7);
    opacity: 1;
  }

  /* -- Deprecated in latest chrome versions, use ::placeholder instead  -- */
  [mixin='input-placeholder']::-webkit-input-placeholder {
    font-size: var(--hi-font-size--text);
    color: var(--hi-clr--gray-7);
  }

  /* -- Do not need this anymore,::placeholder works for all modern browsers  -- */
  [mixin='input-placeholder']:-ms-input-placeholder {
    color: var(--hi-clr--gray-7);
    font-size: var(--hi-font-size--text);
  }

  /* -- Do not need this anymore,::placeholder works for all modern browsers  -- */
  [mixin='input-placeholder']:-moz-placeholder,
  [mixin='input-placeholder']::-moz-placeholder {
    color: var(--hi-clr--gray-7);
    font-size: var(--hi-font-size--text);
    opacity: 1;
  }

  [mixin='input-placeholder']:focus {
    --hi-outline--offset: -1px;
  }

  /* -- FONT -- */

  .build-requirement--include-all-fonts {
    font-family: 'Roboto';
  }

  /* -- BASELINE -- */

  :host {
    all: initial;
    font-size: 1rem;
    line-height: 1;
    background: none;
    font-family: 'Roboto', Tahoma, sans-serif;
    vertical-align: baseline;
    font-style: normal;
    font-weight: 300;
    padding: 0;
    border: 0;
    margin: 0;
    outline: 0;
  }

  :host,
  :host * {
    box-sizing: border-box;
  }

  :host([focused]),
  :host(:focus) {
    outline: var(--hi-outline--width) var(--hi-outline--line) var(--hi-clr--outline);
    outline-offset: var(--hi-outline--offset);
  }

  :host([hidden]) {
    display: none !important;
  }

  /* -- COLOR -- */

  :host {
    --hi-clr--theme-text-1: var(--hi-clr--text);
    --hi-clr--theme-text-3: var(--hi-clr--white);
    --hi-clr--theme-text-5: var(--hi-clr--white);
  }

  :host(:not([theme])),
  :host([theme='primary']),
  :host([theme='blue']) {
    --hi-clr--theme-1: var(--hi-clr--blue-1);
    --hi-clr--theme-3: var(--hi-clr--blue-3);
    --hi-clr--theme-5: var(--hi-clr--blue-5);
  }

  :host([theme='primary']) {
    --hi-clr--theme-3: var(--hi-clr--eab);
  }

  :host([theme='error']),
  :host([theme='red']) {
    --hi-clr--theme-1: var(--hi-clr--red-1);
    --hi-clr--theme-3: var(--hi-clr--red-3);
    --hi-clr--theme-5: var(--hi-clr--red-5);
  }

  :host([theme='white']) {
    --hi-clr--theme-1: var(--hi-clr--white-1);
    --hi-clr--theme-3: var(--hi-clr--white-3);
    --hi-clr--theme-5: var(--hi-clr--white-5);
    --hi-clr--theme-text-1: var(--hi-clr--black);
    --hi-clr--theme-text-3: var(--hi-clr--black);
    --hi-clr--theme-text-5: var(--hi-clr--gray-1);
  }

  :host([theme='black']) {
    --hi-clr--theme-1: var(--hi-clr--black-1);
    --hi-clr--theme-3: var(--hi-clr--black-3);
    --hi-clr--theme-5: var(--hi-clr--black-5);
    --hi-clr--theme-text-1: var(--hi-clr--white);
    --hi-clr--theme-text-3: var(--hi-clr--white);
    --hi-clr--theme-text-5: var(--hi-clr--gray-9);
  }

  /** @deprecated: secondary, gray-light, gray-dark */
  :host([theme='gray-light']),
  :host([theme='gray-dark']),
  :host([theme='secondary']),
  :host([theme='gray']) {
    --hi-clr--theme-1: var(--hi-clr--gray-4);
    --hi-clr--theme-3: var(--hi-clr--gray-8);
    --hi-clr--theme-5: var(--hi-clr--gray-10);
    --hi-clr--theme-text-3: var(--hi-clr--gray-1);
  }

  :host([theme='warning']),
  :host([theme='orange']) {
    --hi-clr--theme-1: var(--hi-clr--orange-1);
    --hi-clr--theme-3: var(--hi-clr--orange-3);
    --hi-clr--theme-5: var(--hi-clr--orange-5);
    --hi-clr--theme-text-3: var(--hi-clr--text);
  }

  :host([theme='success']),
  :host([theme='green']) {
    --hi-clr--theme-1: var(--hi-clr--green-1);
    --hi-clr--theme-3: var(--hi-clr--green-3);
    --hi-clr--theme-5: var(--hi-clr--green-5);
  }

  :host([theme='cyan']) {
    --hi-clr--theme-1: var(--hi-clr--cyan-1);
    --hi-clr--theme-3: var(--hi-clr--cyan-3);
    --hi-clr--theme-5: var(--hi-clr--cyan-5);
  }

  :host([theme='purple']) {
    --hi-clr--theme-1: var(--hi-clr--purple-1);
    --hi-clr--theme-3: var(--hi-clr--purple-3);
    --hi-clr--theme-5: var(--hi-clr--purple-5);
  }

  :host([theme='magenta']) {
    --hi-clr--theme-1: var(--hi-clr--magenta-1);
    --hi-clr--theme-3: var(--hi-clr--magenta-3);
    --hi-clr--theme-5: var(--hi-clr--magenta-5);
  }

  :host([theme='info']),
  :host([theme='teal']) {
    --hi-clr--theme-1: var(--hi-clr--teal-1);
    --hi-clr--theme-3: var(--hi-clr--teal-3);
    --hi-clr--theme-5: var(--hi-clr--teal-5);
    --hi-clr--theme-text-3: var(--hi-clr--text);
  }

  :host([theme='yellow']) {
    --hi-clr--theme-1: var(--hi-clr--yellow-1);
    --hi-clr--theme-3: var(--hi-clr--yellow-3);
    --hi-clr--theme-5: var(--hi-clr--yellow-5);
    --hi-clr--theme-text-3: var(--hi-clr--text);
  }

  :host([theme='university']) {
    --hi-clr--theme-1: var(--hi-clr--university-1);
    --hi-clr--theme-3: var(--hi-clr--university-3);
    --hi-clr--theme-5: var(--hi-clr--university-5);

    --hi-clr--theme-text-1: var(--hi-clr--university-5);
    --hi-clr--theme-text-3: var(--hi-clr--university-text);
    --hi-clr--theme-text-5: var(--hi-clr--university-text);
  }

  :host([theme='transparent']) {
    --hi-clr--theme-1: var(--hi-clr--transparent);
    --hi-clr--theme-3: var(--hi-clr--transparent);
    --hi-clr--theme-5: var(--hi-clr--transparent);

    --hi-clr--theme-text-1: var(--hi-clr--transparent);
    --hi-clr--theme-text-3: var(--hi-clr--transparent);
    --hi-clr--theme-text-5: var(--hi-clr--transparent);
  }

  :host(:disabled),
  :host([disabled]) {
    --hi-clr--theme-1: var(--hi-clr--gray-3) !important;
    --hi-clr--theme-3: var(--hi-clr--gray-ax) !important;
    --hi-clr--theme-5: var(--hi-clr--gray-9) !important;
    --hi-clr--theme-text-1: var(--hi-clr--gray-9) !important;
    --hi-clr--theme-text-3: var(--hi-clr--gray-3) !important;
    --hi-clr--theme-text-5: var(--hi-clr--gray-3) !important;
    --hi-clr--text: var(--hi-clr--disabled-text);
  }

  :host([readonly]),
  :host([readonly]) ::slotted(*),
  :host(:disabled),
  :host([disabled]),
  :host(:disabled) ::slotted(*),
  :host([disabled]) ::slotted(*) {
    -moz-user-focus: ignore !important;
    pointer-events: none !important;
    user-select: none !important;
  }

  :host([readonly]) {
    cursor: default !important;
  }

  :host(:disabled),
  :host([disabled]),
  :host(:disabled) ::slotted(*),
  :host([disabled]) ::slotted(*) {
    color: var(--hi-clr--disabled-text) !important;
    -webkit-filter: grayscale(100%);
    -moz-filter: grayscale(100%);
    filter: url(desaturate.svg#greyscale);
    filter: gray;
    filter: grayscale(100%);
    cursor: not-allowed !important;
    text-shadow: none;
  }

  /* -- MEASUREMENT -- */

  :host([size='tiny']) {
    font-size: 0.75rem !important;
  }

  :host([size='small']) {
    font-size: 0.928rem !important;
  }

  :host([size='medium']) {
    font-size: 1rem !important;
  }

  :host([size='large']) {
    font-size: 1.25rem !important;
  }

  :host([size='large-x']) {
    font-size: 1.5rem !important;
  }

  :host([size='large-xx']) {
    font-size: 2rem !important;
  }

  :host([size='large-xxx']) {
    font-size: 3rem !important;
  }

  :host([size='auto']) {
    font-size: 1em !important;
  }

  /* -- TEXT -- */

  h1,
  h2,
  h3,
  h4,
  h5,
  h6,
  p,
  .text,
  [text-size] {
    font-weight: var(--hi-font--weight-light);
    text-rendering: optimizeLegibility;
    padding: 0;
    border: 0;
    margin: 0;
  }

  h1,
  h2,
  h3,
  h4,
  h5,
  h6 {
    font-family: var(--hi-font--family-header);
    font-weight: var(--hi-font--weight-heavy);
  }

  h1 {
    font-size: var(--hi-font-size--h1);
    line-height: var(--hi-font-lh--h1);
  }

  h2 {
    font-size: var(--hi-font-size--h2);
    line-height: var(--hi-font-lh--h2);
  }

  h3 {
    font-size: var(--hi-font-size--h3);
    line-height: var(--hi-font-lh--h3);
  }

  h4 {
    font-size: var(--hi-font-size--h4);
    line-height: var(--hi-font-lh--h4);
  }

  h5 {
    font-size: var(--hi-font-size--h5);
    line-height: var(--hi-font-lh--h5);
  }

  h6 {
    font-size: var(--hi-font-size--h6);
    line-height: var(--hi-font-lh--h6);
  }

  p,
  .text {
    font-family: var(--hi-font--family-content);
    font-size: var(--hi-font-size--text);
    line-height: var(--hi-font-lh--text);
  }

  h1 hi-link,
  h2 hi-link,
  h3 hi-link,
  h4 hi-link,
  h5 hi-link,
  h6 hi-link,
  strong hi-link {
    --hi-link--font-size: inherit;
    --hi-link--line-height: inherit;
    --hi-link--font-weight: inherit;
  }
`;
const template = document.createElement("template");
template.innerHTML = `<dom-module id="hi-theme">
  <template>
    <style>
      ${styles.cssText}
    </style>
  </template>
</dom-module>`;
document.head.appendChild(template.content);
export const stylesTheme = styles;
