
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
$ip.di.register("generator", "year", {
  id: "factory-generator-year",
  create(initial) {
    const selectedYear = f1.to.integer(initial);
    const startYear = selectedYear - 25;
    const endYear = selectedYear + 10;
    const years = Array.from({ length: endYear - startYear + 1 }, (_, index) => startYear + index);
    return years.map((year) => ({
      selected: year === selectedYear,
      title: year.toString(),
      value: year
    }));
  }
});
$ip.di.register("generator", "month", {
  id: "factory-generator-month",
  create(initial) {
    const selectedMonth = f1.to.integer(initial);
    return [
      "January",
      "February",
      "March",
      "April",
      "May",
      "June",
      "July",
      "August",
      "September",
      "October",
      "November",
      "December"
    ].map((month, index) => ({
      selected: index === selectedMonth,
      title: month,
      value: index
    }));
  }
});
