
import { afterNextRender } from '../../../hip/library/polymer/polymer.js';
import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import { BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { AsHIC, HIP } from '../../../eip/element/hi-component/hi-component.js';
export class EabElement extends BehaviorElement(AsHIC(PolymerElement)) {
  static get is() {
    return "hi-eab";
  }
  static get template() {
    return html`
      <style is="custom-style" include="hi-theme"></style>
      <style>
        :host {
          height: var(--hi-px-34);
          width: var(--hi-px-34);
          display: block;
          opacity: 0;
        }

        :host([disllow-animation]) {
          opacity: 1;
        }

        :host([x-fouc-done='true']:not([disllow-animation])) {
          transition: opacity 0.25s ease-in;
          opacity: 1;
        }

        svg {
          max-height: inherit;
          max-width: inherit;
          height: inherit;
          width: inherit;
        }
      </style>
      <svg
        xmlns="http://www.w3.org/2000/svg"
        viewBox="0 0 96 96"
        fill-rule="evenodd"
        stroke-linejoin="round"
        stroke-miterlimit="1.41421"
        xmlns:v="https://vecta.io/nano"
      >
        <g transform="matrix(1.86505 0 0 1.86139 -11.3081 -17.6139)">
          <g fill-rule="nonzero">
            <path
              d="M57 35.3c0 13.9-11.3 25.2-25.2 25.2S6.6 49.2 6.6 35.3C6.5 21.3 17.8 10 31.8 10 45.7 10 57 21.3 57 35.3"
              fill="var(--hi-clr--theme-3)"
            />
            <path
              d="M31.8 19.9c5.3 0 10.4 3.6 12.1 8.6l-3-1.3c-1.6-2.5-4.8-5.2-9.1-5.2-3.6 0-7.1 1.9-9.1 5.1l-3 1.3c1.7-4.9 6.8-8.5 12.1-8.5"
              fill="var(--hi-clr--theme-text-3)"
            />
            <path d="M31.8 27.8l-12.1 5.4V31l12.1-5.4L43.9 31v2.2l-12.1-5.4z" fill="#fff" />
          </g>
          <path
            d="M19.7 47.1h24.2v2H19.7zm14.5-11.8h2.4v9.2h-2.4zm-7.3 0h2.4v9.2h-2.4zm-7.2 0h2.4v9.2h-2.4zm21.7 0h2.4v9.2h-2.4z"
            fill="var(--hi-clr--theme-text-3)"
          />
        </g>
      </svg>
    `;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "presentation");
    this.__showAfterFirstRender();
  }
  __showAfterFirstRender() {
    afterNextRender(this, function() {
      this.setAttribute("x-fouc-done", "true");
    });
  }
}
export default HIP.factory.element(EabElement);
