
import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-component/hi-component.js';
export class ColumnElement extends BehaviorElement(AsHIC(PolymerElement)) {
  static get is() {
    return "hi-column";
  }
  static get template() {
    return html` <slot id="items"></slot> `;
  }
  static get properties() {
    return {
      id: {
        type: String
      },
      heading: {
        type: String
      },
      hint: {
        type: String
      },
      order: {
        type: Number,
        value: 0
      },
      type: {
        type: String
      },
      hidden: {
        type: Boolean
      },
      width: {
        type: String
      },
      allowSort: {
        type: Boolean
      },
      forceRender: {
        type: Boolean
      },
      className: {
        type: String,
        reflectToAttribute: true
      },
      fieldType: {
        type: Object
      }
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.style.display = "none";
  }
  attributeChangedCallback(attrName, oldVal, newVal, namespace) {
    super.attributeChangedCallback(attrName, oldVal, newVal, namespace);
    this._dispatchBubblingEvent("child-attribute-notified", {});
  }
}
HIP.factory.element(ColumnElement);
