
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from './hi-component-base.js';
import c11n from '../../../pip/library/pi-c11n/pi-c11n.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export function BaseBehaviorCustomizable(Base) {
  class BehaviorCustomizable2 extends Base {
    static get properties() {
      return {
        c11n: {
          type: String,
          observer: "_c11nChanged"
        }
      };
    }
    update(props) {
      super.update(props);
      if (props.has("c11n")) {
        this.__applyC11N(this.c11n);
      }
    }
    _c11nChanged(_c11n, _c11nOld) {
      this.__applyC11N(this.c11n);
    }
    __applyC11N(__c11n) {
      const _c11n = f1.split(",", this.c11n);
      const isDisallowed = c11n.isRuleOff("allowed", _c11n);
      c11n.applyRulesOne(this, _c11n);
      if (isDisallowed) {
        this.remove();
      }
    }
  }
  return window.HIP.factory.mixin(BehaviorCustomizable2);
}
export const BehaviorCustomizable = dedupingMixin(BaseBehaviorCustomizable);
HIP["BehaviorCustomizable"] = BehaviorCustomizable;
