
import '../../../hip/library/polymer/polymer.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
let once = false;
export class ServiceBaseline {
  get settings() {
    return this.__settings || {};
  }
  configure(_settings) {
    if (once) {
      return;
    }
    once = true;
    Object.defineProperty(this, "__settings", {
      value: Object.freeze(_settings),
      configurable: false,
      enumerable: true,
      writable: false
    });
    this.applySettingsAll();
  }
  applySettingsAll() {
    f1.each((settings, componentName) => {
      f1.each((tagEl) => {
        this.applySettingsTo(tagEl, componentName, settings);
      }, Array.from(document.getElementsByTagName(componentName)));
    }, this.settings);
  }
  applySettingsTo(el, componentName = el.localName, settings = this.settings[componentName]) {
    if (!settings) {
      return;
    }
    const dataHIP = window.HIP.data;
    f1.each((value, field) => {
      dataHIP.assignTo(el, field, value, void 0);
    }, settings);
  }
}
