
import '../../../hip/library/polymer/polymer.js';
const comparatorBuilder = (render_type, compare) => {
  return {
    entity: "comparator",
    render_type,
    compare
  };
};
window.HIP.visitor.add(
  comparatorBuilder("like", (left, right) => {
    return "string" === typeof left && "string" === typeof right ? left.indexOf(right) >= 0 || right.indexOf(left) >= 0 : left == right;
  })
);
window.HIP.visitor.add(
  comparatorBuilder("starts_with", (left, right) => {
    return "string" === typeof left && "string" === typeof right ? left.startsWith(right) : left == right;
  })
);
window.HIP.visitor.add(
  comparatorBuilder("in", (left, right) => {
    right = typeof right === "string" ? JSON.parse(right) : right;
    if (!right.length) {
      return false;
    }
    const n = right.length;
    let i = 0;
    for (; i < n; i++) {
      if (right[i] == left) {
        return true;
      }
    }
    return false;
  })
);
window.HIP.visitor.add(
  comparatorBuilder("==", (left, right) => {
    return left == right;
  })
);
window.HIP.visitor.add(
  comparatorBuilder("!=", (left, right) => {
    return left != right;
  })
);
window.HIP.visitor.add(
  comparatorBuilder(">", (left, right) => {
    return parseFloat(left) > parseFloat(right);
  })
);
window.HIP.visitor.add(
  comparatorBuilder("<", (left, right) => {
    return parseFloat(left) < parseFloat(right);
  })
);
window.HIP.visitor.add(
  comparatorBuilder(">=", (left, right) => {
    return parseFloat(left) >= parseFloat(right);
  })
);
window.HIP.visitor.add(
  comparatorBuilder("<=", (left, right) => {
    return parseFloat(left) <= parseFloat(right);
  })
);
window.HIP.visitor.add(
  comparatorBuilder("fallback", () => {
    return false;
  })
);
