
import { AsLitHIC, BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { css, html, LitElement } from '../../../hip/library/lit-element/lit-element.js';
export const styles = css`
  .container {
    display: inline-flex;
    align-items: center;
    background-color: var(--hi-clr--transparent);
    width: 4em;
    margin: 0 var(--hi-px-5);
  }

  .container:before,
  .container:after {
    content: ' ';
  }

  .loader {
    width: 1em;
    height: 1em;
    border-radius: 50%;
    -webkit-animation: typing 1s linear infinite alternate;
    -moz-animation: Typing 1s linear infinite alternate;
    animation: typing 1s linear infinite alternate;
    position: relative;
  }

  @keyframes typing {
    0% {
      background-color: var(--hi-clr--theme-5);
      box-shadow: var(--hi-px-24) var(--hi-px-0) var(--hi-px-0) var(--hi-px-0) var(--hi-clr--theme-1),
        var(--hi-px-48) var(--hi-px-0) var(--hi-px-0) var(--hi-px-0) var(--hi-clr--theme-1);
    }
    25% {
      background-color: var(--hi-clr--theme-3);
      box-shadow: var(--hi-px-24) var(--hi-px-0) var(--hi-px-0) var(--hi-px-0) var(--hi-clr--theme-5),
        var(--hi-px-48) var(--hi-px-0) var(--hi-px-0) var(--hi-px-0) var(--hi-clr--theme-1);
    }
    75% {
      background-color: var(--hi-clr--theme-3);
      box-shadow: var(--hi-px-24) var(--hi-px-0) var(--hi-px-0) var(--hi-px-0) var(--hi-clr--theme-1),
        var(--hi-px-48) var(--hi-px-0) var(--hi-px-0) var(--hi-px-0) var(--hi-clr--theme-5);
    }
  }
`;
export class IndicatorElement extends BehaviorElement(AsLitHIC(LitElement)) {
  static get is() {
    return "hi-indicator";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "presentation");
  }
  render() {
    return html`
      <div class="container">
        <div class="loader"></div>
      </div>
    `;
  }
}
export default HIP.factory.element(IndicatorElement);
