
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { BehaviorValidationMask } from '../../../eip/element/hi-behavior-validation/hi-behavior-validation-mask.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-component/hi-component.js';
export class ValidationMask extends BehaviorValidationMask(BehaviorElement(AsHIC(PolymerElement))) {
  static get is() {
    return "hi-validation-mask";
  }
  static get autoBinding() {
    return {
      signal: "rule-changed",
      field: "rule"
    };
  }
  _validationChanged(rule = "", placeholder) {
    super._validationChanged(rule, placeholder);
    const parentElement = this.parentElement;
    parentElement.maxlength = rule.length;
    parentElement.mask = rule;
    if (parentElement.value) {
      parentElement.value = this._mask(parentElement.value, rule);
    }
  }
  checkValidity(value) {
    return !this.rule || this._maskValidate(value, this.rule);
  }
}
export default HIP.factory.element(ValidationMask);
