
import { repeat } from '../../../hip/library/lit-html/directives/repeat.js';
import { html, nothing } from '../../../hip/library/lit-html/lit-html.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
$ip.di.register("iterator", "tree", {
  id: "factory-iterator-tree",
  render(context) {
    const readIdFn = f1.read("/value", 0);
    return (option, index, templateFn) => {
      return html`
        <hi-leaf .leafIcon=${option.icon} .value=${option.value} .ns=${context.ns}>${option.title}</hi-leaf>
        ${!option.children ? nothing : html`<hi-sub-tree heading=${option.children.title} .ns=${context.ns}>
              ${repeat(
        option.children.list,
        readIdFn,
        (item, index2) => html`${templateFn(item, index2, templateFn)}`
      )}</hi-sub-tree
            >`}
      `;
    };
  }
});
$ip.di.register("iterator", "menu", {
  id: "factory-iterator-menu",
  render(context) {
    const readIdFn = f1.read("/value", 0);
    const findSubChildren = f1.find(f1.is.in("children"));
    return (option, index, templateFn) => {
      const hasNoSubChildren = f1.is.nil(findSubChildren(f1.read("/children/list", [], option)));
      return html` <hi-pick .value=${option.value} .ns=${context.ns}>${option.title}</hi-pick>
        ${!option.children ? nothing : html`<hi-sub-menu heading=${option.children.title} .ns=${context.ns} ?cap-height=${hasNoSubChildren}>
              ${repeat(
        option.children.list,
        readIdFn,
        (item, index2) => html`${templateFn(item, index2, templateFn)}`
      )}</hi-sub-menu
            >`}`;
    };
  }
});
$ip.di.register("iterator", "select", {
  id: "factory-iterator-select",
  render(context) {
    return (option) => {
      return html`<hi-option .icon=${option.icon} .value=${option.value} .ns=${context.ns}>${option.title}</hi-option>`;
    };
  }
});
$ip.di.register("iterator", "list", {
  id: "factory-iterator-list",
  render(context) {
    return (option) => {
      return html`<hi-item .value=${option.value} .ns=${context.ns}>${option.title}</hi-item>`;
    };
  }
});
$ip.di.register("iterator", "ul", {
  id: "factory-iterator-ul",
  render(context) {
    return (option, index) => {
      return html`<li kind="no-dot" data-index=${index} .value=${option.value}>${option.title}</li>`;
    };
  }
});
$ip.di.register("iterator", "color", {
  id: "factory-iterator-color",
  render(context) {
    return (option) => {
      return html`<hi-option .value=${option.value}>
        <hi-color
          size="large"
          .value=${option.value}
          .ns=${context.ns}
          aria-label="color swatch for ${option.title}"
        ></hi-color>
        <span>${option.title}</span>
      </hi-option>`;
    };
  }
});
$ip.di.register("iterator", "icon", {
  id: "factory-iterator-icon",
  render(context) {
    return (option) => {
      return html`<hi-option .icon=${option.value} .ns=${context.ns} .value=${option.value}
        >${option.title}</hi-option
      >`;
    };
  }
});
