
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { LitElement, css, html } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorItemFocus } from '../../../eip/element/hi-behavior-set-focus/hi-behavior-item-focus.js';
import { BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { AsLitHIC, HIP } from '../../../eip/element/hi-component/hi-component.js';
export const styles = css`
  :host {
    min-height: var(--hi-el--height);
    padding: var(--hi-px-6) var(--hi-px-8);

    line-height: var(--hi-font-lh--medium);
    font-size: var(--hi-font-size--text);

    border-radius: var(--hi-shape--radius-2);
    box-sizing: border-box;

    border: var(--hi-px-2) solid var(--hi-clr--transparent);
    color: var(--hi-clr--text);
    background: transparent;
    display: flex;
    outline: 0;
  }

  :host([fit-width]) {
    white-space: normal !important;
  }

  :host(:hover:not([disabled])) {
    background: var(--hi-clr--gray-2);
  }

  :host([disabled]) {
    color: var(--hi-clr--disabled);
    pointer-events: all !important;
  }

  :host(:active:not([disabled])) {
    border-color: var(--hi-clr--gray-7);
    background: var(--hi-clr--gray-2);
  }

  @media only screen and (max-width: 40rem) {
    :host(:not([disallow-responsiveness])) {
      height: var(--hi-el--height-mobile);
      justify-content: center;
      flex-direction: column;
      align-content: center;
      display: flex;
    }
  }
`;
export class ItemElement extends BehaviorItemFocus(BehaviorElement(AsLitHIC(LitElement))) {
  static get is() {
    return "hi-item";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  render() {
    return html` <slot></slot> `;
  }
  static get api() {
    return ["focus"];
  }
  static get autoBinding() {
    return {
      signal: "focused-changed",
      field: "focused"
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "option");
  }
}
export default HIP.factory.element(ItemElement);
