
import { directive, Directive, PartType } from '../../../hip/library/lit-html/directive.js';
import { noChange } from '../../../hip/library/lit-html/lit-html.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
export class SetAttributesDirective extends Directive {
  constructor(partInfo) {
    super(partInfo);
    if (partInfo.type !== PartType.ATTRIBUTE) {
      throw new Error("setAttributes applies to attribute (data-attrs)");
    }
  }
  update(part, [attrs]) {
    dom.setAttrs(part.element, attrs);
    return noChange;
  }
  render(attrs) {
    return noChange;
  }
}
export const setAttributes = directive(SetAttributesDirective);
