
import { AsLitHIC, HIP, BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { LitElement, css, html, nothing } from '../../../hip/library/lit-element/lit-element.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
export const styles = css``;
const _LottiePlayerElement = class extends BehaviorElement(AsLitHIC(LitElement)) {
  constructor() {
    super();
    this.src = "loading";
    this.width = "auto";
    this.height = "auto";
    $ip.require("lottie-player");
  }
  static get is() {
    return "hi-lottie";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  static get properties() {
    return {
      src: {
        type: String
      },
      width: {
        type: String
      },
      height: {
        type: String
      }
    };
  }
  render() {
    const src = this.src;
    const internalLottieFile = _LottiePlayerElement.lottieFileMap[src];
    const lottieFilePath = internalLottieFile ? $ip.path(`@eab-eip/assets/hi-lottie/${internalLottieFile}`) : void 0;
    if (!lottieFilePath) {
      return nothing;
    }
    const heightPx = this.height === "auto" ? this.height : `${this.height}px`;
    const widthPx = this.width === "auto" ? this.width : `${this.width}px`;
    const style = `width:${heightPx};height:${widthPx}`;
    return html`
      <lottie-player
        id="lottie"
        style=${style}
        src=${lottieFilePath}
        background="transparent"
        speed="1"
        autoplay
        loop
      ></lottie-player>
    `;
  }
};
export let LottiePlayerElement = _LottiePlayerElement;
LottiePlayerElement.lottieFileMap = {
  loading: "loading.json",
  error: "error.json",
  empty: "empty.json",
  404: "404.json"
};
export default HIP.factory.element(LottiePlayerElement);
