
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { LitElement, css, html } from '../../../hip/library/lit-element/lit-element.js';
import { nothing } from '../../../hip/library/lit-html/lit-html.js';
import { AsLitHIC, HIP, BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import $ip from '../../../pip/library/pi-ip/pi-ip.js';
import navigationService from './hi-service-navigation.js';
export const styles = css`
  :host {
    color: var(--hi-clr--university-text, var(--hi-clr--white));
    background-color: var(--hi-clr--university-bkg, var(--hi-clr--eab));
    border-bottom: var(--hi-px-4) solid var(--hi-clr--university-primary);
    height: var(--hi-screen--nav-primary);
    width: var(--hi-site--full-width);
    line-height: var(--hi-px-32);
    position: relative;
    display: block;
  }

  #content {
    justify-content: flex-start;
    align-items: center;
    margin: 0 auto;
    display: flex;
    height: 100%;
    width: calc(var(--hi-site--full-width) - var(--hi-px-28));
  }

  #activity {
    margin-left: auto;
    margin-right: calc(-1 * var(--hi-px-14));
    width: calc(2 * var(--hi-px-16));
  }

  :host([layout='center']) #content {
    width: var(--hi-site--narrow-width);
  }
`;
export class PrimaryNavigationElement extends BehaviorElement(AsLitHIC(LitElement)) {
  static get is() {
    return "hi-navigation-primary";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  static get properties() {
    return {
      title: {
        type: String
      }
    };
  }
  connectedCallback() {
    super.connectedCallback();
    navigationService.toggleMicroNavigationStyling(this, "primary", true);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    navigationService.toggleMicroNavigationStyling(this, "primary", false);
  }
  render() {
    const flag__showNetworkActivity = $ip.flags.is("/eip/hi-navigation/show-network-activity", true);
    return html`
      <section id="content">
        <slot>${this.title}</slot>
        ${flag__showNetworkActivity ? html`<hi-navigation-network-activity id="activity"></hi-navigation-network-activity>` : nothing}
      </section>
    `;
  }
}
export default HIP.factory.element(PrimaryNavigationElement);
