
import { PolymerElement, html } from '../../../hip/library/polymer/polymer.js';
import { AsHIC, HIP, BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import '../../../eip/element/hi-button/hi-button.js';
import '../../../eip/element/hi-icon/hi-icon.js';
export class TertiaryNavigationToggleElement extends BehaviorElement(AsHIC(PolymerElement)) {
  static get is() {
    return "hi-navigation-tertiary-toggle";
  }
  static get template() {
    return html`
      <style is="custom-style" include="hi-theme"></style>
      <style>
        :host {
          display: inline-block;
        }

        @media only screen and (min-width: 40rem) {
          :host {
            display: none;
          }
        }
      </style>
      <hi-button
        id="tertiaryNavigationToggle"
        aria-controls="tertiaryNavigation"
        x-style="tertiary-nav-menu-btn"
        aesthetic$="[[ aesthetic ]]"
        size$="[[ size ]]"
        on-trigger-ended="toggle"
      >
        <hi-icon mode="presentation" kind="menu"></hi-icon>
      </hi-button>
    `;
  }
  static get properties() {
    return {
      for: {
        type: String,
        reflectToAttribute: true,
        value: "hi-navigation-tertiary"
      },
      aesthetic: {
        type: String,
        reflectToAttribute: true,
        value: "primary"
      },
      size: {
        type: String,
        reflectToAttribute: true
      }
    };
  }
  toggle() {
    const tertiaryNavigation = this.__getTertiaryNavigation();
    this.$.tertiaryNavigationToggle.setAttribute("aria-pressed", "true");
    tertiaryNavigation.toggle();
    tertiaryNavigation.focus();
  }
  __getTertiaryNavigation() {
    return HIP.browser.queryOne(this.for);
  }
}
export default HIP.factory.element(TertiaryNavigationToggleElement);
