
import { TemplateStamp } from '../../../hip/library/polymer/polymer.js';
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { HIP, AsHIC } from '../../../eip/element/hi-hip/hi-hif.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class HIObjectStampElement extends TemplateStamp(AsHIC(PolymerElement)) {
  static get is() {
    return "hi-object-stamp";
  }
  static get properties() {
    return {
      template: Object,
      object: Object,
      reference: Object,
      value: {
        type: Object,
        computed: "__valueCompute(object, reference)"
      }
    };
  }
  static get observers() {
    return ["__objectWatcher(object, reference)"];
  }
  __valueCompute(object, reference) {
    if (!object) {
      return "";
    }
    const ref = typeof reference === "string" ? reference : reference.id;
    const _value = f1.read(f1.path(ref), "", object);
    return f1.read(`/fieldType/options/${f1.path(_value)}`, _value, reference);
  }
  __formatCell(ref, object, reference) {
    const _value = f1.read(f1.path(ref), "", object);
    return f1.read(`/fieldType/options/${f1.path(_value)}`, _value, reference);
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("hidden", "hidden");
  }
  __objectWatcher() {
    this.__insertExternalTemplate();
  }
  __insertExternalTemplate() {
    if (this.__stamped && this.parentElement) {
      Array.from(this.parentElement.children).filter((n) => n.nodeName !== "HI-OBJECT-STAMP").forEach((n) => {
        if (n != null) {
          n.remove();
        }
      });
    }
    this.__stamped = void 0;
    if (this.template == null) {
      const reference = this.reference;
      const ref = f1.read("/id", reference, reference);
      this.template = document.createElement("template");
      this.template.ns = this.ns;
      const templateValue = ref ? `[[ __formatCell('${ref}', object, reference) ]]` : ``;
      this.template.innerHTML = `<span>${templateValue}</span>`;
    }
    this.__stamped = this._stampTemplate(this.template);
    const el = this.__stamped;
    if (el && this.parentElement) {
      this.parentElement.appendChild(el);
    }
  }
}
HIP.factory.element(HIObjectStampElement);
export default "hi-object-stamp";
