
import { PolymerElement } from '../../../hip/library/polymer/polymer.js';
import { HIP, AsHIC, BehaviorElement } from '../../../eip/element/hi-hip/hi-hif.js';
import { BehaviorAssignment } from '../../../eip/element/hi-behavior-assignment/hi-behavior-assignment.js';
import { BehaviorImperativeElement } from '../../../eip/element/hi-behavior-imperative/hi-behavior-imperative.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class PipeElement extends BehaviorAssignment(BehaviorImperativeElement(BehaviorElement(AsHIC(PolymerElement)))) {
  static get is() {
    return "hi-pipe";
  }
  static get properties() {
    return {
      source: {
        type: Object,
        reflectToAttribute: true
      },
      sourceField: {
        type: String,
        reflectToAttribute: true
      }
    };
  }
  static get api() {
    return ["invoke"];
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this._unlinkReferences();
  }
  invoke(_value, event = document.createEvent("CustomEvent")) {
    if (this.disabled) {
      return Promise.resolve("disabled");
    }
    const sourceEl = this._sourceEl = this._lookupNode(this.source);
    const sourceField = sourceEl ? this.sourceField = this.sourceField || sourceEl.autoBinding.field : void 0;
    const value = sourceEl && sourceField ? sourceEl[sourceField] : _value;
    const promiseRtn = this._invoke(value, event);
    const promise = f1.is.array(promiseRtn) ? Promise.all(promiseRtn) : promiseRtn;
    return promise.catch(() => Promise.resolve(void 0));
  }
  memento() {
    const _memento = super.memento();
    _memento.sourceField = this.sourceField;
    _memento.source = this.source;
    return _memento;
  }
}
HIP.factory.element(PipeElement);
