
import { afterNextRender } from '../../../hip/library/polymer/polymer.js';
import { DomRepeat } from '../../../hip/library/polymer/polymer.js';
import '../../../hip/library/polymer/polymer.js';
import { HIP, BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorIO } from '../../../eip/element/hi-behavior-io/hi-behavior-io.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
function AsHICDomRepeat(p) {
  return p;
}
export class RepeatElement extends BehaviorIO(BehaviorElement(AsHICDomRepeat(DomRepeat))) {
  constructor() {
    super();
    this.respondToModifiers = true;
    this.renderedItemCount = 100;
    this.targetFramerate = 15;
    this.initialCount = 50;
    this.delay = 128;
  }
  static get is() {
    return "hi-repeat";
  }
  static get properties() {
    return {
      as: {
        type: String,
        value: "item"
      },
      filterRule: {
        type: Object
      },
      valueAttr: {
        type: String,
        value: "value",
        observer: "__valueAttrChanged"
      },
      map: {
        type: Function
      }
    };
  }
  static get valueEvent() {
    return "output-changed";
  }
  static get autoBinding() {
    return {
      signal: "output-changed",
      field: "input"
    };
  }
  static get observers() {
    return ["__outputWatcher(output)"];
  }
  connectedCallback() {
    super.connectedCallback();
    this.addEventListener("modified-notified", this.__onModifierModified);
    this.__onMutationObserverBound = this.__onMutationObserver.bind(this);
    this.__observer = new MutationObserver(this.__onMutationObserverBound);
    this.__observer.observe(this, {
      childList: true
    });
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.__onMutationObserverBound = void 0;
    if (this.__observer) {
      this.__observer.disconnect();
    }
  }
  __onModifierModified() {
    this.render();
  }
  __onMutationObserver(mutations) {
    let hasAdded = false;
    mutations.forEach((mutation) => {
      if (mutation.addedNodes.length > 0) {
        hasAdded = true;
      }
    });
    if (hasAdded) {
      this.__aggressiveForceRender();
    }
  }
  __aggressiveForceRender() {
    if (this.items) {
      this.splice("items", 0, this.items.length);
    }
    if (this.input) {
      this.flush();
    }
  }
  render() {
    this.flush();
    super.render();
  }
  __valueAttrChanged(valueAttr) {
    this.filter = this.__filterRule;
    this.observe = `filterRule ${valueAttr}`;
  }
  __filterRule(item) {
    if (!this.filterRule) {
      return true;
    } else if (this.filterRule instanceof RegExp) {
      return item[this.valueAttr].match(this.filterRule) !== null;
    } else if (typeof this.filterRule === "string") {
      return item[this.valueAttr] === this.filterRule;
    }
    return true;
  }
  __outputWatcher(output) {
    const items = Array.isArray(output) ? output : Object.values(output);
    afterNextRender(this, function() {
      this.items = this.map ? f1.map(this.map, items) : [...items];
    });
  }
  emptyAppend() {
    if (this.items == null) {
      this.set("items", []);
    }
    this.input = this.items = [
      ...this.items,
      {
        idx: f1.ascending()
      }
    ];
    this.set("items", this.items);
  }
  emptyRemoveIndex(index) {
    if (index != null) {
      this.splice("items", index, 1);
      this.input = this.items;
    }
  }
}
export default HIP.factory.element(RepeatElement);
