
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { LitElement, css, html } from '../../../hip/library/lit-element/lit-element.js';
import { nothing } from '../../../hip/library/lit-html/lit-html.js';
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-component/hi-component.js';
export const styles = css`
  :host {
    display: block;
    min-width: 100%;
    width: 100%;
    height: var(--hi-px-32);
  }

  hr,
  #content {
    position: relative;
  }

  hr {
    background-color: var(--hi-clr--theme-3);
    height: var(--hi-px-1);
    top: var(--hi-px-16);
    border: none;
  }

  #content {
    background: white;
    color: var(--hi-clr--theme-5);
    border: var(--hi-px-1) solid var(--hi-clr--theme-3);
    border-radius: var(--hi-shape--radius-2);
    font-size: var(--hi-font-size--text);
    font-variant: small-caps;
    /* 16 + 4, where the 16 is half height and 4 is padding to center */
    top: var(--hi-px-20);
    padding: var(--hi-px-4);
    display: inline-block;
    margin: auto;
    left: 50%;
    transform: translate(-50%, -90%);
  }
`;
export class SeparatorElement extends BehaviorElement(AsHIC(LitElement)) {
  static get is() {
    return "hi-separator";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  static get properties() {
    return {
      value: {
        type: String,
        reflect: true
      }
    };
  }
  render() {
    return html`
      <hr />
      ${this.value ? html` <div id="content">${this.value}</div> ` : nothing}
    `;
  }
  connectedCallback() {
    super.connectedCallback();
    if (!this.hasAttribute("theme")) {
      this.setAttribute("theme", "gray");
    }
  }
}
export default HIP.factory.element(SeparatorElement);
