
import { LitElement, html, css } from '../../../hip/library/lit-element/lit-element.js';
import { BehaviorElement, AsLitHIC, HIP } from '../../../eip/element/hi-component/hi-component.js';
export const styles = css`
  #container {
    margin: auto;
    display: flex;
    gap: var(--hi-px-12);
    padding: var(--hi-px-12);
  }

  :host([layout='hort']) #container {
    justify-content: center;
    flex-direction: row;
    max-width: 100%;
  }

  :host([layout='vert']) #container {
    flex-direction: column;
    margin: auto;
  }

  :host([layout='grid']) #container {
    display: grid;
    grid-gap: var(--hi-px-12);
    grid-template-columns: repeat(3, 1fr);
    width: 100% !important;
  }

  :host([aesthetic='dim']) #container {
    background-color: var(--hi-clr--gray-1);
  }
`;
export class TileGroupElement extends BehaviorElement(AsLitHIC(LitElement)) {
  static get is() {
    return "hi-tile-group";
  }
  static get styles() {
    return [styles];
  }
  static get properties() {
    return {
      aesthetic: {
        type: String,
        reflect: true
      }
    };
  }
  render() {
    return html`
      <div id="container">
        <slot id="items"></slot>
      </div>
    `;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "group");
  }
}
export default HIP.factory.element(TileGroupElement);
