
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};
import { AsHIC, BehaviorElement, HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorFlow } from '../../../eip/element/hi-behavior-flow/hi-behavior-flow.js';
import { LitElement, css, html } from '../../../hip/library/lit-element/lit-element.js';
import { queryAssignedNodes } from '../../../hip/library/lit-element/decorators.js';
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { styles as flowTheme } from '../../../eip/element/hi-behavior-flow/hi-behavior-flow-style.js';
import { stylesTile } from '../../../eip/element/hi-behavior-style/hi-style-tile.js';
export const styles = css`
  :host {
    --toolbar-background: var(--hi-clr--gray-1);
  }

  #header {
    display: none;
    background-color: var(--toolbar-background);
  }

  :host([allow-toolbar]) #header {
    display: flex;
  }

  #header ::slotted([slot='title']) {
    margin-right: var(--hi-px-2);
  }

  #header ::slotted([slot='toolbar']:not(:first-of-type)) {
    margin-left: var(--hi-px-8);
  }

  #header ::slotted([slot='toolbar']:first-of-type) {
    margin-left: auto;
  }

  :host([aesthetic='invisible']) {
    border-color: var(--hi-clr--transparent);
    background: var(--hi-clr--transparent);
    box-shadow: none;
  }

  :host([aesthetic='invisible']) #header {
    background-color: var(--hi-clr--transparent);
    border-bottom: none;
  }

  :host([aesthetic='fill']),
  :host([aesthetic='tint']) {
    border-color: var(--hi-clr--theme-3);
    background: var(--hi-clr--theme-1);
  }

  :host([aesthetic='outline']) {
    border-color: var(--hi-clr--theme-3);
  }

  :host([aesthetic='outline']) #header,
  :host([aesthetic='tint']) #header {
    background-color: var(--hi-clr--white);
    border-color: var(--hi-clr--theme-3);
  }

  :host([theme]) {
    --toolbar-background: var(--hi-clr--white);
  }

  :host([disabled]) {
    background-color: var(--hi-clr--gray-1);
    border-color: var(--hi-clr--theme-3);
    box-shadow: none;
  }
`;
export class TileElement extends BehaviorFlow(BehaviorElement(AsHIC(LitElement))) {
  constructor() {
    super(...arguments);
    this.allowToolbar = false;
  }
  static get is() {
    return "hi-tile";
  }
  static get styles() {
    return [stylesTheme, flowTheme, stylesTile, styles];
  }
  static get properties() {
    return {
      aesthetic: {
        type: String,
        reflect: true
      },
      allowToolbar: {
        type: Boolean,
        attribute: "allow-toolbar",
        reflect: true
      }
    };
  }
  render() {
    return html`
      <header id="header">
        <slot id="title" name="title" @slotchange="${this.__willAllowToolbar}"></slot>
        <slot id="toolbar" name="toolbar" @slotchange="${this.__willAllowToolbar}"></slot>
      </header>
      <slot></slot>
    `;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "article");
  }
  __willAllowToolbar() {
    this.allowToolbar = this.__toolbar.length > 0 || this.__title.length > 0;
  }
}
__decorateClass([
  queryAssignedNodes({ slot: "toolbar" })
], TileElement.prototype, "__toolbar", 2);
__decorateClass([
  queryAssignedNodes({ slot: "title" })
], TileElement.prototype, "__title", 2);
export default HIP.factory.element(TileElement);
