
import { directive, Directive, PartType } from '../../../hip/library/lit-html/directive.js';
import { noChange } from '../../../hip/library/lit-html/lit-html.js';
export class WriteAlwaysDirective extends Directive {
  constructor(partInfo) {
    super(partInfo);
    if (partInfo.type !== PartType.PROPERTY) {
      throw new Error("writeAlways applies to properties");
    }
  }
  update(part, [val]) {
    part.element[part.name] = val;
    return noChange;
  }
  render(val) {
    return noChange;
  }
}
export const writeAlways = directive(WriteAlwaysDirective);
