const legacyCustomElement = (tagName, clazz) => {
    customElements.define(tagName, clazz);
    return clazz;
};
const standardCustomElement = (tagName, descriptor) => {
    const { kind, elements } = descriptor;
    return {
        kind,
        elements,
        finisher(clazz) {
            customElements.define(tagName, clazz);
        },
    };
};
const customElement = (tagName) => (classOrDescriptor) => typeof classOrDescriptor === 'function'
    ? legacyCustomElement(tagName, classOrDescriptor)
    : standardCustomElement(tagName, classOrDescriptor);

export { customElement };

//# sourceMappingURL=custom-element.js.map
