import { decorateProperty } from './base.js';
import { queryAssignedElements } from './query-assigned-elements.js';

function queryAssignedNodes(slotOrOptions, flatten, selector) {
    let slot = slotOrOptions;
    let assignedNodesOptions;
    if (typeof slotOrOptions === 'object') {
        slot = slotOrOptions.slot;
        assignedNodesOptions = slotOrOptions;
    }
    else {
        assignedNodesOptions = { flatten };
    }
    if (selector) {
        return queryAssignedElements({
            slot: slot,
            flatten,
            selector,
        });
    }
    return decorateProperty({
        descriptor: (_name) => ({
            get() {
                var _a, _b;
                const slotSelector = `slot${slot ? `[name=${slot}]` : ':not([name])'}`;
                const slotEl = (_a = this.renderRoot) === null || _a === void 0 ? void 0 : _a.querySelector(slotSelector);
                return (_b = slotEl === null || slotEl === void 0 ? void 0 : slotEl.assignedNodes(assignedNodesOptions)) !== null && _b !== void 0 ? _b : [];
            },
            enumerable: true,
            configurable: true,
        }),
    });
}

export { queryAssignedNodes };

//# sourceMappingURL=query-assigned-nodes.js.map
