const forAwaitOf = async (iterable, callback) => {
    for await (const v of iterable) {
        if ((await callback(v)) === false) {
            return;
        }
    }
};
class PseudoWeakRef {
    constructor(ref) {
        this._ref = ref;
    }
    disconnect() {
        this._ref = undefined;
    }
    reconnect(ref) {
        this._ref = ref;
    }
    deref() {
        return this._ref;
    }
}
class Pauser {
    constructor() {
        this._promise = undefined;
        this._resolve = undefined;
    }
    get() {
        return this._promise;
    }
    pause() {
        var _a;
        (_a = this._promise) !== null && _a !== void 0 ? _a : (this._promise = new Promise((resolve) => (this._resolve = resolve)));
    }
    resume() {
        var _a;
        (_a = this._resolve) === null || _a === void 0 ? void 0 : _a.call(this);
        this._promise = this._resolve = undefined;
    }
}

export { Pauser, PseudoWeakRef, forAwaitOf };

//# sourceMappingURL=private-async-helpers.js.map
