import { TemplateInstanceBase, templatize, modelForElement } from '../utils/templatize.js'; 

let TemplatizerUser; 

export const Templatizer = {

  templatize(template, mutableData) {
    this._templatizerTemplate = template;
    this.ctor =
        templatize(template,  (this), {
          mutableData: Boolean(mutableData),
          parentModel: this._parentModel,
          instanceProps: this._instanceProps,
          forwardHostProp: this._forwardHostPropV2,
          notifyInstanceProp: this._notifyInstancePropV2
        });
  },

  stamp(model) {
    return new this.ctor(model);
  },

  modelForElement(el) {
    return modelForElement(this._templatizerTemplate, el);
  }
};

//# sourceMappingURL=templatizer-behavior.js.map
