import './boot.js';
import {enqueueDebouncer, flushDebouncers} from '../utils/debounce.js';
export {enqueueDebouncer};

export const flush = function() {
  let shadyDOM, debouncers;
  do {
    shadyDOM = window.ShadyDOM && ShadyDOM.flush();
    if (window.ShadyCSS && window.ShadyCSS.ScopingShim) {
      window.ShadyCSS.ScopingShim.flush();
    }
    debouncers = flushDebouncers();
  } while (shadyDOM || debouncers);
};

//# sourceMappingURL=flush.js.map
