import './boot.js';

let dedupeId = 0;

function MixinFunction(){}
MixinFunction.prototype.__mixinApplications;
MixinFunction.prototype.__mixinSet;

export const dedupingMixin = function(mixin) {
  let mixinApplications = (mixin).__mixinApplications;
  if (!mixinApplications) {
    mixinApplications = new WeakMap();
(mixin).__mixinApplications = mixinApplications;
  }
  let mixinDedupeId = dedupeId++;
  function dedupingMixin(base) {
    let baseSet = (base).__mixinSet;
    if (baseSet && baseSet[mixinDedupeId]) {
      return base;
    }
    let map = mixinApplications;
    let extended = map.get(base);
    if (!extended) {
      extended = (mixin)(base);
      map.set(base, extended);
      let mixinSet = Object.create((extended).__mixinSet || baseSet || null);
      mixinSet[mixinDedupeId] = true;
(extended).__mixinSet = mixinSet;
    }
    return extended;
  }

  return dedupingMixin;
};

//# sourceMappingURL=mixin.js.map
