
import { css } from '../../../hip/library/lit-element/lit-element.js';
export const gridStyles = css`
  [hover='parent'] {
    position: relative;
  }

  [hover='parent'] > [hover='child'] {
    visibility: hidden;
    z-index: -100;
    display: none;
  }

  [hover='parent']:focus > [hover='child'],
  [hover='parent']:hover > [hover='child'],
  [hover='parent'][hover-show] > [hover='child'] {
    z-index: var(--hi-depth--above-all);
    visibility: visible;
    display: block;
  }

  .grid__row {
    width: 100%;
    display: flex;
    flex: 1 1 auto;
  }

  .row__cell {
    background-color: var(--hi-clr--white);
    color: var(--hi-clr--theme-text);

    display: flex;
    align-items: center;

    padding: 0 var(--grid--cell-padding);

    font-family: inherit;
    font-size: var(--hi-font-size--text);
    text-align: left;
  }

  .row--frozen-fixed {
    width: var(--grid--row-selector-width);
    min-width: var(--grid--row-selector-width);
    justify-content: center;
  }

  .grid__row > .row__cell.row--frozen,
  .grid__row > .row__cell.row--frozen-fixed {
    position: sticky;
    z-index: 100;
  }

  .grid__row > .row__cell.row--frozen-fixed:nth-child(1) {
    left: 0;
  }

  .grid__row > .row__cell.row--frozen-fixed:nth-child(2) {
    left: var(--grid--row-selector-width);
  }

  .grid__row > .row__cell.row--frozen:nth-child(1) {
    left: 0;
  }

  .grid__row > .row__cell.row--frozen:nth-child(2) {
    left: var(--grid--row-selector-width);
  }

  .grid__row > .row__cell.row--frozen:nth-child(3) {
    left: calc(2 * var(--grid--row-selector-width));
  }

  .row--selector hi-checkbox {
    margin: auto;
  }

  .grid__row,
  .row__cell {
    height: var(--hi-grid--row-height);
  }

  .grid__bar {
    padding: 0 var(--grid--cell-padding);
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    align-items: center;
    height: 100%;
  }

  .grid__bar--right,
  .grid__bar--left {
    display: flex;
    align-items: center;
    gap: var(--hi-px-6);
  }

  .grid__bar--middle {
    padding: 0 var(--hi-px-6);
    flex-grow: 100;
  }

  .grid__bar--right {
    margin-left: auto;
  }

  .grid__bar--left {
    margin-right: auto;
  }

  ul {
    list-style: none;
    padding: 0;
    margin: 0;
  }

  .hide-content {
    visibility: hidden;
    position: absolute;
    height: 1px;
    width: 1px;
    overflow: hidden;
    clip: rect(1px, 1px, 1px, 1px);
  }
`;
export const computeCellStyle = (field) => {
  const widthStyle = `var(--grid--column-${field.name})`;
  return `min-width: ${widthStyle}; width: ${widthStyle};`;
};
