
import { repeat } from '../../../hip/library/lit-html/directives/repeat.js';
import { html, LitElement } from '../../../hip/library/lit-element/lit-element.js';
import { nothing } from '../../../hip/library/lit-html/lit-html.js';
import { AsLitHIC } from '../../../eip/element/hi-component/hi-component.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import dom from '../../../pip/library/pi-dom/pi-dom.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export class LoopElement extends AsLitHIC(LitElement) {
  static get is() {
    return "vi-loop";
  }
  static get properties() {
    return {
      input: {
        type: Array
      },
      context: {
        type: Object
      },
      template: {
        type: Object,
        attribute: false
      }
    };
  }
  connectedCallback() {
    super.connectedCallback();
    dom.setAttrs(this, {
      role: "list"
    });
  }
  createRenderRoot() {
    return this;
  }
  render() {
    if (!this.template) {
      return nothing;
    }
    const readIdFn = f1.read("/id", 0);
    const input = f1.safe([], this.input);
    const templateFn = this.template.render(f1.safe({}, this.context));
    return html`
      ${repeat(
      input,
      readIdFn,
      (item, index) => html`<li kind="no-dot" data-index=${index}>${templateFn(item, index)}</li>`
    )}
    `;
  }
  shouldUpdate(changedProperties) {
    return changedProperties.has("input") || changedProperties.has("template") || changedProperties.has("context");
  }
}
export default HIP.factory.element(LoopElement);
