
import { html, css, LitElement } from '../../../hip/library/lit-element/lit-element.js';
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { AsLitHIC, BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import './vi-metric.js';
export const styles = css`
  :host {
    display: flex;
    justify-content: start;
    flex: 1;
    flex-flow: row wrap;
    align-self: center;
    gap: var(--hi-px-12);
  }
`;
export class MetricGroupElement extends BehaviorElement(AsLitHIC(LitElement)) {
  static get is() {
    return "vi-metric-group";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "group");
  }
  render() {
    return html`<slot id="items"></slot>`;
  }
}
export default HIP.factory.element(MetricGroupElement);
