
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
import { dedupingMixin } from '../../../hip/library/polymer/polymer.js';
import { HIP } from '../../../eip/element/hi-component/hi-component.js';
import { BehaviorBehavior } from '../../../eip/element/hi-behavior-behavior/hi-behavior-behavior.js';
import { LayoutScreenQueryElement } from '../../../yip/element/yi-layout-screen-query/yi-layout-screen-query.js';
export function BaseBehaviorScreenQuery(Base) {
  class BehaviorScreenQuery2 extends BehaviorBehavior(Base) {
    constructor() {
      super(...arguments);
      this.screenQuery = LayoutScreenQueryElement.instance;
    }
    static get properties() {
      return {
        screenDevice: {
          type: String,
          attribute: "screen-device",
          reflect: true
        },
        forcedScreenDevice: {
          type: String,
          attribute: "forced-screen-device"
        },
        disallowResponsiveness: {
          type: Boolean,
          attribute: "disallow-responsiveness"
        }
      };
    }
    connectedCallback() {
      super.connectedCallback();
      this.screenQuery.subscribe(this);
    }
    disconnectedCallback() {
      super.disconnectedCallback();
      this.screenQuery.unsubscribe(this);
    }
    _renderLayoutStrategy(deviceLayoutStrategy) {
      return f1.strategy(deviceLayoutStrategy, this.screenDevice);
    }
    isScreenDeviceMobileOrTablet() {
      return "tablet" === this.screenDevice || "mobile" === this.screenDevice;
    }
  }
  return HIP.factory.mixin(BehaviorScreenQuery2);
}
export const BehaviorScreenQuery = dedupingMixin(BaseBehaviorScreenQuery);
