
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};
import { LitElement, css, html } from '../../../hip/library/lit-element/lit-element.js';
import { queryAssignedNodes } from '../../../hip/library/lit-element/decorators.js';
import { HIP, AsLitHIC, BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import f1 from '../../../pip/library/pi-f1/pi-f1.js';
export const styles = css`
  :host {
    display: grid;
    text-align: center;
  }

  #navigation {
    margin-bottom: var(--hi-px-10);
  }

  #navigation ::slotted(*) {
    display: flex;
    gap: var(--hi-px-10);
    flex-wrap: wrap;
    justify-content: center;
  }

  [is-empty-slot] {
    display: none !important;
  }
`;
export class ViewFooterElement extends BehaviorElement(AsLitHIC(LitElement)) {
  constructor() {
    super(...arguments);
    this.__isEmpty = {
      description: true,
      navigation: true
    };
  }
  static get is() {
    return "yi-view-footer";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  static get properties() {
    return {
      __isEmpty: {
        type: Object
      }
    };
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "contentinfo");
  }
  __onSlotChanged(e, part) {
    if (e.currentTarget.name === part) {
      this.__isEmpty[part] = this[`__${part}Slot`].length <= 0;
      this.requestUpdate("__isEmpty");
    }
  }
  render() {
    return html`
      <div id="navigation" ?is-empty-slot=${this.__isEmpty["navigation"]}>
        <slot name="navigation" @slotchange=${(e) => this.__onSlotChanged(e, "navigation")}></slot>
      </div>
      <div id="description" ?is-empty-slot=${this.__isEmpty["description"]}>
        <slot name="description" @slotchange=${(e) => this.__onSlotChanged(e, "description")}></slot>
      </div>
    `;
  }
  updated(props) {
    super.updated(props);
    const children = [...this.children];
    f1.each(
      (activeSlot) => {
        this.__isEmpty[activeSlot] = false;
      },
      children.map((e) => e.slot)
    );
  }
}
__decorateClass([
  queryAssignedNodes({ slot: "navigation" })
], ViewFooterElement.prototype, "__navigationSlot", 2);
__decorateClass([
  queryAssignedNodes({ slot: "description" })
], ViewFooterElement.prototype, "__descriptionSlot", 2);
export default HIP.factory.element(ViewFooterElement);
