
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __decorateClass = (decorators, target, key, kind) => {
  var result = kind > 1 ? void 0 : kind ? __getOwnPropDesc(target, key) : target;
  for (var i = decorators.length - 1, decorator; i >= 0; i--)
    if (decorator = decorators[i])
      result = (kind ? decorator(target, key, result) : decorator(result)) || result;
  if (kind && result)
    __defProp(target, key, result);
  return result;
};
import { LitElement, css, html } from '../../../hip/library/lit-element/lit-element.js';
import { queryAssignedNodes } from '../../../hip/library/lit-element/decorators.js';
import { stylesTheme } from '../../../eip/element/hi-component/hi-component-theme.js';
import { AsLitHIC, HIP, BehaviorElement } from '../../../eip/element/hi-component/hi-component.js';
export const styles = css`
  :host {
    height: 100%;
    width: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    text-align: center;
  }

  #animation {
    max-height: 20rem;
    max-width: 20rem;
    min-height: 15rem;
    min-width: 15rem;
    height: 50%;
    width: 50%;
  }

  #icon {
    font-size: 8em;
  }

  #description {
    font-size: var(--hi-font-size--large);
    line-height: var(--hi-font-lh--large);
    margin-bottom: var(--hi-spacing--medium);
    color: var(--hi-clr--gray-8);
  }

  [has-slot-elements] {
    display: block;
  }

  ::slotted([slot='controls']) {
    display: flex;
    gap: var(--hi-px-6);
    align-items: center;
  }
`;
export class ViewStateElement extends BehaviorElement(AsLitHIC(LitElement)) {
  constructor() {
    super(...arguments);
    this.kind = "icon";
    this.animation = "loading";
    this.icon = "stop";
    this.title = "";
    this.description = "";
    this.__hasControls = false;
  }
  static get is() {
    return "yi-view-state";
  }
  static get styles() {
    return [stylesTheme, styles];
  }
  static get properties() {
    return {
      kind: {
        type: String
      },
      animation: {
        type: String
      },
      icon: {
        type: String
      },
      title: {
        type: String
      },
      description: {
        type: String
      }
    };
  }
  render() {
    return html`
      ${this.kind === "animation" ? html`<hi-lottie id="animation" src=${this.animation}></hi-lottie>` : html`<hi-icon id="icon" type="material" kind=${this.icon} theme="gray"></hi-icon>`}
      <h1 id="title">${this.title}</h1>
      <p id="description">${this.description}</p>
      <div id="controls" ?has-slot-elements=${this.__hasControls}>
        <slot name="controls" @slotchange="${this.__controls__onSlotChanged}"></slot>
      </div>
    `;
  }
  __controls__onSlotChanged() {
    this.__hasControls = this.__controls.length > 0;
  }
}
__decorateClass([
  queryAssignedNodes({ slot: "controls" })
], ViewStateElement.prototype, "__controls", 2);
export default HIP.factory.element(ViewStateElement);
