const {
  html,
  nothing,
  directives: { repeat }
} = HIP.extern.lit;
import { emptyFolderSvg } from '../images/emptyFolderSvg.js';
export const type = 'repeater';
export const id = 'appt_summary__list';
export const template = (hilType) => {
  return (itemFn) => {
    if (!itemFn) {
      return nothing;
    }
    return (list) => {
      const type = {
        fields: {}
      };

      const itemTemplate = {
        id: 'list-template-item',
        render() {
          return itemFn;
        }
      };

      const hiddenSettings = {
        hidden: {
          global_search: true,
          pagination_row_size: true
        }
      };

      return html`
        <p class="text-sz-m clr-gray_90-txt mbl">Filter by category to find specific appointment summaries.</p>
        ${list.length > 0
          ? html`
              <vi-list
                class="pos-relative z-1"
                mode="item"
                .template=${itemTemplate}
                .input=${list}
                .type=${type}
                .settings=${hiddenSettings}
                disallow-header
              ></vi-list>
            `
          : html`<div class="text-center">
              <div class="min-w-120 max-w-240 maa width-50">${emptyFolderSvg}</div>
              <p class="text-sz-l">No appointment summaries to view.</p>
            </div> `}
        <div l-kind l-width-fixed l-align="center" class="pam">
          <span class="mrm">
            <hi-icon kind="info_circle_filled" theme="gray"></hi-icon>
          </span>
          <p class="text-sz-m clr-gray_70-txt">
            These docs have been shared by your school’s staff. You will see docs that were created after your school
            enabled this feature and that you have permission to see.
          </p>
        </div>
      `;
    };
  };
};
