const {
  html,
  nothing,
  directives: { unsafeHTML, repeat }
} = HIP.extern.lit;

import { ReportsServant } from '../servants/reports_servant.js';
export const type = 'template';
export const id = 'notes_detail';
export const template = (builderEl) => {
  const isMobile = document.getElementsByTagName('html')[0].classList.contains('view-mobile');

  return () => (list) => {
    const o = tt.first(list);
    const getInitial = ReportsServant.getInitial;
    const toggleStar = ReportsServant.toggleStar;
    const openLink = ReportsServant.openLink;
    const processReportBody = ReportsServant.processReportBody;
    ReportsServant.markReportAsRead(o.status);

    const favIcon = o.status === 'flagged' ? 'star_filled' : 'star';

    return html`
        <header l-kind="hort" l-width-fixed l-align="center">
          <div class="mrm">
            <hi-avatar
              initials="${getInitial(o.from_name)}"</hi-avatar>
          </div>
          <div l-size="grow">
            <p class="text-sz-l text-normal">From: ${o.from_name}</p>
            <p class="clr-gray_80-txt">${moment(o.created_at).format('ll')}</p>
          </div>
          <div class="mrm">
            <hi-link href="#" @trigger-ended="${toggleStar(o.status)}">
              <hi-icon id="report_status" kind="${favIcon}" theme="orange"></hi-icon>
            </hi-link>
          </div>
  
        </header>
        <section class="pam"
          l-kind="vert">
          <p class="text-sz-l mtm">${unsafeHTML(processReportBody(o.body))}</p>
          <br/>
          <p class="text-sz-l mtm mbsx text-normal">Note Reasons:</p>
          <p class="text-sz-l">${o.note_reasons.length > 0 ? o.note_reasons.join(', ') : `No Note Reason`}</p>
  
          ${
            o.location != ''
              ? html`<p class="text-sz-l mtm mbsx text-normal">Visit URL:</p>
                  <hi-link href="#" @trigger-ended="${openLink(o.location, false, isMobile)}">
                    <hi-icon kind="link" mode="presentation"></hi-icon>
                    <p class="text-sz-l">${o.location}</p>
                  </hi-link>`
              : nothing
          }
  
          ${o.attachments.length > 0 ? html`<p class="text-sz-l mtm mbsx text-normal">Attachment(s):</p>` : nothing} 
          <ul data-tap-disabled="true" kind="no-dot">${tt.map((l) => {
            const fileName = l.name != '' ? l.name : l.uri.slice(l.uri.lastIndexOf('/') + 1);
            return html` <li class="display-inline-block mbm">
              <hi-link href="#" @trigger-ended="${openLink(l.uri, true, isMobile)}">
                <hi-icon kind="paperclip" mode="presentation"></hi-icon>
                <span>${fileName}</span>
              </hi-link>
            </li>`;
          }, o.attachments)}</ul>
  
        </section>
      `;
  };
};
