const {
  html,
  nothing,
  directives: { unsafeHTML, repeat }
} = HIP.extern.lit;

export const type = 'template';
export const id = 'notes_item';
export const template = (recordType, typeMap, builderEl) => {
  return () => (o) => {
    const goToDetails = `#/my/notes-details/?id=${o.id}`;
    return html`
      <div
        class="pam plsxx bdr-solid bts clr-gray_30-bdr pos-relative vi-list-content"
        l-kind="hort"
        l-width-fixed
        l-align="center"
      >
        ${o.status === 'unread'
          ? html` <div class="mrm">
              <hi-badge kind="indicator"></hi-badge>
            </div>`
          : o.status === 'flagged'
          ? html`
              <div class="mrsxx">
                <hi-icon kind="star_filled" theme="orange"></hi-icon>
              </div>
            `
          : html` <div class="mrmxx"></div> `}
        <div id="note-item-${o.id}" l-size="grow">
          <hi-link href="${goToDetails}">
            <p class="text-sz-lx ${o.status === 'unread' ? 'text-normal' : ''}">${o.from_name}</p>
          </hi-link>
          <span class="mrm mtsxx pos-absolute pin-top pin-right text-sz-s clr-gray_80-txt">
            ${moment(o.created_at).format('ll')}</span
          >
          <p class="clr-gray_90-txt">
            ${o.note_reasons.length > 0 ? o.note_reasons[0] : html`No Note Reason`}
            ${o.note_reasons.length > 1 ? html` and ${o.note_reasons.length - 1} more` : nothing}
          </p>
          ${o.attachments.length > 0
            ? html`<p>
                <hi-icon kind="paperclip" mode="presentation" size="small"></hi-icon
                ><span class="clr-gray_70-txt text-sz-s">${o.attachments.length} attachment(s)</span>
              </p>`
            : nothing}
        </div>
        <div l-align="center">
          <hi-link href="${goToDetails}" aria-labelledby="note-item-${o.id}">
            <hi-icon kind="chevron_right" size="large" aria-label="View Details"></hi-icon>
          </hi-link>
        </div>
      </div>
    `;
  };
};
