const {
  html,
  nothing,
  directives: { unsafeHTML, repeat }
} = HIP.extern.lit;

export const type = 'template';
export const id = 'report_item';
export const template = () => {
  return () => (o) => {
    const IconOptions = {
      APPOINTMENT_SUMMARIES: 'folder_shared',
      NOTES: 'reminder',
      PROGRESS_REPORTS: 'fact_check',
      SELF_ALERTS: 'waving_hand',
      default: 'description'
    };
    const icon = IconOptions[o.nk] || IconOptions['default'];

    const UriOptions = {
      APPOINTMENT_SUMMARIES: '#/my/appointment-summary',
      NOTES: '#/my/notes',
      PROGRESS_REPORTS: '#/my/progress-report',
      SELF_ALERTS: '#/my/self-alerts',
      default: '#'
    };
    const uri = UriOptions[o.nk] || UriOptions['default'];

    return html`
      <div class="pam text text-sz-m bdr-solid bts clr-gray_40-bdr" l-kind="hort" l-width-fixed l-align="center">
        <div>
          <hi-icon mode="presentation" size="large-xx" kind="${icon}" class="mrm"></hi-icon>
        </div>
        <div class="reports_title" l-size="grow" l-kind="hort" l-width-fixed l-align="center">
          <div l-size="grow">
            <div>
              <hi-link href="${uri}">
                <p class="text-sz-l text-normal">
                  ${o.nk === 'SELF_ALERTS'
                    ? localStorage.getItem('eab.navigate.self_alerts_title') === 'undefined' ||
                      !localStorage.getItem('eab.navigate.self_alerts_title')
                      ? 'Hand Raise'
                      : JSON.parse(localStorage.getItem('eab.navigate.self_alerts_title'))
                    : o.name}
                </p>
              </hi-link>
            </div>
          </div>
          <div>
            <hi-link
              href="${uri}"
              aria-label="Redirect to ${o.nk === 'SELF_ALERTS'
                ? localStorage.getItem('eab.navigate.self_alerts_title') === 'undefined' ||
                  !localStorage.getItem('eab.navigate.self_alerts_title')
                  ? 'Hand Raise'
                  : JSON.parse(localStorage.getItem('eab.navigate.self_alerts_title'))
                : o.name}"
            >
              <hi-icon kind="chevron_right" size="large"></hi-icon>
            </hi-link>
          </div>
        </div>
      </div>
    `;
  };
};
