const {
  html,
  nothing,
  directives: { repeat }
} = HIP.extern.lit;
import { emptyFolderSvg } from '../images/emptyFolderSvg.js';
export const type = 'repeater';
export const id = 'report_item_repeater';
export const template = (hilType) => {
  return (itemFn) => {
    if (!itemFn) {
      return nothing;
    }
    if (
      localStorage.getItem('eab.navigate.self_alerts_title') === undefined ||
      !localStorage.getItem('eab.navigate.self_alerts_title')
    ) {
      localStorage.setItem('eab.navigate.self_alerts_title', JSON.stringify('Hand Raise'));
    }
    if (
      localStorage.getItem('eab.navigate.alert_name') === undefined ||
      !localStorage.getItem('eab.navigate.alert_name')
    ) {
      localStorage.setItem('eab.navigate.alert_name', JSON.stringify('Feedback'));
    }

    return (list) => {
      const active_list = tt.filter((obj) => obj.is_active, list);

      return html`
        <p class="text-sz-m clr-gray_90-txt mbl">The following docs were sent from staff members at your school.</p>
        ${active_list.length > 0
          ? html`
              <ul kind="no-dot" class="bbs bdr-solid clr-gray_30-bdr">
                ${repeat(active_list, (o, index) => html`${itemFn(o, index)}`)}
              </ul>
            `
          : html`<div class="text-center">
              <div class="min-w-120 max-w-240 maa width-50">${emptyFolderSvg}</div>
              <p class="text-sz-l">No reports to view.</p>
            </div> `}
      `;
    };
  };
};
