const {
  html,
  nothing,
  directives: { repeat, unsafeHTML }
} = HIP.extern.lit;
import { emptyFolderSvg } from '../images/emptyFolderSvg.js';
export const type = 'repeater';
export const id = 'self_alerts_item_repeater';
export const template = (hilType) => {
  return (itemFn) => {
    if (!itemFn) {
      return nothing;
    }
    return (list) => {
      const type = {
        fields: {}
      };

      const itemTemplate = {
        id: 'list-template-item',
        render() {
          return itemFn;
        }
      };

      const hiddenSettings = {
        hidden: {
          global_search: true,
          pagination_row_size: true
        }
      };

      const selfAlertTextData = localStorage.getItem('eab.navigate.self_alert_intro_text');
      const defaultText =
        'Below are your previous submissions. Your school will review your submissions and contact you to follow-up.';

      const selfAlertIntroText = selfAlertTextData ? JSON.parse(selfAlertTextData) : defaultText;

      return html`
        ${localStorage.getItem('eab.navigate.self_alert_create')
          ? JSON.parse(localStorage.getItem('eab.navigate.self_alert_create'))
            ? html` <hi-button
                @trigger-ended="${() => (document.querySelector('#self-alert-dialog').opened = true)}"
                aesthetic="primary"
                class="mb-8"
                >Create a
                ${localStorage.getItem('eab.navigate.self_alerts_title')
                  ? JSON.parse(localStorage.getItem('eab.navigate.self_alerts_title'))
                  : 'Hand Raise'}</hi-button
              >`
            : nothing
          : nothing}
        ${html`<p class="text-sz-l pbm">${unsafeHTML(selfAlertIntroText)}</p>`}
        ${list.length > 0
          ? html`
              <vi-list
                class="pos-relative z-1"
                mode="item"
                .template=${itemTemplate}
                .input=${list}
                .type=${type}
                .settings=${hiddenSettings}
                disallow-header
              ></vi-list>
            `
          : html`<div class="text-center">
              <div class="min-w-120 max-w-240 maa width-50">${emptyFolderSvg}</div>
              <p class="text-sz-l">
                No
                ${localStorage.getItem('eab.navigate.self_alerts_title')
                  ? JSON.parse(localStorage.getItem('eab.navigate.self_alerts_title'))
                  : 'Hand Raise'}
                to view.
              </p>
            </div> `}
      `;
    };
  };
};
