HIL.dsl.plugin.register({
  id: 'cancel_appointment_data',
  pointCut: {
    prePostCompile: (script) => {
      const refScript = script;
      script.user_space = {
        ...(script.user_space || {}),
        initial_data: [false],
        initialize: (o) => {
          const def = script;

          let return_object = HIP.db.gid.queryOne('read_upcoming_appointment', def.namespace).invoke() || [];
          let appt_id;
          const searchParams = window.location.hash ? `?${window.location.hash.split('?')[1]}` : window.location.search;
          const formDataFromUrlParams = new URLSearchParams(searchParams);
          if (formDataFromUrlParams.has('id')) {
            appt_id = formDataFromUrlParams.get('id');
          }

          if (return_object.length === 0) {
            Promise.resolve(
              HIP.db.gid
                .queryOne('get_all_appointments', def.namespace)
                .invoke()
                .then((e) => {
                  let cancel_reason_params = HIP.db.gid.queryOne('cancel_reasons_params', def.namespace).invoke();
                  let is_cancelled;
                  if (
                    e &&
                    e.user &&
                    e.user.upcoming_appointments.find((e) => e.instance_id == cancel_reason_params.calendar_instance_id)
                  ) {
                    is_cancelled =
                      e.user.upcoming_appointments.filter(
                        (e) => e.instance_id == cancel_reason_params.calendar_instance_id
                      )[0].status === 'cancelled';
                  } else if (
                    e &&
                    e.user &&
                    e.user.recent_appointments.find((e) => e.instance_id == cancel_reason_params.calendar_instance_id)
                  ) {
                    is_cancelled =
                      e.user.recent_appointments.filter(
                        (e) => e.instance_id == cancel_reason_params.calendar_instance_id
                      )[0].status === 'cancelled';
                  }

                  if (is_cancelled) {
                    return;
                  } else if (cancel_reason_params.calendar_instance_id) {
                    // SGD mobile and STC
                    if (!e) {
                      // only SGD mobile enters here
                      let selected_appointment = HIP.db.gid.queryOne('all_appointments', def.namespace).invoke();
                      if (selected_appointment.status === 'cancelled') {
                        return;
                      }
                    }
                    HIP.db.gid.queryOne('get_cancel_reasons', def.namespace).invoke(cancel_reason_params);
                  } else {
                    // SGD desktop
                    cancel_reason_params = {
                      calendar_instance_id: appt_id
                    };
                    if (
                      e.user.upcoming_appointments.find(
                        (e) => e.instance_id == cancel_reason_params.calendar_instance_id
                      )
                    ) {
                      is_cancelled =
                        e.user.upcoming_appointments.filter(
                          (e) => e.instance_id == cancel_reason_params.calendar_instance_id
                        )[0].status === 'cancelled';
                    } else if (
                      e.user.recent_appointments.find((e) => e.instance_id == cancel_reason_params.calendar_instance_id)
                    ) {
                      is_cancelled =
                        e.user.recent_appointments.filter(
                          (e) => e.instance_id == cancel_reason_params.calendar_instance_id
                        )[0].status === 'cancelled';
                    }

                    if (is_cancelled || is_cancelled == undefined) {
                      return;
                    }

                    HIP.db.gid.queryOne('get_cancel_reasons', def.namespace).invoke(cancel_reason_params);
                  }
                })
            );
          } else {
            let cancel_reason_params = HIP.db.gid.queryOne('cancel_reasons_params', def.namespace).invoke();
            HIP.db.gid.queryOne('get_cancel_reasons', def.namespace).invoke(cancel_reason_params);
          }

          return return_object;
        }
      };

      return script;
    }
  }
});
