HIL.dsl.plugin.register({
  id: 'map_appointment_data',
  pointCut: {
    prePostCompile: (script) => {
      const refScript = script;
      script.user_space = {
        ...(script.user_space || {}),
        map_appointment_data: (o) => {
          const locations = HIP.db.gid.queryOne('locations', refScript.namespace).output || [];
          const staff = HIP.db.gid.queryOne('staff', refScript.namespace).output || [];
          const care_units = HIP.db.gid.queryOne('care_units', refScript.namespace).output || [];
          const services = HIP.db.gid.queryOne('services', refScript.namespace).output || [];

          o.location = locations.find((lc) => lc.id == o.location_id) || {};
          o.service = services.find((srv) => srv.id == o.service_id) || {};
          o.careUnit = care_units.find((cu) => cu.id == o.care_unit_id) || {};
          // o.location = locations.find((lc) => lc.id == o.location_id) || {};
          o.staffs = o.staff_times.map((st) => staff.find((s) => s.id == st.staff_id));
          // TODO: Use Moment or DayJS in Future
          const selectedTime = new Date();
          const withInDay = (time) => {
            const timeDate = new Date(time);
            return new Intl.DateTimeFormat().format(selectedTime) == new Intl.DateTimeFormat().format(timeDate);
          };
          const allTimes = o.staff_times.reduce((tms, stf) => tms.concat(stf.times), []);
          o.times = Array.from(new Set(allTimes)).slice(0, 100);

          return o;
        }
      };

      return script;
    }
  }
});
