HIL.dsl.plugin.register({
  id: 'set_initial_value',
  pointCut: {
    prePostCompile: (script) => {
      const searchParams = window.location.hash ? `?${window.location.hash.split('?')[1]}` : window.location.search;
      const formDataFromUrlParams = new URLSearchParams(searchParams);

      const def = script.type.record_type;
      for (const key in def.properties) {
        if (formDataFromUrlParams.has(key)) {
          def.properties[key].initial_value = [formDataFromUrlParams.get(key)];
        }
      }

      return script;
    }
  }
});
