const {
  html,
  nothing,
  directives: { repeat }
} = HIP.extern.lit;

const avatarsTemplate = (staffs, locationCallback) => {
  return html`<div l-kind l-width-fixed l-align="center" class="ptm">
    <hi-link href="#" @trigger-ended="${locationCallback}">
      ${repeat(staffs, (sta) => {
        const intials = (sta.first_name || '').substring(0, 2);
        return html`<hi-avatar size="small" layout-inline initials="${intials}"></hi-avatar>`;
      })}
    </hi-link>
    <span class="text-sz-m mlm">${staffs.length} Staffs</span>
  </div>`;
};

const dropinTemplate = (appointment) => {
  return appointment.dropin_available
    ? html`<hi-badge aesthetic="light" theme="cyan" size="small">Drop-in time</hi-badge>`
    : ``;
};

const timesTemplate = (appointment, staffTimes, duration, selectionCallback) => {
  return html`${repeat(staffTimes, (time, index) => {
    const fromTime = new Date(time);
    const fromTimeUnix = fromTime.getTime();
    const toTime = new Date().setTime(fromTimeUnix + duration * 60000);
    // TODO: Use Moment or DayJS in Future
    const timeFormatter = new Intl.DateTimeFormat('default', {
      hour12: true,
      hour: 'numeric',
      minute: 'numeric'
    });
    const fromTimeFormatted = timeFormatter.format(fromTime);
    const toTimeFormatted = timeFormatter.format(toTime);
    return html`<hi-button
      size="small"
      @trigger-ended="${selectionCallback}"
      aesthetic="secondary"
      class="bdr-round-full mrsx mtsx"
      value="${time}"
      >${fromTimeFormatted} - ${toTimeFormatted}</hi-button
    >`;
  })}`;
};
export const result_template = (appointment, locationCallback, selectionCallback) => html`
  <li class="clr-white-bkg pal bas bdr-solid clr-gray_20-bdr mbl">
    <div class="mbmsx">
      <hi-link href="#" @trigger-ended="${locationCallback}"
        ><p class="text-sz-lx">${appointment.location.name}</p></hi-link
      >
    </div>
    ${dropinTemplate(appointment)} ${avatarsTemplate(appointment.staffs, locationCallback)}
    <div class="ptm">${timesTemplate(appointment, appointment.times, appointment.duration, selectionCallback)}</div>
  </li>
`;
