const {
  html,
  nothing,
  directives: { repeat }
} = HIP.extern.lit;
export const id = 'appointment_campaign_list__item';
export const type = 'template';
export const template = (hilType) => {
  // the HIL template where we can pre-calculate information too
  const typeMap = tt.filter((o) => !o.hidden, hilType);
  const formatDataByFormatType = (data) => {
    return tt.map((value, key) => {
      const fieldType = typeMap[key];
      return fieldType && fieldType.format_type
        ? HIP.fn.format(value, fieldType.format_type, tt.get('$configure.format_type', fieldType))
        : value;
    }, data);
  };
  return () => {
    // ignored for templates because we do not get sub-item templates
    return (o, index) => {
      // called for each item and should return a lit-html template
      const formattedData = formatDataByFormatType(o);
      let [date, ...time] = formattedData.end_time.split(' ');

      const detailsLink = `#/my/appointment-campaign-details?id=${o.id}`;

      return html`<li class="pam bdr-solid bbs clr-gray_40-bdr" l-kind="hort" l-align="center">
        <div l-size="11">
          <hi-link href="${detailsLink}">
            <p class="text-sz-lx pbsx">Appointment Invitation for ${o.services[0].name}</p>
          </hi-link>
          <p class="clr-gray_80-txt">Please respond by ${date}</p>
        </div>
        <div l-size="1" class="text-right">
          <hi-icon kind="chevron_right" theme="gray" size="large-x"></hi-icon>
        </div>
      </li> `;
    };
  };
};
