const {
  html,
  nothing,
  directives: { unsafeHTML }
} = HIP.extern.lit;
export const id = 'appointment_cancel__details';
export const type = 'template';
export const template = (hilType, hilData, builderEl) => {
  return () => {
    return (o, index) => {
      const momentDate = new moment(o.start_time);
      let date = momentDate.format('MM/DD/YYYY');
      let time = momentDate.format('h:mm A');
      return html`
        ${o.length === 0
          ? html`<hi-alert theme="warning" class="mbm mrl mll" mode="presentation"
              ><p>This Appointment could not be found</p></hi-alert
            >`
          : o.instance_id
          ? nothing
          : html`<div class="mll"><hi-indicator></hi-indicator></div>`}
        ${o.status === 'cancelled'
          ? html`<hi-alert theme="warning" class="mbm mrl mll" mode="presentation"
              ><p>This Appointment has already been cancelled</p></hi-alert
            >`
          : ``}
        ${o.will_be_no_show && o.can_cancel
          ? html`<hi-alert theme="warning" class="mbm mrl mll" mode="presentation"
              ><p>This Appointment will be counted as a no show</p></hi-alert
            >`
          : ``}
        ${o.can_cancel === false && o.status !== 'cancelled'
          ? html`<hi-alert theme="warning" class="mbm mrl mll" mode="presentation"
              ><p>This Appointment cannot be cancelled</p></hi-alert
            >`
          : ``}
        <div class="mll">
          ${o.instance_id
            ? html`<p class="text-sz-lx pbsx">${o.name} with ${o.staff.map((s) => s.name).join(',')}</p>
                <p class="clr-gray_80-txt">${date} ${time}</p>`
            : nothing}
        </div>
      `;
    };
  };
};
