const {
  html,
  nothing,
  directives: { repeat }
} = HIP.extern.lit;
export const id = 'my-team-item';
export const type = 'template';
export const template = (hilType) => {
  // the HIL template where we can pre-calculate information too

  return () => {
    // ignored for templates because we do not get sub-item templates
    return (o, index) => {
      // called for each item and should return a lit-html template
      const apptLink = `#/my/appointment-new?staff_ids=${o.id}`;

      return html`<li class="pam bdr-solid bbs clr-gray_40-bdr" l-kind="hort" l-align="center">
        <div class="display-flex" l-size="11">
          <div>
            <hi-avatar
              class="non-interactive"
              initials="${o.first_name[0] + o.last_name[0]}"
              image="${o.picture}"
            ></hi-avatar>
          </div>
          <div class="mll">
            <hi-link href="${apptLink}">
              <p class="text-sz-lx pbsx">${o.first_name} ${o.last_name}${o.formatted_pronouns}</p>
            </hi-link>
            <p>${o.relationships.join(', ')}</p>
          </div>
        </div>
        <div l-size="1" class="text-right">
          <hi-icon kind="chevron_right" theme="gray-dark" size="large-x"></hi-icon>
        </div>
      </li> `;
    };
  };
};
