const {
  html,
  nothing,
  directives: { repeat }
} = HIP.extern.lit;
export const id = 'my-team-repeater';
export const type = 'repeater';
export const template = (hilType) => {
  // the HIL template where we can pre-calculate information too
  return (itemFn) => {
    // the item template
    // if it was not delivered, then we should stop
    if (!itemFn) {
      return nothing;
    }
    return (list) => {
      // called once for the whole collection and invokes the item-fn
      if (list.length > 0) {
        if (list[0].loading) {
          return html`<div class="text-center pamx">
            <div l-kind l-width-fixed l-align="center" l-justify="center" class="min-h-120">
              <hi-indicator></hi-indicator>
            </div>
            <p class="text-sz-l">Loading your Success Team</p>
          </div>`;
        }

        return html`<ul kind="no-dot">
          ${repeat(list, (o, index) => html`${itemFn(o, index)}`)}
        </ul>`;
      } else {
        return html`
          <div class="text-center">
            <p class="text-sz-l">
              Sorry, there is no one available within your Success Team. Please go through the normal scheduling
              workflow to find availability.
            </p>
          </div>
        `;
      }
    };
  };
};
