const {
  html,
  nothing,
  directives: { repeat }
} = HIP.extern.lit;
export const id = 'template-appointment-results-repeater';
export const type = 'repeater';
export const template = (hilType, hilData, builderEl) => {
  // the HIL template where we can pre-calculate information too
  return (itemFn) => {
    // the item template
    // if it was not delivered, then we should stop
    if (!itemFn) {
      return html``;
    }
    return (list) => {
      const takeMeToRequest = () => {
        const requestApptAction = HIP.db.gid.queryOne('request_alternate', builderEl.ns);
        requestApptAction.invoke({});
      };
      const requestTemplate = html`
        <hi-tile>
          <hi-link href="#" @trigger-ended="${takeMeToRequest}"
            ><span class="text-sz-lx">Request Alternate Appointment Time</span></hi-link
          >
          <p>
            If you cannot find a date or time that work for your schedule, please click here to request an alternate
            appointment time.
          </p>
        </hi-tile>
      `;
      // called once for the whole collection and invokes the item-fn
      if (list.length > 0) {
        return html`<ul kind="no-dot">
            ${repeat(list, (o, index) => html`${itemFn(o, index)}`)}
          </ul>
          ${requestTemplate}`;
      } else {
        return html`
          <div>
            <p class="text-sz-l">No Results</p>
          </div>
          ${requestTemplate}
        `;
      }
    };
  };
};
