const { html, nothing } = HIP.extern.lit;
export const id = 'template-new-appointment-results';
export const type = 'template';
export const template = (hilType) => {
  return () => {
    return (o) => {
      const resultsObj = [...o.locations, ...o.care_units];
      return html`
        <style>
          dt {
            font-weight: var(--hi-font--weight-bold);
            font-size: var(--hi-font-size--medium-xx);
            padding-bottom: var(--hi-size--small-xx);
          }
          dl, dd {
            font-size: var(--hi-font-size--normal);
          }
          dl > div {
            border-bottom: var(--hi-size--small) solid var(--hi-color--gray-40);
            padding-top: var(--hi-size--medium);
            padding-bottom: var(--hi-size--medium);
          }
        </style>
        <hi-alert mode="presentation">
          To ensure accurate availability, please add more preferences using filters.
        </hi-alert>
        <hi-repeat input="${JSON.stringify(resultsObj)}">
          <template>
            <hi-tile>
              <dl l-kind="hort" l-justify="center">
                <div l-size="12" l-sml-size="6">
                  <dt>[[ item.name ]]<dt>
                </div>
              </dl>
            </hi-tile>
          </template>
        </hi-repeat>
      `;
    };
  };
};
